include(../../defines.pri)

TEMPLATE  = lib
TARGET    = aethera
CONFIG   += dll

win32 {
  DEFINES += AETHERA_EXPORTS
}

unix {
  VERSION   = 1.0.1
}

mac_osx {
QMAKE_LFLAGS_SONAME  = -Wl,-install_name,@executable_path/../Frameworks/
QMAKE_LFLAGS += -r
}

INCLUDEPATH += .
INCLUDEPATH += ../..
DEPENDPATH  += ../..
INCLUDEPATH += ../
DEPENDPATH  += ../
INCLUDEPATH += ../clientskel
DEPENDPATH  += ../clientskel
INCLUDEPATH += ../../src
DEPENDPATH  += ../../src
INCLUDEPATH += ../kommanager
INCLUDEPATH += ../tkwidgets
DEPENDPATH  += ../tkwidgets

FORMS +=\
  acceptcertificatebase.ui\
  passwddialogbase.ui\
  settingsdialogbase.ui

SOURCES  +=\

HEADERS   =\
  accounts.h\
  addressclass.h\
  addresslistclass.h\
  any.h\
  appstatus.h\
  atextbrowser.h\
  attributefactories.h\
  certificatesmanager.h\
  charsets.h\
  clipboard.h\
  commands.h\
  commframe.h\
  conversions.h\
  countriesclass.h\
  datahandler.h\
  dateclass.h\
  ebutton.h\
  editfield.h\
  elineedit.h\
  elistview.h\
  elistviewitem.h\
  filedownloader.h\
  folderchooserdialog.h\
  folderlistwidget.h\
  fontcolorbutton.h\
  groupobj.h\
  htmlprocessing.h\
  imaputf7convertor.h\
  kolabsharedfolder.h\
  komaetheraplugin.h\
  komaetheratools.h\
  komcontainerwidget.h\
  kommaintreeitem.h\
  komrmiservice.h\
  korecomponents.h\
  kurllabel.h\
  mail.h\
  magellan.h\
  md5.h\
  metaformatcontrol.h\
  mimecodec.h\
  names.h\
  notificationpopup.h\
  passwddialog.h\
  qcolorbutton.h\
  qfontchooser.h\
  queryprocessor.h\
  rmicalldata.h\
  settingsdialog.h\
  settingslistview.h\
  settingslistviewitem.h\
  sortingwidget.h\
  sortingwidgetitem.h\
  statuscodes.h\
  textfitter.h\
  texthtml.h\
  textprocessor.h\
  toolbox.h\
  vattribute.h\
  vblockobjectattribute.h\
  vcacheobject.h\
  vdragobject.h\
  vfolder.h\
  vfolderattribute.h\
  vobject.h\
  vobjectfactory.h\
  vfsmimetype.h\
  vfsobjectdialog.h\
  vfsobjecticonview.h\
  vfsobjectlist.h\
  vfsobjectlistglobals.h\
  vfsobjectlistview.h\
  vfsobjectpreview.h\
  vfsview.h\
  vmailattribute.h\
  vpartattribute.h\
  vreference.h

SOURCES  +=\
  accounts.cpp\
  addressclass.cpp\
  addresslistclass.cpp\
  any.cpp\
  appstatus.cpp\
  atextbrowser.cpp\
  attributefactories.cpp\
  certificatesmanager.cpp\
  charsets.cpp\
  commframe.cpp\
  conversions.cpp\
  countriesclass.cpp\
  clipboard.cpp\
  datahandler.cpp\
  dateclass.cpp\
  ebutton.cpp\
  editfield.cpp\
  elineedit.cpp\
  elistview.cpp\
  elistviewitem.cpp\
  filedownloader.cpp\
  folderchooserdialog.cpp\
  folderlistwidget.cpp\
  fontcolorbutton.cpp\
  groupobj.cpp\
  htmlprocessing.cpp\
  imaputf7convertor.cpp\
  kolabsharedfolder.cpp\
  komaetheraplugin.cpp\
  komaetheratools.cpp\
  komcontainerwidget.cpp\
  kommaintreeitem.cpp\
  komrmiservice.cpp\
  kurllabel.cpp\
  mail.cpp\
  md5.c\
  metaformatcontrol.cpp\
  mimecodec.cpp\
  miscfunctions.cpp\
  names.cpp\
  notificationpopup.cpp\
  passwddialog.cpp\
  qcolorbutton.cpp \
  qfontchooser.cpp \
  queryprocessor.cpp\
  settingsdialog.cpp\
  settingslistview.cpp\
  settingslistviewitem.cpp\
  sortingwidget.cpp\
  sortingwidgetitem.cpp\
  statusinfo.cpp\
  textfitter.cpp\
  texthtml.cpp\
  textprocessor.cpp\
  toolbox.cpp\
  vattribute.cpp\
  vblockobjectattribute.cpp\
  vcacheobject.cpp\
  vdragobject.cpp\
  vfolder.cpp\
  vfolderattribute.cpp\
  vfsmimetype.cpp\
  vfsobjectdialog.cpp\
  vfsobjecticonview.cpp\
  vfsobjectlist.cpp\
  vfsobjectlistview.cpp\
  vfsobjectpreview.cpp\
  vfsview.cpp\
  vobject.cpp\
  vobjectfactory.cpp\
  vmailattribute.cpp\
  vpartattribute.cpp\
  vreference.cpp

TRANSLATIONS  = \
  aetheralib_ro.ts \
  aetheralib_fr.ts \
  aetheralib_de.ts \
  aetheralib_en.ts

win32 {
LIBS  += ../tino/tino.lib
LIBS  += libkore.lib tkcbase.lib tkcssl.lib
}

unix {
LIBS    += -L../tino -ltino
LIBS    += -L$$AETHERA_LIB -ltkcbase
LIBS    += -L/usr/local/lib -lkore 

aethera.path     = $$AETHERA_LIB/
aethera.files    = libaethera.so.1.0.1
aethera.extra = \
  cd $$AETHERA_LIB; \
  rm -f libaethera.so.1; \
  ln -s libaethera.so.1.0.1 libaethera.so.1; \
  rm -f libaethera.so; \
  ln -s libaethera.so.1.0.1 libaethera.so;
INSTALLS          += aethera

aetheraincludes.path    = $$AETHERA_INCLUDE/
aetheraincludes.files   = $$HEADERS
INSTALLS               += aetheraincludes
}
