/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/

#ifndef APPSTATUS_H
#define APPSTATUS_H

#include <qstatusbar.h>
#include <qapplication.h>

#include <defines.h>

class QString;

/**It has to give enough info to the user.
  *@author Eugen Constantinescu <eug@thekompany.com>
  */

class AETHERA_API AppStatus : public QStatusBar
{
  Q_OBJECT
  
  public:
  
    enum Level { Server=0, Client };
    enum Type { Text=0, Progress };
    enum Status { Good=0, Warning, Error, Waiting };
  
    AppStatus(QWidget * parent = 0, const char * name = 0);
    virtual ~AppStatus();
    
    static AppStatus * instance();
    
  public slots:
  
    virtual void message(const QString&);
    virtual void message(const QString&, int ms);
    virtual void clear();
    
    virtual void message(Level, Type, Status, const QString & text, int iStep=0, int iTotal=0);
  
  signals:
  
    void error(const QString&);
  
  private:
  
    static AppStatus * instance_;
    
    class Private;
    Private * d;
};

#endif
