//
// C++ Interface: evano
//
// Description: 
//
//
// Author: Eugen Constantinescu <eug@thekompany.com>
//
// Copyright: (C) 2005 theKompany.com
//
//

#ifndef EVANO_H
#define EVANO_H

class EVANOPrivate;

/**
EVeniment class for Aethera NOtifications.
It is used together with the notificator class from tkcbase.

@author Eugen Constantinescu
*/
class AETHERA_API EVANO
{
  public:
  
    EVANO();
    
    EVANO(const QString & parent, const QString & settingsGroup);

    virtual ~EVANO();
    
    virtual bool saveSettings();
    
    virtual bool loadSettings();
    
    virtual void setEnabled(bool);
    
    virtual bool enabled() const;

    virtual void setSoundEnabled(bool);
    
    virtual bool soundEnabled() const;

    virtual void setPopupEnabled(bool);
    
    virtual bool popupEnabled() const;

    virtual void setTrayEnabled(bool);
    
    virtual bool trayEnabled() const;

    virtual void setStatusEnabled(bool);
    
    virtual bool statusEnabled() const;
    
    virtual void setLogEnabled(bool);
    
    virtual bool logEnabled() const;
    
    virtual void setName(const QString &);
    
    virtual QString name() const;
    
    virtual void setDescription(const QString &);
    
    virtual QString description() const;
    
    virtual void setParent(const QString &);
    
    virtual QString parent() const;
    
    virtual void setGroup(const QString &);
    
    virtual QString group() const;
    
    virtual void setSoundPath(const QString &);
    
    virtual QString soundPath() const;
    
    virtual QString log() const;

  private:
  
    EVANOPrivate * d;
};

#endif
