/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
#ifndef KOMMAINTREEITEM_H
#define KOMMAINTREEITEM_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qlistview.h>
#include <qpixmap.h>
#include <qdict.h>

#include <komaetheratools.h>
#include <defines.h>

class AETHERA_API KomItemType
{
  public:
    KomItemType( int itemType, QString* itemText=NULL, QPixmap *itemIcon=NULL,
                 bool autoDeleteIcon=false, bool autoDeleteText=false );
    KomItemType( KomItemType& komItemType );

    virtual ~KomItemType( );

    void setItemType( int itemType ) { m_itemType = itemType; }
    virtual void setItemIcon( QPixmap *itemIcon );
    virtual void setItemText( QString *itemText );
    void setAutoDeleteIcon( bool autoDelete );
    void setAutoDeleteText( bool autoDelete );
    void setAutoDelete( bool autoDeleteIcon, bool autoDeleteText );

    int getItemType() { return m_itemType; }
    const QPixmap* getItemIcon( ) { return m_itemIcon; }
    const QString* getItemText( ) { return m_itemText; }


  protected:
    int m_itemType;
    QPixmap *m_itemIcon;
    QString *m_itemText;
    bool m_autoDeleteIcon, m_autoDeleteText;

};

class AETHERA_API KomItemTypeList : public QDict<KomItemType>
{
public:
  KomItemTypeList()
  {
    setAutoDelete( true );
  }
  virtual ~KomItemTypeList(){}

  const KomItemType* getItemOfType( const QString itemType );

};


class AETHERA_API KomTreeItem : public QListViewItem, public KomItemType
{
public:
  KomTreeItem( QListView * parent, KomItemType& treeItemType );
  KomTreeItem( KomTreeItem* parent, KomItemType& treeItemType )
    :QListViewItem( (QListViewItem*)parent ), KomItemType( treeItemType )
  {
  }
  virtual ~KomTreeItem(){}

  virtual void setItemIcon( QPixmap *itemIcon );
  virtual void setItemText( QString *itemText );

  virtual const QPixmap *pixmap( int column ) const;
  
  virtual QString text( int column ) const;

protected:

};


#endif


