/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
---------------------------------------------------------------------------------
  Date     : 15 August 2003
  Copyright: 2003 theKompany.com
  Author   : Eugen Constantinescu <eug@thekompany.com>
  Author   : Ghiciuc Ilie (ilie@eco-spaces.com.ro)
---------------------------------------------------------------------------------
*/

#ifndef KOM_RMI_SERVICE_H
#define KOM_RMI_SERVICE_H

//own includes
#include "komaetheraplugin.h"

//QT includes
#include "qdom.h"

#define AETHERA_RMI_SERVICE       "/Aethera/Services/RMI"
#define AETHERA_RMI_SERVICE_DESC  "RMI service for plugin: "

class AETHERA_API KomRMIService : public KomAetheraService
{
  public:
    KomRMIService();
    virtual ~KomRMIService(){}

    /*
      The QDomDocument representing the RMI call has to be formed like this
      
      <call>
        <name>getMessages</name>
        <parameters count="2">
          <parameter pos="1" type="QString"> Inbox </parameter>
          <parameter pos="2" type="int"> 3 </parameter>
        </parameters>
        <return>
          bool
        </return>
      </call>
      
      Call methods like this one at a time coz it doesn't handle multiple method elements.
      
      The return result will look like this
      
      <return>
        true
      </return>
    */    
    virtual QDomDocument callMethod( const QDomDocument& method )=0;
};


#endif

