/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/****************************************************************************
** Form implementation generated from reading ui file 'notificationpopup.ui'
**
** Created: mer avr 28 14:13:08 2004
**      by: The User Interface Compiler ($Id: notificationpopup.cpp,v 1.3 2004/10/28 16:19:24 eug Exp $)
**
*****************************************************************************/

/***************************************************************************
               notificationpopup.cpp - popup to notify of new mails
                             -------------------

  copyright : (C) by Atol C&D           <www.atolcd.com>

  authors :   Fabien Armand <f.armand@atolcd.com>

 ***************************************************************************/

#include "notificationpopup.h"

#include <qvariant.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qtimer.h>
#include <stdlib.h>
#include <qapplication.h>
#include <qpoint.h>
#include <qrect.h>

/*
 *  Constructs a NotificationPopup as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
NotificationPopup::NotificationPopup( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, Qt::WStyle_StaysOnTop)
{
    if ( !name )
	setName( "NotificationPopup" );
    setPaletteBackgroundColor( QColor( 255, 255, 255 ) );
    NotificationPopupLayout = new QGridLayout( this, 1, 1, 11, 6, "NotificationPopupLayout"); 
    NotificationPopupLayout->setResizeMode( QLayout::Fixed );

    NotificationPopupText = new QLabel( this, "NotificationPopupText" );
    NotificationPopupText->setPaletteForegroundColor( QColor( 0, 0, 0 ) );

    NotificationPopupLayout->addWidget( NotificationPopupText, 0, 0 );
    languageChange();
    resize( QSize(150,60));
    clearWState( WState_Polished );
    move(position());
    hideTimer=new QTimer(this);
    connect(hideTimer,SIGNAL(timeout()),SLOT(hide()));
    hideTimer->start(2000,TRUE);
}

/*
 *  Destroys the object and frees any allocated resources
 */
NotificationPopup::~NotificationPopup()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void NotificationPopup::languageChange()
{
    setCaption( tr( "New mail notification" ) );
    NotificationPopupText->setText( tr( "You have new message(s)" ) );
}

QPoint NotificationPopup::position()
{
  QRect geom = qApp->desktop()->availableGeometry(this);
	QPoint destination(geom.x() + geom.width(), geom.y() + geom.height()); // in which corner popup should appear

	if ( (destination.x() + this->width()) > (geom.x() + geom.width()) )
		destination.setX( geom.x() + geom.width() - this->width() );

	if ( destination.x() < 0 )
		destination.setX( 0 );

	if ( (destination.y() + this->height()) > (geom.y() + geom.height()) )
		destination.setY( geom.y() + geom.height() - this->height() );

	if ( destination.y() < 0 )
		destination.setY( 0 );

	return destination;
}

