/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with the tkwidgets library (or with
    modified versions of tkwidgets that use the same license as tkwidgets),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than tkwidgets.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use tkwidgets with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/***************************************************************************
  settingsdialog.h
  -  Container for settings widgets provided by plugins.
                             -------------------
    begin                : Tue Dec 18 15:06:07 GMT 2001
    copyright            : (C) 2001 by theKompany.com
    author               : Rik Hemsley <rik@kde.org>
 ***************************************************************************/

#ifndef SETTINGS_DIALOG_H
#define SETTINGS_DIALOG_H

//own includes
#include <defines.h>
#include "settingsdialogbase.h"

//Aethera plugins
#include <komaetheraplugin.h>

//QT includes
#include <qlistview.h>
#include <qptrlist.h>

/**
 * \class KomConfigPtrList
 * 
 * Class to hold the KomConfig services in a particular order... we need this to make them
 * apare in the same order every time coz we korelib will provide the services in a
 * somehow random order.
 */

class KomConfigPtrList : public QPtrList<KomConfigService>
{
  public:
    KomConfigPtrList();
    
  protected:
    virtual int compareItems( QPtrCollection::Item lhs, QPtrCollection::Item rhs );
  
}; 


/**
 * \class SettingsDialog
 * 
 * Container for settings widgets provided by plugins.
 */
class AETHERA_API SettingsDialog : public SettingsDialogBase
{
  Q_OBJECT

  public:

    SettingsDialog(QWidget * parent = 0, const char * name = 0);

    virtual ~SettingsDialog();
    
    virtual void languageChange();
    
    virtual void init();

  protected slots:

    void slotAboutToShow();


    void slotDefault();
    void slotApply();
    void slotCurrentChanged(QListViewItem*);
    void slotOkClicked();    
                         
  private:
    void loadServices();

    class Private;
    Private * d;

};

#endif
