/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
---------------------------------------------------------------------------------
  Date     : 22 August 2003
  Author   : Ghiciuc Ilie (ilie@eco-spaces.com.ro)
---------------------------------------------------------------------------------
*/

//own includes
#include "settingslistviewitem.h"
#include "settingslistview.h"
/*
----------------------------------------------------------------------------------------
SettinsListViewItem::Private class
----------------------------------------------------------------------------------------
*/

class SettingsListViewItem::Private
{
  public:
    Private( SettingsListViewItem* item );
    ~Private();
  
    SettingsListViewItem* parent;
    KomConfigService* configService;
    QWidget* serviceWidget;
};

SettingsListViewItem::Private::Private( SettingsListViewItem* item )
  : parent( item ),
    configService( 0L ),
    serviceWidget( 0L )
{
}


SettingsListViewItem::Private::~Private()
{
  if( configService )
  {
    delete configService;
    configService = 0L;
  }
}

/*
----------------------------------------------------------------------------------------
SettingsListViewItem class
----------------------------------------------------------------------------------------
*/


SettingsListViewItem::SettingsListViewItem( SettingsListView* parent )
  : QListViewItem( parent ),
    d( 0L )
{
  d = new Private( this );
}

SettingsListViewItem::SettingsListViewItem( KomConfigService* cfg, SettingsListView* parent)
  : QListViewItem( parent ),
    d( 0L )
{
  d = new Private( this );
  d->configService = cfg;
}


SettingsListViewItem::SettingsListViewItem( KomConfigService* cfg, SettingsListViewItem* parentItem)
  : QListViewItem( parentItem ),
    d( 0L )
{ 
  d = new Private( this );
  d->configService = cfg;
}


SettingsListViewItem::SettingsListViewItem( SettingsListViewItem* parentItem)
  : QListViewItem( parentItem ),
    d( 0L )
{
  d = new Private( this );
  d->configService = 0L;
}


SettingsListViewItem::~SettingsListViewItem()
{
  if( d )
  {
    delete d;
    d = 0L;
  }
}


KomConfigService* SettingsListViewItem::getConfigService()
{
  return d->configService;
}

void SettingsListViewItem::setConfigService( KomConfigService* s)
{
  d->configService = s;
}

QWidget* SettingsListViewItem::getConfigWidget()
{
  return d->serviceWidget;
}


void SettingsListViewItem::setConfigWidget( QWidget* widget )
{
  d->serviceWidget = widget;
}

SettingsListViewItem* SettingsListViewItem::findSettingsItem( const QString& text, int column, SettingsListViewItem* sli)
{
  if( sli==0L )
    return 0L;
  
  do
  {
    
    if( sli->text(column)==text )
    {
      return sli;
    }
    
    sli = static_cast<SettingsListViewItem*>(sli->nextSibling());
  }while( sli );
  
  return 0L;
}

