/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
#ifndef VFSMIMETYPE_H
#define VFSMIMETYPE_H

// known vfs mimetypes
#define VFS_MIMETYPE                        "vfs"
#define VFS_CONTACTS_MIMETYPE               "contacts"
#define VFS_MAILS_MIMETYPE                  "mail"
#define VFS_IMAP_MIMETYPE                   "imap"
#define VFS_PART_MIMETYPE                   "part"
#define VFS_NOTES_MIMETYPE                  "notes"
#define VFS_JABBER_MIMETYPE                 "jabber"
#define VFS_WHITEBOARD_MIMETYPE             "whiteboard"
#define VFS_CALENDAR_MIMETYPE               "datebook"
#define VFS_ATTRIBUTE_MIMETYPE              "vattribute"
#define VFS_MAILATTRIBUTE_MIMETYPE          "vmailattribute"
#define VFS_PARTATTRIBUTE_MIMETYPE          "vpartattribute"
#define VFS_FOLDERATTRIBUTE_MIMETYPE        "vfolderattribute"
#define VFS_BLOCKOBJECTATTRIBUTE_MIMETYPE   "vblockobjectattribute"
#define VFS_HOME_MIMETYPE                   "home"
#define VFS_PHONE_MIMETYPE                  "phone"
#define VFS_CRM_MIMETYPE                    "crm"
#define VFS_TEMPLATES_MIMETYPE              "templates"


// plugins root folders
#define VFS_CONTACTS_ROOT                   "Contacts"
#define VFS_GROUPS_ROOT                     "Groups"
#define VFS_MAIL_ROOT                       "Mail"
#define VFS_NOTES_ROOT                      "Notes"
#define VFS_WHITEBOARD_ROOT                 "Whiteboard"
#define VFS_JABBER_ROOT                     "Jabber"
#define VFS_CALENDAR_ROOT                   "Datebook"
#define VFS_TEMPLATES_ROOT                  "Templates"

#define MIME_UNKNOWN                        ""
#define MIME_MAIL                           "text/rfc822"
#define MIME_NOTES                          "application/x-notes"
#define MIME_CONTACTS                       "text/directory"
#define MIME_GROUPS                         "application/x-groups"
#define MIME_WHITEBOARD                     "image/jpeg"
#define MIME_JABBER                         "application/xml"
#define MIME_CALENDAR                       "text/calendar"
#define MIME_TEMPLATES                      "text/directory"

#include <qstring.h>

#include <defines.h>

class AETHERA_API VFSMimeType
{
  public:
    VFSMimeType();
    virtual ~VFSMimeType();
    
    static QString vfs2mime(const QString&);
};


#endif
