/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.

    ______________________________________________________________________________
    DATE        : 15 April 2003
    COPYRIGHT   : (C) 2003 by theKompany.com
    AUTHOR      : Eugen Constantinescu <eug@thekompany.com>
    AUTHOR      : Iulian Ghiciuc <ilie@eco-spaces.com.ro>
    BUGS        : there were some but not any more
    DESCRIPTION : an object of this class will be displayed in the VFSFileDialog
                  as a preview widget.
    ______________________________________________________________________________
*/

#ifndef VFS_OBJECT_PREVIEW_H
#define VFS_OBJECT_PREVIEW_H

//QT includes
#include <qwidget.h>

#include <defines.h>

class AETHERA_API VFSObjectPreview : public QWidget
{
  Q_OBJECT

  public:
  
    /*
    PURPOSE    : construct an object of type VFSObjectPreview
    PARAMETERS : parent - parent
                 name - name
    */
    VFSObjectPreview(QWidget* parent=0, const char* name=0);

    /*
    PURPOSE    : destruct a VFSObjectPreview object
    PARAMETERS : none
    */
    virtual ~VFSObjectPreview(){}

  public slots:

    /*
    PURPOSE    : external widgets connect to this slot to instruct the VFSObjectPreview
                 to render an certain object
    PARAMETERS : obj - is the full Aethera VFS path of the object that will be previewed. Make
                       sure it is the right thing you send this method becouse plugins that
                       reimplement don't check to see if what they are trying to display is of
                       proper type
    */
    virtual void slotSetObject(const QString& obj)=0;

    /*
    PURPOSE    : external widgets connect to this is they whant to hide/show the VFSObjectPreview
    PARAMETERS : visibility - if true the widget is showen if not it is hidden
    */
    virtual void slotToggleVisibility(bool visibility=true)=0;
};

#endif
