/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
#include <qaccel.h>
#include <qmainwindow.h>
#include <qwidget.h>
#include <qmenubar.h>
#include <qstatusbar.h>
#include <qwindowsstyle.h>
#include <qtoolbutton.h>
#include <qaction.h>
#include <qdockwindow.h>
#include <qpopupmenu.h>
#include <qapplication.h>
#include <qbuttongroup.h>
#include <qkeysequence.h>
#include <qmessagebox.h>
#include <qprocess.h>
#include <qurl.h>
#include <qsplitter.h>
#include <qtextcodec.h>

#include <defines.h>
#include <externalbrowser.h>
#include <settings.h>
#include <dirs.h>

#include <komaetheraman.h>
#include <kommaintree.h>
#include <settingsdialog.h>
#include <indexclass.h>
#include <messagedevice.h>
#include <orb.h>
#include <appstatus.h>
#include <accountmanager.h>

// kore include
#include <korecomponents.h>

#include <externalbrowser.h>

using namespace kore;

/*
static const char* komaetheraman_metainfo[][2]=
{
    { "/name", "Aethera UI Manager" },
    { "/class", "KomAetheraMan" },
    { "/class/fqn", "KomAetheraMan" },
    { "/factory", "komaetheraman_factory" },
    { "/description", AETHERA_MANAGER_DESC },
    { "/service", AETHERA_MANAGER },
    { 0, 0 }
};
*/

kore::Interface* komaetheraman_factory()
{
  return new KomAetheraMan( (QMainWindow*)qApp->mainWidget() );
}

KomAetheraMan::KomAetheraMan(QMainWindow *qmainWindow)
  : UIPartManager               (),
    dockManager                 (0L),
    mainDockWidget              (0L),
    leftDockWidget              (0L),
    leftWidget                  (0L),
    bannerDockWidget            (0L),
    bannerWidget                (0L),
    topWidget                   (0L),
    pluginToolbar               (0L),
    m_settingsDialog            (0L),
    m_pluginToolbarButtonGroup  (0L),
    m_helpMenuId                (505), // SOS ;)
    m_helpPopup                 (0),
    m_helpIndexAction           (0),
    m_aboutPluginAction         (0),
    m_aboutAction               (0),
    m_shopAction                (0),
    m_toggleLeftWidgetAction    (0),
    m_toggleBannerWidgetAction  (0),
    m_toggleWidgetAction        (0),
    emptyLabel                  (0)
{
  // set the meta information
  MetaInfo *info = metaInfo();
  info->replaceAll("name", "Aethera UI Manager");
  info->replaceAll("class", "KomAetheraMan");
  info->replaceAll("class/fqn", "KomAetheraMan");
  info->replaceAll("factory", "komaetheraman_factory");
  info->replaceAll("description", AETHERA_MANAGER_DESC );
  info->insert("service", AETHERA_MANAGER );

  // Set the main window.
  mainWnd=qmainWindow;
  mainWnd->setAcceptDrops( true );

  // Set the main menu bar.
  mainMenu=mainWnd->menuBar();

  // Set the status bar.
  AppStatus * statusBar = new AppStatus(qmainWindow);
  if( !statusBar )
  {
    qDebug("No StatusBar");
  }
  else
  {
    statusBar->message(AppStatus::Server, AppStatus::Text, AppStatus::Good, QObject::tr("Protocol Status."));
    statusBar->message(AppStatus::Client, AppStatus::Text, AppStatus::Good, QObject::tr("Interface Status."));
  }
  
  // Exclusive button group for handling toggles of plugin toolbar buttons.

  m_pluginToolbarButtonGroup = new QButtonGroup;
  m_pluginToolbarButtonGroup->setExclusive(true);
  m_pluginToolbarButtonGroup->hide();

  // Init the dock widget manager.
  // The top widget used for placing the banners.
  topWidget = new KomContainerWidget( mainWnd, "topWidgetStack");

  dockManager =
    new TKDockManager( QString(APP_KEY), mainWnd, "uimanager", true, topWidget);

  mainDockWidget = (TKDockWidget*) dockManager->mainDock();

  // Plugin toolbar intialization.
  pluginToolbar = new QToolBar( mainWnd, "PluginToolbar" );
  pluginToolbar->setOrientation( Qt::Vertical );
  mainWnd->addDockWindow( pluginToolbar, "PluginToolbar", Qt::DockLeft);

  // Creating DockWidgets.
  // The banner widget (shows pixmaps).
  bannerWidget = new KomContainerWidget( mainDockWidget, "bannerWidgetStack");
  bannerDockWidget = dockManager->create( bannerWidget, "bannerDockWidget");
  QSplitter * dockSplitter = static_cast<QSplitter *>(bannerDockWidget->dock( mainDockWidget, TKDockWidget::Top)->widget());
  if( dockSplitter )
  {
//    qDebug("Banner - DockSplitter found!");
    QValueList<int> sizes;
    sizes << 76 << 314;
    dockSplitter->setSizes(sizes);
  }

  // The left widget for showing the tree.
  leftWidget = new KomContainerWidget( mainDockWidget, "leftWidgetStack");
  leftDockWidget = dockManager->create( leftWidget, "leftDockWidget");
  dockSplitter = static_cast<QSplitter *>(leftDockWidget->dock( mainDockWidget, TKDockWidget::Left)->widget());
  if( dockSplitter )
  {
//    qDebug("Tree - DockSplitter found!");
    QValueList<int> sizes;
    sizes << 180 << 398;
    dockSplitter->setSizes(sizes);
  }

  mainTree = new KomMainTree( leftWidget, "mainTree" );

  QObject::connect
    (
      mainTree,
      SIGNAL(changePart(const QString &)),
      getQTHandler(),
      SLOT(slotChangePart(const QString &))
    );

  QObject::connect
    (
      mainTree,
      SIGNAL(currentURLChanged(const QString &)),
      getQTHandler(),
      SLOT(slotTreeURLChanged(const QString &))
    );

  leftWidget->addChildWidget( mainTree );
  // add an empty label for plugins which doesn't have the left widget
  emptyLabel = new QLabel(leftWidget);
  leftWidget->addChildWidget(emptyLabel);

  // rikkus: This screws the window up. If the method was readable or
  // had docs, I might try fixing it, but we don't have time right now.

  QString geometry = Settings::instance()->readEntry(QString(APP_KEY)+"/uimanager/LastConfig");
  if( !geometry.isEmpty() )
  {
    Settings::forceWrite();
    dockManager->read();
  }
  
  // Build Aethera/Quicksilver and Help menu entries.
  //
  QPopupMenu * fileMenu = new QPopupMenu(mainWnd);
  QPopupMenu * windowMenu = new QPopupMenu(mainWnd);

  // Create the QActions (before adding help menu, because it uses the actions.)
  createMainQActions();

  mainWnd->menuBar()->insertItem("&" + QString(AppName), fileMenu);

  fileMenu->insertItem
    ("&Settings...", getQTHandler(), SLOT(slotShowSettingsDialog()));

  fileMenu->insertSeparator();
  
  fileMenu->insertItem("Show/Hide &Window ...", windowMenu);
  m_toggleWidgetAction->addTo(windowMenu);
  QObject::connect
    (
      windowMenu,
      SIGNAL(aboutToShow()),
      getQTHandler(),
      SLOT(slotSetToggleActions())
    );


  fileMenu->insertSeparator();

  fileMenu->insertItem("&Quit", qApp, SLOT(quit()));

  QAccel * accel = new QAccel(mainWnd);

  accel->connectItem
    (
      accel->insertItem(Qt::Key_F12),
      getQTHandler(),
      SLOT(slotShowVFSView())
    );

  addHelpMenu();
}

KomAetheraMan::~KomAetheraMan()
{
  delete m_helpPopup;
  m_helpPopup = 0;

  delete m_pluginToolbarButtonGroup;
  m_pluginToolbarButtonGroup = 0;

// TODO: Max has to fix this since I have got a crash here!
//  if( dockManager )
  Settings::forceWrite();
  dockManager->save();
  
//  qDebug("------------ KomAetheraMan destructor !!!! ---------");
}

UIPartManagerPrivate *KomAetheraMan::createQTHandler(void)
{
  return new KomUIPartManagerPrivate((UIPartManager*)this);
}

void KomAetheraMan::addPart(UIPart * newPart)
{
  if (!newPart->hasCapability(AETHERA_INTERFACE))
  {
    qDebug("Part doesn't have AETHERA_INTERFACE capability");
    return;
  }

  KomUserInterfaceService * part =
    static_cast<KomUserInterfaceService *>(newPart);

  KomUIPartManagerPrivate * managerHandler =
    static_cast<KomUIPartManagerPrivate *>(getQTHandler());

  KomUIPartPrivate * partHandler =
    static_cast<KomUIPartPrivate *>(part->getQTHandler());

  bool hasTop       (part->hasCapability(TOP_WIDGET));
  bool hasLeft      (part->hasCapability(LEFT_WIDGET));
  bool hasBanner    (part->hasCapability(BANNER_WIDGET));
  bool hasTree      (part->hasCapability(TREE_INTERFACE));
  bool hasActivate  (part->hasCapability(ACTIVATE_BUTTON));

  QWidget * topView = 0;
  int iButton = -1;
  
  if (hasTop)
  {
    part->createWidget  (TOP_WIDGET);
    part->linkWidget    (TOP_WIDGET);

    topView = part->getWidget(TOP_WIDGET);

    topWidget->addChildWidget(topView);
  }

#if 0
  if( part->hasCapability( UPPERVIEW_WIDGET ) )
  {
    part->createWidget( UPPERVIEW_WIDGET );
    part->linkWidget( UPPERVIEW_WIDGET );
  }
#endif

  if (hasLeft)
  {
    part->createWidget  (LEFT_WIDGET);
    part->linkWidget    (LEFT_WIDGET);

    leftWidget->addChildWidget(part->getWidget(LEFT_WIDGET));
  }

  if (hasBanner)
  {
    part->createWidget  (BANNER_WIDGET);
    part->linkWidget    (BANNER_WIDGET);

    bannerWidget->addChildWidget(part->getWidget(BANNER_WIDGET));
  }
  else
  {
    // TODO: default
  }

  if (hasTree)
  {
    KomMainTreeInterface * mainTreeInterface =
      part->getMainTreeInterface(mainTree);

    mainTree->addInterface(mainTreeInterface);

#if 0
    // FIXME: There should be a more logical way to do this.

    if (0 != topView)
    {
      qDebug("********** Connecting mainTree to ui parthandler");
      QObject::connect
        (
          mainTreeInterface->getQTHandler(),
          SIGNAL(currentURLChanged(const QString &)),
          partHandler,

          SLOT(slotCurrentURLChanged(const QString &))
        );
    }
#endif
  }

  if (hasActivate)
  {
    QToolButton * newButton =
      new QToolButton
      (
        part->iconSet(),
        part->prettyName(),
        QString::null,
        partHandler,
        SLOT(slot_activate()),
        pluginToolbar,
        part->mimeType()
      );

    QObject::connect
      (
        newButton,
        SIGNAL(toggled(bool)),
        partHandler,
        SLOT(slot_activate(bool))
      );
      
    switch( parts.count() )
    {
      case 0 :
        newButton->setAccel( QKeySequence("Alt+1") );
        break;
      
      case 1:
        newButton->setAccel( QKeySequence("Alt+2") );
        break;
      
      case 2 :
        newButton->setAccel( QKeySequence("Alt+3") );
        break;
      
      case 3:
        newButton->setAccel( QKeySequence("Alt+4") );
        break;
      
      case 4 :
        newButton->setAccel( QKeySequence("Alt+5") );
        break;
      
      case 5:
        newButton->setAccel( QKeySequence("Alt+6") );
        break;
      
      case 6 :
        newButton->setAccel( QKeySequence("Alt+7") );
        break;
      
      case 7:
        newButton->setAccel( QKeySequence("Alt+8") );
        break;
      
      case 8 :
        newButton->setAccel( QKeySequence("Alt+9") );
        break;
      
      case 9:
        newButton->setAccel( QKeySequence("Alt+0") );
        break;
      
      default:
        qDebug("It's not possible to associate an accelerator for this plugin.");
        break;
    }
        
    iButton = m_pluginToolbarButtonGroup->insert(newButton);

    newButton->setUsesBigPixmap (true);
    newButton->setToggleButton  (true);

    QObject::connect
      (
        partHandler,
        SIGNAL(activate(const QString &)),
        managerHandler,
        SLOT(slot_pluginToolbarButtonClicked(const QString &))
      );
      
    // Connect the UIPart with the VFSModule.
    
    VFSModule * vfs = 0;
    ComponentTrader* trader = dynamic_cast<ComponentTrader*>(ComponentTrader::traderRef().instance());
    if( trader )
    {
      ComponentRef ref = trader->registeredComponent( AETHERA_VFS_SERVICE );
      if( ref.isValid() )
        vfs = dynamic_cast<VFSModule*>(ref.instance());
    }
    assert (0 != vfs);

    QObject::connect
      (
        vfs,
        SIGNAL(updateVInstances(const QStringList &)),
        partHandler,
        SLOT(slot_updateVInstances(const QStringList &))
      );

    QObject::connect
      (
        vfs,
        SIGNAL(createVInstances(const QStringList &)),
        partHandler,
        SLOT(slot_createVInstances(const QStringList &))
      );

    QObject::connect
      (
        vfs,
        SIGNAL(deleteVInstances(const QStringList &)),
        partHandler,
        SLOT(slot_deleteVInstances(const QStringList &))
      );

    QObject::connect
      (
        vfs,
        SIGNAL(purgeVFolder(const QString &)),
        partHandler,
        SLOT(slot_purgeVFolder(const QString &))
      );

    QObject::connect
      (
        vfs,
        SIGNAL(updateHierarchy(const QString &)),
        partHandler,
        SLOT(slot_updateHierarchy(const QString &))
      );

    QObject::connect
      (
        vfs,
        SIGNAL(showProgress(const QString &)),
        partHandler,
        SLOT(slot_showProgress(const QString &))
      );

    QObject::connect
      (
        vfs,
        SIGNAL(createVFolder(const QString &, const QString &, const QString &, const QString &, const QString &)),
        partHandler,
        SLOT(slot_createVFolder(const QString &, const QString &, const QString &, const QString &, const QString &))
      );

    QObject::connect
      (
        vfs,
        SIGNAL(deleteVFolder(const QString &, const QString &, const QString &)),
        partHandler,
        SLOT(slot_deleteVFolder(const QString &, const QString &, const QString &))
      );
  }

  // An index with 4 digits should be enough.

  if( iButton != (int)parts.count() )
  {
    qDebug("Button ID is different then part ID. %d || %u", iButton, parts.count());
  }
  idxPartDict.insert(QString("%1").arg(parts.count(), 4), part);

  typePartDict.insert(part->mimeType(), part);
  
//  qDebug("Part %u is %s", parts.count(), part->mimeType().latin1());

  parts.append(part);

  linkPart(part);

  managerHandler->emitPartAdded(part);
}

void KomAetheraMan::removePart(UIPart *removedPart)
{
  if( removedPart && removedPart->hasCapability( AETHERA_INTERFACE ) )
  {
    KomUserInterfaceService * part =
      static_cast<KomUserInterfaceService *>(removedPart);
    
    if(!part)
      return;
  
    KomUIPartManagerPrivate * managerHandler =
      static_cast<KomUIPartManagerPrivate *>(getQTHandler());
  
    KomUIPartPrivate * partHandler =
      static_cast<KomUIPartPrivate *>(part->getQTHandler());

    // Disconnect the UIPart from the VFSModule.

    VFSModule * vfs = 0;
    ComponentTrader* trader = dynamic_cast<ComponentTrader*>(ComponentTrader::traderRef().instance());
    if( trader )
    {
      ComponentRef ref = trader->registeredComponent( AETHERA_VFS_SERVICE );
      if( ref.isValid() )
        vfs = dynamic_cast<VFSModule*>(ref.instance());
    }
    assert (0 != vfs);

    QObject::disconnect
      (
        vfs,
        SIGNAL(updateVInstances(const QStringList &)),
        partHandler,
        SLOT(slot_updateVInstances(const QStringList &))
      );

    QObject::disconnect
      (
        vfs,
        SIGNAL(createVInstances(const QStringList &)),
        partHandler,
        SLOT(slot_createVInstances(const QStringList &))
      );

    QObject::disconnect
      (
        vfs,
        SIGNAL(deleteVInstances(const QStringList &)),
        partHandler,
        SLOT(slot_deleteVInstances(const QStringList &))
      );

    QObject::disconnect
      (
        vfs,
        SIGNAL(purgeVFolder(const QString &)),
        partHandler,
        SLOT(slot_purgeVFolder(const QString &))
      );

    QObject::disconnect
      (
        vfs,
        SIGNAL(updateHierarchy(const QString &)),
        partHandler,
        SLOT(slot_updateHierarchy(const QString &))
      );

    QObject::disconnect
      (
        vfs,
        SIGNAL(showProgress(const QString &)),
        partHandler,
        SLOT(slot_showProgress(const QString &))
      );

    QObject::disconnect
      (
        vfs,
        SIGNAL(createVFolder(const QString &, const QString &, const QString &, const QString &, const QString &)),
        partHandler,
        SLOT(slot_createVFolder(const QString &, const QString &, const QString &, const QString &, const QString &))
      );

    QObject::disconnect
      (
        vfs,
        SIGNAL(deleteVFolder(const QString &, const QString &, const QString &)),
        partHandler,
        SLOT(slot_deleteVFolder(const QString &, const QString &, const QString &))
      );

    if( part->isActive() )
      deactivatePart(part);
    // the dict should have setAutoDelete(false)
//    idxPartDict.deleteItem(part);
    if( !typePartDict.remove(part->mimeType()) )
      return;
    if( !parts.removeRef(part) )
      return;
    unlinkPart(part);
    managerHandler->emitPartRemoved(part);
  }
}

void KomAetheraMan::activatePart(int id)
{
//  qDebug("activatePart(%d)", id);
  UIPart* part = idxPartDict.find( QString("%1").arg(id, 4) );
  if( part )
    activatePart(part);
}

void KomAetheraMan::activatePart(const QString & type)
{
  qDebug("activatePart(%s)", type.ascii());

  UIPart* part = typePartDict.find( type );
  if( part )
    activatePart(part);
}

void KomAetheraMan::activatePart(UIPart *activatedPart)
{
//  qDebug("activatePart");
  if( activatedPart->hasCapability( AETHERA_INTERFACE ) )
  {
    KomUserInterfaceService *part= (KomUserInterfaceService*) activatedPart;
    KomUIPartManagerPrivate* managerHandler = (KomUIPartManagerPrivate*) getQTHandler();
    
    // if it is already active, just return
    if( part == activePart )
      return;
    if( activePart )
      deactivatePart(activePart);
    if( (mainWnd) && (part->hasCapability( TOOLBARS )) )
      part->showToolbars(mainWnd);
    if( (mainMenu) && (part->hasCapability( MENUBARS )) )
    {
      removeHelpMenu();

      m_aboutPluginAction->setEnabled(true);
      part->showMenus(mainMenu);
      
      addHelpMenu();
    }
    if(part->hasCapability( TOP_WIDGET ))
    {
      topWidget->showChild( part->getWidget( TOP_WIDGET ) );
    }
    if(part->hasCapability( BANNER_WIDGET ))
    {
      bannerWidget->showChild( part->getWidget( BANNER_WIDGET ) );
    }
    if(part->hasCapability( TREE_INTERFACE ))
    {
      part->buildTree();
      // This makes the part set the main widget's URL to the default.
      part->setCurrentURL(QString::null);
    }
    if(part->hasCapability( LEFT_WIDGET ))
    {
      leftWidget->showChild( part->getWidget( LEFT_WIDGET ) );
    }
    else
    {
      if(part->hasCapability( TREE_INTERFACE ))
      {
        leftWidget->addChildWidget( mainTree );
        leftWidget->showChild( mainTree );
      }
      else
      {
        // Save the visible status for the left widget
        // We have to turn back to the old status when the part is deactivated
        bLeftVisible = leftDockWidget->isVisible();

        leftWidget->showChild( emptyLabel );
        leftDockWidget->hide();
      }
    }

    activePart = part;
    part->activated();
    managerHandler->emitPartActivated(part);
  }
}

void KomAetheraMan::deactivatePart(UIPart *part)
{
  qDebug("KomAetheraMan::deactivatePart");

  if( part->hasCapability( AETHERA_INTERFACE ) )
  {
    if( part->hasCapability( TOP_WIDGET ) )
    {
      // show a default widget from the top widget stack
    }
    if( part->hasCapability( TREE_INTERFACE ) )
    {
      KomUserInterfaceService * partUI = (KomUserInterfaceService*) part;
      partUI->removeTree();
      
      mainTree->clear();
      // TODO TREE_INTERFACE
    }
    if( part->hasCapability( LEFT_WIDGET ) )

    {
      // show a default widget from the top widget stack
    }
    else
    {
      if( !part->hasCapability( TREE_INTERFACE ) )
      {
        if( bLeftVisible )
          leftDockWidget->show();
      }
    }

    m_aboutPluginAction->setEnabled(false);

    // the TINO method
    UIPartManager::deactivatePart( part );
  }
}

bool KomAetheraMan::init()
{
  InitializingTranslators();
  
//  mainTree->addColumn("test");
  mainTree->setColumnWidthMode( 0, QListView::Maximum );

  // init the UI components
  InitializingBackendServices();
  InitializingUIServices();
  
  // Hide all the top toolbars
//  QPtrList<QToolBar> toolbars = mainWnd->toolBars(Qt::DockTop);
//  for(QPtrListIterator<QToolBar> it(toolbars); it.current(); ++it)
//    it.current()->hide();

  // Go to the first component
  QLabel *emptyLabel = new QLabel(pluginToolbar);
  pluginToolbar->setStretchableWidget(emptyLabel);

  m_pluginToolbarButtonGroup->setButton(0);

  // show the main window
  mainWnd->show();
  
  return true;
}

void KomAetheraMan::InitializingTranslators()
{
  ComponentTrader* trader = dynamic_cast<ComponentTrader*>(ComponentTrader::traderRef().instance());
  if( trader )
  {
    ComponentRef *providers = trader->registeredComponents( AETHERA_LANGUAGESERVICE );
    
    if ( !providers[0].isValid() )
    {
      qDebug("No translators registered");
    }
    else
    {
      // languages support for Aethera basic
      QString languageEnv = QTextCodec::locale();
      
      if( languageEnv.isEmpty() )
        languageEnv = "en";
        
      QString languagePath = Dirs::locateDir("i18n");
      if( languagePath.isEmpty() )
        languagePath = ".";
      QString trFile;
      KomLanguageService * crtServiceTest = 0L;
      
      for(int i=0; providers[i].isValid(); ++i)
      {
        crtServiceTest = dynamic_cast<KomLanguageService*>(providers[i].instance());

        if( crtServiceTest )
        {
          trFile = crtServiceTest->translator() + "_" + languageEnv;
          
          // QT translation
          QTranslator * translator = new QTranslator(0);
          if( translator->load( trFile, languagePath) )
          {
            qApp->installTranslator( translator );
          }
          else
          {
            qDebug("Couldn't find translator %s", trFile.latin1());
            delete translator;
          }
        }
      }
    }
  }
}

void KomAetheraMan::InitializingUIServices()
{
  ComponentTrader* trader = dynamic_cast<ComponentTrader*>(ComponentTrader::traderRef().instance());
  if( trader )
  {
    ComponentRef *providers = trader->registeredComponents( AETHERA_UISERVICE );
    
    if ( !providers[0].isValid() )
    {
      qWarning("No UI providers registered");
    }
    else
    {
      QDict<UIPart> availableParts;
      UIPart* crtServiceTest = 0;
      MetaInfo* libraryMetaInfo = 0;
      QString libraryName;
      for ( int i=0; providers[i].isValid(); ++i )
      {
        ComponentRef library = providers[i];
        libraryMetaInfo = library.metaInfo();
        crtServiceTest = dynamic_cast<UIPart*> ( providers[i].instance() );
        
        if( !crtServiceTest ||
            !crtServiceTest->hasCapability( AETHERA_INTERFACE ) ||
            !libraryMetaInfo ||
            (libraryName = libraryMetaInfo->find("library/name")).isEmpty() )
        {
          qWarning("Not a valid UIPart");
        }
        else
        {
          availableParts.insert(libraryName, crtServiceTest);
        }
      }
      
      QStringList plugIns = Settings::instance()->readListEntry("/Aethera/PlugInManager/LoadedPlugins", ',');
      if( plugIns.isEmpty() )
        plugIns = Settings::instance()->readListEntry("/Aethera/PlugInManager/PlugIns", ',');
      
      for(QStringList::Iterator itPlugIn=plugIns.begin(); itPlugIn!=plugIns.end(); ++itPlugIn)
      {
        crtServiceTest = availableParts[(*itPlugIn)];
        if( crtServiceTest )
          addPart( crtServiceTest );
      }
    }
  }
}

void KomAetheraMan::InitializingBackendServices()
{
  ObjectRequestBroker * orb = 0L;
  VFSModule * vfs = 0L;

  
  orb = ObjectRequestBroker::thisInstance();
  
  ComponentTrader* trader = dynamic_cast<ComponentTrader*>(ComponentTrader::traderRef().instance());
  if( trader )
  {

    ComponentRef ref = trader->registeredComponent( AETHERA_VFS_SERVICE );
    if( ref.isValid() )
      vfs = dynamic_cast<VFSModule*>(ref.instance());
    
    ComponentRef *providers = trader->registeredComponents( AETHERA_BACKENDSERVICE );
    
    if ( !providers[0].isValid() || vfs==NULL )
    {
      qWarning( "No BACKEND providers registered or no VFS module available." );
      return;
    }
    KomBackendService* crtServiceTest;
    for ( int i=0; providers[i].isValid(); ++i )
    {

      crtServiceTest = dynamic_cast<KomBackendService*> ( providers[i].instance() );
      if( crtServiceTest )
      {
        vfs->registerFactory( crtServiceTest->mimeType(), crtServiceTest->vobjectFactory());
        qDebug("The %s objects factory is registered", crtServiceTest->mimeType().latin1());
        
        orb->addPlugin( crtServiceTest->mimeType(),
                        crtServiceTest->systemFolders(),
                        crtServiceTest->backendType() );
      }
      else 
        qDebug( "Service %d is not a BackendService", i );
    }
  }
}

void KomAetheraMan::createMainQActions()
{
  //-------------- Windows -----------
  m_toggleLeftWidgetAction =
    new QAction
    (
      "ToggleLeftWidget",
      "&Tree ...",
      QKeySequence(),
      mainWnd
    );
  m_toggleLeftWidgetAction->setToggleAction(true);
  m_toggleLeftWidgetAction->setOn(true);

  m_toggleBannerWidgetAction =
    new QAction
    (
      "ToggleBannerWidget",
      "&Banner ...",
      QKeySequence(),
      mainWnd
    );
  m_toggleBannerWidgetAction->setToggleAction(true);
  m_toggleBannerWidgetAction->setOn(true);

  m_toggleWidgetAction =
    new QActionGroup
    (
      mainWnd,
      "ToggleDockWidget",
      false
    );
  m_toggleWidgetAction->add(m_toggleLeftWidgetAction);
  m_toggleWidgetAction->add(m_toggleBannerWidgetAction);
    
  QObject::connect
    (
      m_toggleLeftWidgetAction,
      SIGNAL(activated()),
      getQTHandler(),
      SLOT(slotToggleLeftDockWidget())
    );
  QObject::connect
    (

      m_toggleLeftWidgetAction,
      SIGNAL(toggled(bool)),
      getQTHandler(),
      SLOT(slotToggleLeftDockWidget(bool))
    );
  QObject::connect
    (
      m_toggleBannerWidgetAction,
      SIGNAL(activated()),
      getQTHandler(),
      SLOT(slotToggleBannerDockWidget())
    );
  QObject::connect
    (
      m_toggleBannerWidgetAction,
      SIGNAL(toggled(bool)),
      getQTHandler(),

      SLOT(slotToggleBannerDockWidget(bool))
    );
    
  //-------------- Help -----------
  m_helpIndexAction =
    new QAction
    (
      "Index",
      "&Index...",
      QKeySequence(Qt::Key_F1),
      mainWnd
    );

  QObject::connect
    (
      m_helpIndexAction,
      SIGNAL(activated()),
      getQTHandler(),
      SLOT(slotHelpIndex())
    );

  m_shopAction =
    new QAction
    (
      "Shop for Plugins",
      "&Shop for Plugins...",
      QKeySequence(),
      mainWnd
    );

  QObject::connect
    (
      m_shopAction,
      SIGNAL(activated()),
      getQTHandler(),
      SLOT(slotShop())

    );

  m_aboutPluginAction =
    new QAction

    (
      "About active plugin",
      "About active &plugin...",
      QKeySequence(),

      mainWnd
    );

  QObject::connect
    (
      m_aboutPluginAction,
      SIGNAL(activated()),
      getQTHandler(),
      SLOT(slotAboutActivePlugin())
    );

  // Disable 'about plugin' until we have a plugin.
  m_aboutPluginAction->setEnabled(false);

  m_aboutAction =
    new QAction
    (
      "About " + QString(AppName),
      "&About " + QString(AppName) + QString("..."),

      QKeySequence(),
      mainWnd
    );


  QObject::connect
    (
      m_aboutAction,
      SIGNAL(activated()),
      getQTHandler(),
      SLOT(slotAbout())

    );
}

//--------------------------------------------------------------
//*************** SLOTS ***********************
//--------------------------------------------------------------

void KomAetheraMan::pluginToolbarButtonClicked(const QString & type)
{
//  qDebug("KomAetheraMan::pluginToolbarButtonClicked %s", type.ascii());


  if (0 == parts.count())
  {
    qDebug("Hmm, no parts ?");
    return;
  }

  if (lastToolbarButtonClicked == type)
  {
    qDebug("Already on this type - no need to activate part");
    return;
  }

  lastToolbarButtonClicked = type;
  activatePart(type);
}


void KomAetheraMan::treeURLChanged(const QString & url)
{
  for (QPtrListIterator<UIPart> it(parts); it.current(); ++it)
  {
    KomUserInterfaceService * part =
      static_cast<KomUserInterfaceService *>(it.current());


    part->setCurrentURL(url);
  }
}


void KomAetheraMan::showSettingsDialog()
{
  // stop the prtocols activities
  AccountManager::ref()->stopAllAccounts();
  
  if (0 == m_settingsDialog)
    m_settingsDialog = new SettingsDialog(mainWidget(), "AetheraSettings");

  m_settingsDialog->exec();
}

void KomAetheraMan::removeHelpMenu()
{
  if (0 == m_helpPopup)
  {
    qDebug("KomAetheraMan::removeHelpMenu: m_helpPopup is 0");
    return;
  }

  assert(0 != m_helpIndexAction);

  m_helpIndexAction   ->removeFrom(m_helpPopup);

  m_aboutPluginAction ->removeFrom(m_helpPopup);
  m_aboutAction       ->removeFrom(m_helpPopup);
  m_shopAction        ->removeFrom(m_helpPopup);

  delete m_helpPopup;
  m_helpPopup = 0;
}

void KomAetheraMan::addHelpMenu()
{
  if(0L == m_helpPopup)
  {
    m_helpPopup = new QPopupMenu(mainWnd);
  }

  assert(0 != m_helpIndexAction);

  m_helpIndexAction   ->addTo(m_helpPopup);
  m_aboutPluginAction ->addTo(m_helpPopup);
  m_aboutAction       ->addTo(m_helpPopup);
  m_shopAction        ->addTo(m_helpPopup);

  // Index defaults to -1, which will put us right-aligned on the bar.
  mainMenu->insertItem("Help", m_helpPopup, m_helpMenuId);
}

void KomAetheraMan::helpIndex()
{
#if HANCOM
  QString url = QString(getenv("H_PATH")) + "/help/HancomQuicksilver.pdf";
  QProcess * process = new QProcess(getQTHandler());

  // First we try acroread.

  process->addArgument("/usr/local/Acrobat4/bin/acroread");
  process->addArgument(url);

  if (process->launch(QByteArray()))
    return;
  
  process->clearArguments();
  process->addArgument("acroread");
  process->addArgument(url);

  if (process->launch(QByteArray()))
    return;


  qDebug("Can't launch acroread. Trying xpdf next.");
  
  // Tring xpdf
  
  process->clearArguments();
  process->addArgument("xpdf");
  process->addArgument(url);

  if (process->launch(QByteArray()))
    return;

  qDebug("Can't launch xpdf.");
  
  QMessageBox::warning
    (
      mainWnd,
      "Warning - " + QString(AppName),
      "You need to install a pdf viewer (Acrobat Reader or xpdf) for reading the help file."
    );
#else
#ifdef _QTWIN_
  QString path = QDir::currentDirPath() + "/help/index.html";
#else
  QString path = Dirs::locate("help/index.html");
#endif
  QUrl url( path );
  ExternalBrowser::launchUrl(url);
#endif
}

void KomAetheraMan::aboutActivePlugin()
{
  KomUserInterfaceService * part =
    static_cast<KomUserInterfaceService *>(activePart);


  if (0 == part)
  {

    qDebug("Active part isn't a KomUserInterfaceService");
    return;
  }


  part->execAboutDialog(mainWnd);
}

void KomAetheraMan::about()
{
  QMessageBox::about
    (
      mainWnd,
      QString("About %1").arg(AppName),
      QString("%1").arg(FullAppName) + "\n"
      + QString("Developed by theKompany.com") + "\n\n"
      + QString("Project manager") + "\n"
      + QString("Eugen Constantinescu <eug@thekompany.com>")
    );
}

void KomAetheraMan::shop()
{
  QString thisIsQuickSilver = "0";


  if (QString("QuickSilver").lower() == QString(AppName).lower())
    thisIsQuickSilver = "1";

  QString url =
    "http://www.thekompany.com/scripts/redir.php3?HO="
    + thisIsQuickSilver
    + "&redir=/products/aethera/";

  if (!ExternalBrowser::launchUrl(url, getQTHandler()))
  {
    QMessageBox::warning
      (
        mainWnd,
        "Warning - " + QString(AppName),
        "Can't launch a web browser to shop for plugins.\n"
        "Please contact aethera@thekompany.com for help."
      );
  }
}

void KomAetheraMan::toggleLeftDockWidget(bool bShow)
{
  if( bShow )
    leftDockWidget->show();
  else
    leftDockWidget->hide();
}

void KomAetheraMan::toggleBannerDockWidget(bool bShow)
{
  if( bShow )
    bannerDockWidget->show();
  else
    bannerDockWidget->hide();
}

void KomAetheraMan::setToggleActions()
{
  if( leftDockWidget->isVisible() )
    m_toggleLeftWidgetAction->setOn(true);
  else

    m_toggleLeftWidgetAction->setOn(false);
  
  if( bannerDockWidget->isVisible() )
    m_toggleBannerWidgetAction->setOn(true);
  else
    m_toggleBannerWidgetAction->setOn(false);
}

QWidget * KomAetheraMan::mainWidget()
{
  return mainWnd;
}

KomMainTree * KomAetheraMan::foldersTree()
{
  return mainTree;
}

