/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
#ifndef KOMAETHERAXCHG_H
#define KOMAETHERAXCHG_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qstring.h>

#include <komaetheratools.h>

#define _MAX_PLUGIN_CONNECTIONS_ 10

class KomXchgObject
{
public:
  KomXchgObject(){}
  virtual ~KomXchgObject(){}
  KomXchgObject( KomXchgObject& r ){ *this = r; }
  KomXchgObject& operator=( KomXchgObject& ){ return *this; }
protected:
};


typedef int (*KomXchgAction)( KomXchgObject& o ) ;

class KomXchgInterface
{
public:
  KomXchgInterface( unsigned int reserveActionCount=0 );
  virtual ~KomXchgInterface();

  typedef enum { stdNone=-1, stdActionNew=0 } stdActions;

  int registerAction( KomXchgAction actionPtr, stdActions actionId=stdNone );

  int execute( stdActions actionId, KomXchgObject& o );
  int execute( int actionId, KomXchgObject& o );

protected:
  KomXchgAction *m_registeredActions;
  int m_registeredActionsCount, m_reservedActionCount;
};

class KomAetheraXchg
{
public:
  KomAetheraXchg( int pluginConnectionsCount=0 );
  virtual ~KomAetheraXchg();

  KomXchgInterface* getXchgInterface( int pluginId );
  KomXchgInterface* getXchgInterface( QString pluginName );
  int getPluginId( QString pluginName );
  int getPluginCount( ) { return m_pluginConnectionsCount; }

  int connectPlugin( QString pluginName );
  int disconnectPlugin( QString pluginName );
  int disconnectPlugin( int pluginId );

  void executeAction( ) {}


protected:
  class KomPluginConnectionPoint
  {
  public:
    KomPluginConnectionPoint( );
    KomPluginConnectionPoint( const QString &pluginName, KomXchgInterface *pluginInterface =NULL);
    ~KomPluginConnectionPoint();
    KomPluginConnectionPoint( KomPluginConnectionPoint &r ){ *this=r; }
    KomPluginConnectionPoint& operator=( KomPluginConnectionPoint& r );

    bool isConnected( ) { return m_pluginInterface==NULL; }
    KomXchgInterface* getInterface( ) { return m_pluginInterface; }
    void setInterface( KomXchgInterface* pluginInterface );
    void setName( const QString &pluginName ) { m_pluginName = pluginName; }
    QString& getName( ) { return m_pluginName; }

    bool operator==( QString& pluginName ) { return m_pluginName == pluginName; }

  protected:
    QString m_pluginName;
    KomXchgInterface *m_pluginInterface;
  };

  typedef KomPluginConnectionPoint* PKomPluginConnectionPoint;

  // Nu e dinamic pt. viteza... o sa ma gandesc la alta implementare
  PKomPluginConnectionPoint* m_pluginConnections;
  int m_pluginConnectionsCount;
};


#endif


