/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/***************************************************************************
                      reportviewer.cpp  -  description
                             -------------------
    begin                : Thu Jan 30 2003
    copyright            : (C) 2003 by theKompany.com
    email                : eug@thekompany.com
 ***************************************************************************/


#include "reportviewer.h"

#include <filedownloader.h>
#include <externalbrowser.h>

#include <qtimer.h>
#include <qfile.h>

ReportViewer::ReportViewer(QObject *parent, const char *name )
  : QObject(parent, name),
    fileDownload(0),
    refresh(false)
{
  fileDownload = new FileDownloader(this);
  
  connect(fileDownload, SIGNAL(finished(const FileDownloader::Result&, const QString&, const QString&)),
          this, SLOT(slotDataReady(const FileDownloader::Result&, const QString&, const QString&)));
}

ReportViewer::~ReportViewer()
{
}

void ReportViewer::slotUpdate()
{
  qDebug("ReportViewer::slotUpdate()");
  
  refresh = true;
}

void ReportViewer::startTimer(int msec, bool sshot)
{
  timer.start(msec, sshot);
}

void ReportViewer::startTimer()
{
  // by default, 30 min
  timer.start(30 * 60 * 1000, false);
}

void ReportViewer::stopTimer()
{
  timer.stop();
}

bool ReportViewer::isActive()
{
  return timer.isActive();
}

void ReportViewer::slotDataReady( const FileDownloader::Result & result,
                                  const QString & packageUrl,
                                  const QString & savePath)
{
//  qDebug("ReportViewer::slotDataReady");
  
  if( result.type == FileDownloader::Result::Success )
  {
    currentURL = packageUrl;
    
    QFile dataFile(savePath);
    parseData(&dataFile);
      
    show();
  }
  else
  {
    qDebug("ReportViewer error: %s", result.description.latin1());
    
    return;
  }
      
  nextURL();
}

void ReportViewer::slotOpenLink(const QString & url)
{
  QUrl link(url);
  
  ExternalBrowser::launchUrl(link, this);
}

