/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/***************************************************************************
                          reportviewer.h  -  description
                             -------------------
    begin                : Thu Jan 30 2003
    copyright            : (C) 2003 by theKompany.com
    email                : eug@thekompany.com
 ***************************************************************************/

#ifndef REPORTVIEWER_H
#define REPORTVIEWER_H

#include <filedownloader.h>

#include <qobject.h>
#include <qtimer.h>
#include <qstringlist.h>

class QWidget;
class QIODevice;

/**It can parse some data for showing a report.
  *@author Eugen C. <eug@thekompany.com>
  */

class HOME_PLUGIN_API ReportViewer : public QObject
{
  Q_OBJECT
  
  public:
  
    ReportViewer(QObject *parent=0, const char *name=0);
    virtual ~ReportViewer();
    
    virtual QWidget * widget(QWidget *parent=0, const char *name=0)=0;
    virtual bool isActive();
    
  public slots:
  
    virtual void slotUpdate();
    virtual void startTimer(int, bool sshot=false);
    virtual void startTimer();
    virtual void stopTimer();
    
  protected slots:
  
    virtual void slotDataReady(const FileDownloader::Result&, const QString&, const QString&);
    virtual void slotOpenLink(const QString &);
    
  protected:
  
    virtual bool parseData(QIODevice * dev)=0;
    virtual bool parseData(const QByteArray&)=0;
    
    virtual void show()=0;
    virtual void clear()=0;
    virtual void hideWidget()=0;
    virtual void showWidget()=0;
    virtual void nextURL()=0;
    
    FileDownloader * fileDownload;
    bool refresh;
    QTimer timer;
    QString group;
    QString fileName;
    QString currentURL;
    QStringList urlList;
};

#endif
