/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/*
 * This file is part of Magellan <http://www.kAlliance.org/Magellan>
 *
 * Copyright (c) 1998-2000 Teodor Mihai <teddy@ireland.com>
 * Copyright (c) 1998-2000 Laur Ivan <laur.ivan@ul.ie>
 * Copyright (c) 1999-2000 Virgil Palanciuc <vv@ulise.cs.pub.ro>
 *
 * Requires the Qt widget libraries, available at no cost at
 * http://www.troll.no/
 *
 * Also requires the KDE libraries, available at no cost at
 * http://www.kde.org/
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */

#ifndef __Has_AddressBook__
#define __Has_AddressBook__

#include <qstringlist.h>
#include <qstring.h>
#include <qdict.h>
#include <vcontactobject.h>
#include <groupobj.h>
#include <vfsmodule.h>

#ifdef Q_WS_WIN
#if defined(Q_TEMPLATEDLL)
// MOC_SKIP_BEGIN
template class CONTACT_PLUGIN_API QDict<QString>;
template class CONTACT_PLUGIN_API QDict<QStringList>;
template class CONTACT_PLUGIN_API QDict<GroupObject>;
// MOC_SKIP_END
#endif
#endif

// Eugen C. :( This class has to be completly rewriten !!!
// Sorry but what a b...s... :(

class CONTACT_PLUGIN_API AddressBook
{
  public:
    enum { Contacts=1, Groups=2, History=4, ListOnly=8 , ShowHeader=0x10};	
    
     // scans contacts, groups, loads history
    AddressBook();
    
    void setChanged();
    void update();
    
    /*
     * load history from file, calls addHistoryAddress()
     * save history to file
     * adding the history address to the cache
     */
    void loadHistory();
    void saveHistory();
    void addHistoryAddress(QString address);
    
    void removeHistoryItem(QString);
    
    // scan "entries" with a dict iterator and build list of matching entries
    // (matching means that substring
    // (first input_string.length() chars of key)==
    // (case insensitive)input_string)
    QStringList completeNames(QString key, int mode=Contacts|Groups|History);
    
    QString getDefaultName(QString key);
    
    QStringList complete(QString key);
    
    QStringList getEntries(QStringList keys);
    
    QStringList getEntry(QString key);
    
    QStringList getRealEntry(QString key);
    
    static AddressBook *thisInstance();
    
  private:
    // scans all contacts and calls addContact()
    void scanContacts();
    // scans all groups and call addGroup()
    void scanGroups();

    void addContact(VContactObject *);
    void addGroup(GroupObject *);
    
    // remove url from contactURLs and add all emails
    // (properly formatted if necessary) to
    // history
    void removeContact(QString url);
    // remove url from groupURLs and add all emails to history
    void removeGroup(QString url);
    
    bool isProper(QString &addr);
    QString makeProper(VContactObject *, QString);
    
    // Use the QDict to complete names...
    QStringList completeNamesContacts(QString key);
    QStringList completeNamesGroups(QString key);
    QStringList completeNamesHistory(QString key);
    
    void addUnique(QStringList &, QString entry);
    
    VFSModule *vfs;
    // url -> VObject
    QDict<QString> entries;
    // entries -> url
    QDict<QStringList> aliasesDict;
    QDict<QStringList> reverse;
    QStringList contacts;
    QStringList groups;
    QStringList historyAddresses;
    QDict<GroupObject> go;
    int historySize;
    static AddressBook *item;
    bool changed_;
};

#endif
