/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
---------------------------------------------------------------------------------
  Date     : 16 August 2003
  Author   : Ghiciuc Ilie (ilie@eco-spaces.com.ro)
---------------------------------------------------------------------------------
*/

#ifndef CONTACT_SEARCH_SERVICE_H
#define CONTACT_SEARCH_SERVICE_H

//Aethera includes
#include <komaetheraplugin.h>

#define CONTACT_SEARCH_SERVICE        "/Aethera/Service/Search/Contact"
#define CONTACT_SEARCH_SERVICE_DESC   "Allow other plugin to search for contacts"

extern "C"
{
    CONTACT_PLUGIN_API kore::Interface* contactsearchservice_factory();
};

//search value defines
#define CONTACT_EMAIL "email"

class CONTACT_PLUGIN_API ContactSearchService : public KomAetheraService
{
  public:
  
    static ContactSearchService * instance();
    
    virtual ~ContactSearchService();
    
    virtual bool inAddressBook(const QString& searchField, const QString& info=QString::null);
    
    virtual QStringList getAllContactsList(const QString& folder=QString::null, bool recursive=true);
    
    virtual void freeContacts(const QString& folder=QString::null, bool recursive=true);
    
    virtual QString contactsRoot();
    
  private:
  
    ContactSearchService();
    
    void buildContactsList(QStringList&, const QString&, bool recursive=true);

    static ContactSearchService * instance_;
        
    VFSModule * vfs;
    QString contactsRoot_;
};

#endif

