/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/***************************************************************************
        contactsexportsetup.cpp  -  the card export setup dialog
                             -------------------
    begin                : Thu Aug 15 17:35:17 EEST 2001
    copyright            : (C) 2001 by Eugen C.
    email                : eug@thekompany.com
 ***************************************************************************/

#include <contactsexportsetup.h>
#include <qfiledialog.h>
#include <qradiobutton.h>
#include <qlineedit.h>

/*
 *  Constructs a ContactsImportSetup which is a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
ContactsExportSetup::ContactsExportSetup( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : ContactExportSetupBase( parent, name, modal, fl )
{
  MIS_FileNameLineEdit->setFocus();
//  LINERadioButton->setDisable(true);
}

/*
 *  Destroys the object and frees any allocated resources
 */
ContactsExportSetup::~ContactsExportSetup()
{
    // no need to delete child widgets, Qt does it all for us
}

unsigned ContactsExportSetup::type()
{
 
  if ( VCARDRadioButton_enc->isChecked()  )
    return ContactsExportSetup::VCARD_ENC;
  else
    return ContactsExportSetup::OTHER;
}

/*
 * public slot
 */
void ContactsExportSetup::browseFiles_slot()
{
	fileName=QFileDialog::getSaveFileName(QString::null, "*", this);
	if( !fileName.isEmpty() )
	  MIS_FileNameLineEdit->setText(fileName);
}

/*
 * public slot
 */
void ContactsExportSetup::setFileName_slot(const QString& _fileName)
{
	fileName=_fileName;
}





