/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/*
 * This file is part of Magellan <http://www.kAlliance.org/Magellan>
 *
 * Copyright (c) 1998-2000 Teodor Mihai <teddy@ireland.com>
 * Copyright (c) 1998-2000 Laur Ivan <laur.ivan@ul.ie>
 * Copyright (c) 1999-2000 Virgil Palanciuc <vv@ulise.cs.pub.ro>
 *
 * Requires the Qt widget libraries, available at no cost at
 * http://www.troll.no/
 *
 * Also requires the KDE libraries, available at no cost at
 * http://www.kde.org/
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */

/** Changed by Eugen C. - 04 July 2001 */

#include <qptrlist.h>
#include <templateview.h>
#include <brokeriface.h>
#include <qdragobject.h>
#include <qstrlist.h>
#include <clipboard.h>
#include <qmessagebox.h>
// Need porting
//#include <maillistview.h>
//#include <clientrmi.h>
//#include <destinationdialog.h>
#include <clientvfs.h>
#include <datahandlerimpl.h>
#include <vobject.h>

DataHandlerImpl::DataHandlerImpl():OldDataHandler()
{
}

int DataHandlerImpl::copySelection()
{
  QPtrList<DataWidget> selectedViews=getSelection();
  QStrList uriList;
  TemplateView *tw;
  
  for(QPtrListIterator<DataWidget> it(selectedViews); it.current(); ++it)
  {
    tw=dynamic_cast<TemplateView *>((*it));
    if(tw)
      uriList.append((const char *)tw->path());
  }
  
  if(uriList.count())
    return ClipboardWrapper::thisInstance()->copyData(new QUriDrag(uriList));
  else
    return -1;
}

int DataHandlerImpl::cutSelection()
{
  QPtrList<DataWidget> selectedViews=getSelection();
  QStrList uriList;
  TemplateView *tw;
  
  for(QPtrListIterator<DataWidget> it(selectedViews); it.current(); ++it)
  {
    tw=dynamic_cast<TemplateView *>((*it));
    if(tw)
      uriList.append((const char *)tw->path());
  }
  
  if(uriList.count())
  {
    OldDataHandler::grayOutSelection();
    return ClipboardWrapper::thisInstance()->cutData(new QUriDrag(uriList));
  }
  else
    return -1;
}

void DataHandlerImpl::deleteSelection()
{
  QPtrList<DataWidget> selectedViews=getSelection();
  TemplateView *t;
  bool setExpungeMode=false;
  
  qDebug("DataHandlerImpl::deleteSelection: Need MailListView, ClientRMI and BrokerInterface here");
#if 0
  if(dynamic_cast<MailListView *>(this) && selectedViews.count()>1)
    setExpungeMode=true;
  
  if(setExpungeMode)
    ClientRMI::ref()->setAutoExpunge(false);
  
  for(QListIterator<DataWidget> it(selectedViews); it.current(); ++it)
  {
    t=dynamic_cast<TemplateView *>((*it));
    if( t )
    {
      if( it.atLast() && setExpungeMode )
        ClientRMI::ref()->setAutoExpunge(true);
      BrokerInterface::thisInstance()->remove(t->path());
    }
  }
#endif
}

void DataHandlerImpl::openSelection()
{
  QPtrList<DataWidget> selectedViews=getSelection();
  
  if (selectedViews.count()>PROGRESS_THRESHOLD)
  {
    if(QMessageBox::warning(0, "Confirm open", "You have selected a large number of items.\nOpening them could take a significant amount of time.\nAre you sure you want to open them?", QMessageBox::Yes, QMessageBox::No)==QMessageBox::Yes)
    {
      for(QPtrListIterator<DataWidget> it(selectedViews); it.current(); ++it)
        (*it)->open();
    }
  }
}

void DataHandlerImpl::sendSelection()
{
}

void DataHandlerImpl::printSelection()  
{
}

void DataHandlerImpl::paste()
{
  TemplateView *t=dynamic_cast<TemplateView *>(this);
  
  if(t && canPaste() && QUriDrag::canDecode(ClipboardWrapper::thisInstance()->data()))
  {
    QUriDrag *uriList=(QUriDrag *)ClipboardWrapper::thisInstance()->pasteData();
    QStrList pathList;
    QUriDrag::decode(uriList, pathList);
    bool shouldMove=ClipboardWrapper::thisInstance()->shouldCutSource();

    VFSModule * vfs = 0;
    ComponentTrader* trader = dynamic_cast<ComponentTrader*>(ComponentTrader::traderRef().instance());
    if( trader )
    {
      ComponentRef ref = trader->registeredComponent( AETHERA_VFS_SERVICE );
      if( ref.isValid() )
        vfs = static_cast<VFSModule*>(ref.instance());
    }

    if (0 == vfs)
    {
      qDebug("No VFS module ?");
      return;
    }

    if(shouldMove)
      vfs->move(pathList, t->path());
    else
      vfs->copy(pathList, t->path());
        
//    for(QStrListIterator it(pathList); it.current(); ++it)
//    {
//      QString sourcePath=(const char *)(*it);
//      
//      if(shouldMove)
//        // move source here
//        vfs->move(sourcePath, t->path());
//      else
//        // copy source here
//        vfs->copy(sourcePath, t->path());
//    }
  }
}

void DataHandlerImpl::copySelectionTo()
{
  qDebug("DataHandlerImpl::copySelectionTo: STUB");
  // Need DestinationDialog
#if 0
  if(!isSelectionEmpty())
  {
    TemplateView *t=dynamic_cast<TemplateView *>(childViews.at(0));
    if(t && dynamic_cast<VObject *>(t->getVItem()))
    {
      QString objectType=((VObject *)t->getVItem())->parentFolder()->mimeType();
      //VFolder *folder=ClientVFS::thisInstance()->folderRef(ContentsWidget::ref()->getCurrentFolder());
      DestinationDialog *d=new DestinationDialog("Copy", objectType, 0);
      int res=d->exec();

      if(res==QDialog::Accepted)
      {
        FolderTreeItem *selectedItem=d->selectedItem();
        QString filePath=selectedItem->getFilePath();

        if(filePath)
        {
          // export current selection
        }
        else
        {
          // move current selection 
          QList<DataWidget> selectedViews=getSelection();
          QString destFolder=selectedItem->path();

          for(QListIterator<DataWidget> it(selectedViews); it.current(); ++it)
          {
            t=dynamic_cast<TemplateView *>((*it));
            if( t )
              BrokerInterface::thisInstance()->copy(t->path(), destFolder);
          }
        }
      }         
      delete d;
    }
    else
    {
      printf("Warning: could not determine object mime type, bailing out\n");
    }
  }
  else
  {
    printf("Warning: there is nothing to copy, bailing out\n");
  }
#endif
}

void DataHandlerImpl::moveSelectionTo()
{
  qDebug("DataHandlerImpl::moveSelectionTo: STUB");
  // Needs DestinationDialog
#if 0
  // Need DestinationDialog
  if(!isSelectionEmpty())
  {
    TemplateView *t=dynamic_cast<TemplateView *>(childViews.at(0));
    if(t && dynamic_cast<VObject *>(t->getVItem()))
    {
      QString objectType=((VObject *)t->getVItem())->parentFolder()->mimeType();
      //VFolder *folder=ClientVFS::thisInstance()->folderRef(ContentsWidget::ref()->getCurrentFolder());
      DestinationDialog *d=new DestinationDialog("Move", objectType, 0);
      int res=d->exec();

      if(res==QDialog::Accepted)
      {
        FolderTreeItem *selectedItem=d->selectedItem();
        QString filePath=selectedItem->getFilePath();

        if(filePath)
        {
          // export current selection
        }
        else
        { 
          // move current selection 
          QList<DataWidget> selectedViews=getSelection();
          QString destFolder=selectedItem->path();
          TemplateView *t;

          bool setExpungeMode=false;

          if (dynamic_cast<MailListView *>(this)) {
            setExpungeMode=true;
            ClientRMI::ref()->setAutoExpunge(true);
          }

          for(QListIterator<DataWidget> it(selectedViews); it.current(); ++it)
          {
            t=dynamic_cast<TemplateView *>((*it));
            if( t )
            {
              if( it.atLast() && setExpungeMode )
                ClientRMI::ref()->setAutoExpunge(false);
              BrokerInterface::thisInstance()->copy(t->path(), destFolder);
            }
          }
        }
      }

      delete d;
    }
    else
    {
      printf("Warning: could not determine object mime type, bailing out\n");
    }
  }
  else
  {
    printf("Warning: there is nothing to move, bailing out\n");
  }
#endif
}

void DataHandlerImpl::saveSelection()
{
}

void DataHandlerImpl::editProperties()
{
}

void DataHandlerImpl::dragStart(QWidget *dragSource)
{
  QPtrList<DataWidget> selectedViews = getSelection();
  QStrList uriList;
  TemplateView *tw;

  for(QPtrListIterator<DataWidget> it(selectedViews); it.current(); ++it)
  {
    tw=dynamic_cast<TemplateView *>((*it));
    if(tw)
      uriList.append((const char *)tw->path());
  }

  if(uriList.count())
  {
    qDebug("Starting drag for %d items", uriList.count());
    OldDataHandler::grayOutSelection();
    QUriDrag *d = new QUriDrag(uriList, dragSource);
    d->drag();
  }
}

void DataHandlerImpl::dragEnter(QDragEnterEvent* event)
{
  event->accept(QUriDrag::canDecode(event));
}

void DataHandlerImpl::dragDrop(QDropEvent* event)
{
  TemplateView *t=dynamic_cast<TemplateView *>(this);
  QStrList pathList;

  if(t && QUriDrag::decode(event, pathList))
  {

    VFSModule * vfs = 0;
    ComponentTrader* trader = dynamic_cast<ComponentTrader*>(ComponentTrader::traderRef().instance());
    if( trader )
    {
      ComponentRef ref = trader->registeredComponent( AETHERA_VFS_SERVICE );
      if( ref.isValid() )
        vfs = static_cast<VFSModule*>(ref.instance());
    }
    
    if (0 == vfs)
    {
      qDebug("No VFS module ?");
      return;
    }

    for(QStrListIterator it(pathList); it.current(); ++it)
    {
      QString sourcePath=(const char *)(*it);

      vfs->move(sourcePath, t->path());
    }
  }
}

