/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/***************************************************************************
  komcontacts_main_tree_interface.h
                             -------------------
    begin                : Thu Nov  1 20:49:24 GMT 2001
    copyright            : (C) 2001 by theKompany.com
    author               : Rik Hemsley <rik@kde.org>
 ***************************************************************************/

#ifndef KOM_CONTACTS_MAIN_TREE_INTERFACE_H
#define KOM_CONTACTS_MAIN_TREE_INTERFACE_H

#include <komaetheraplugin.h>

class KomContactsMainTreeSlots;

class CONTACT_PLUGIN_API KomContactsMainTreeInterface : public KomMainTreeInterface
{
  public:

    enum ItemType
    {
      ItemTypeRoot = 0,
      ItemTypeGroup,
      ItemTypeLeaf
    };

    KomContactsMainTreeInterface(QListView * parentTree);

    virtual ~KomContactsMainTreeInterface();

    virtual void show();
    virtual void show(const QString & focus);
    virtual void hide();

    KomTreeItem * root();
    KomTreeItem * folderItem(const QString & url, bool create);

    virtual void createChildren(KomTreeItem *);

    virtual bool hasChild(KomTreeItem *);

    virtual QPopupMenu * contextMenu(KomTreeItem *);

    void updateVInstances(const QStringList &);
    void createVInstances(const QStringList &);
    void deleteVInstances(const QStringList &);
    void updateHierarchy(const QString &);

    void createVFolder
      (
        const QString & parentFolderPath,
        const QString & folderName,
        const QString & type,
        const QString & subType,
        const QString & serverPath
      );

    void deleteVFolder
      (
        const QString & parentFolderPath,
        const QString & folderName,
        const QString & type
      );

    virtual QObject * qObject();

    KomTreeItem * findChild(KomTreeItem * root, const QString & name);

    virtual QString name() const { return "Contacts"; }

  private:
    KomTreeItem * createFolderItem
      (KomTreeItem * parentItem, const QString & vfsPath, const QString & type);

    QPopupMenu                * m_popupMenu;
    KomContactsMainTreeSlots  * m_slots;
    KomTreeItem               * m_currentItem;
    KomTreeItem               * m_root;
};

#endif
// vim:tabstop=2:shiftwidth=2:expandtab:cinoptions=(s,U1,m1
