/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/***************************************************************************
    komcontactsmaintreeslots.h
                             -------------------
    begin                : Fri Nov  2 12:23:13 GMT 2001
    copyright            : (C) 2001 by theKompany.com
                           (C) 2004 by Atol C&D
    author               : Rik Hemsley <rik@kde.org>
                           Fabien Armand <far@atolcd.com>
 ***************************************************************************/

#ifndef KOM_CONTACTS_MAIN_TREE_SLOTS_H
#define KOM_CONTACTS_MAIN_TREE_SLOTS_H

#include <qobject.h>

#include <defines.h>

class KomContactsMainTreeInterface;

class CONTACT_PLUGIN_API KomContactsMainTreeSlots : public QObject
{
  Q_OBJECT

  public:

    KomContactsMainTreeSlots
      (
        KomContactsMainTreeInterface * parent,
        const char * name
      );

    virtual ~KomContactsMainTreeSlots();

  public slots:

    void slotCreate(const QString &);

    void slotNewContact();
    void slotDeleteContact();
    void slotEditContact();
    void slotNewContactGroup();
    void slotDeleteContactGroup();
    void slotMoveContactGroup();
    void slotRenameContactGroup();
    void slotExpungeContactGroup();
    void slotSearchForSharedFolders();
    
    void slotKolabSynch();

    void slotUpdateVInstances(const QStringList &);
    void slotCreateVInstances(const QStringList &);
    void slotDeleteVInstances(const QStringList &);
    void slotUpdateHierarchy(const QString &);

    void slotCreateVFolder
      (
        const QString & parentFolderPath,
        const QString & folderName,
        const QString & type,
        const QString & subType,
        const QString & serverPath
      );

    void slotDeleteVFolder
      (
        const QString & parentFolderPath,
        const QString & folderName,
        const QString & type
      );

  private:

    KomContactsMainTreeInterface * m_mainTreeInterface;
    QString m_toBeEditedWhenCreated;
};

#endif
// vim:tabstop=2:shiftwidth=2:expandtab:cinoptions=(s,U1,m1
