/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/*
 * This file is part of Magellan <http://www.kAlliance.org/Magellan>
 *
 * Copyright (c) 1998-2000 Teodor Mihai <teddy@ireland.com>
 * Copyright (c) 1998-2000 Laur Ivan <laur.ivan@ul.ie>
 * Copyright (c) 1999-2000 Virgil Palanciuc <vv@ulise.cs.pub.ro>
 *
 * Requires the Qt widget libraries, available at no cost at
 * http://www.troll.no/
 *
 * Also requires the KDE libraries, available at no cost at
 * http://www.kde.org/
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
 * IN THE SOFTWARE.
 */

#ifndef HAS_OBJECT_LIST
#define HAS_OBJECT_LIST

#include <qvaluelist.h>
#include <qtextstream.h>

#include <metaobject.h>

class CONTACT_PLUGIN_API ObjectDetails
{
	MetaObject *mObj;
	int parentUID;
	int UID;
	int level;
	int nestIndex;
public:
	ObjectDetails(MetaObject *mo=NULL, int uid=-1, 
			int l=-1, int ni=-1, int puid=-1);
	~ObjectDetails() { if(mObj) delete mObj; };
	// get *
	int getLevel() 						{ return level;     };
	int getUID()							{ return UID;       };
	int getNestIndex()				{ return nestIndex; };
	int getParentUID()				{ return parentUID; };
	MetaObject *getObject()		{ return mObj;      };
	// set *
	void setObject(MetaObject *mo)	{ mObj = mo;      };
	void setLevel(int l) 						{ level = l;      };
	void setUID(int uid)						{ UID = uid;      };
	void setNestIndex(int ni)				{ nestIndex=ni;   };
	void setParentUID(int puid)			{ parentUID=puid; };
};

#define DELETE_OP				1


#ifdef Q_WS_WIN
#if defined(Q_TEMPLATEDLL)
// MOC_SKIP_BEGIN
template class CONTACT_PLUGIN_API QValueList<ObjectDetails *>;
template class CONTACT_PLUGIN_API QValueList<int>;
// MOC_SKIP_END
#endif
#endif

class CONTACT_PLUGIN_API ObjectsList
{
	QValueList<ObjectDetails *> elements;
	static int localUID;
	void init(QTextStream &str);
	bool indexedOperation(int parent=-1, int operation=DELETE_OP, int offset=0);
public:
	ObjectsList(MetaObject *mo=NULL);
	ObjectsList(QString list);
	~ObjectsList();
	void addObject(MetaObject *mo=NULL, int level=0, int idx=-1, int puid=-1);
	void addObject(QString objstr);
	bool deleteObject(int objectUID); // deletes only if is level=0
	QValueList<int> nameQuery(QString name); // the object's type (VEVENT...)
	MetaObject *operator[] (int uid);
	QString recompose();
	int getLocalUID() { return localUID++; };
	
	
};

#endif








