/*!
  ______________________________________________________________________________
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.

               COPYRIGHT   : (C) 2003 by theKompany.com
  ______________________________________________________________________________

  \date 5 July 2003
  \author Iulian Ghiciuc <ilie@eco-spaces.com.ro>
  \file AutoGetMail class declaration

*/

#ifndef AUTO_GET_MAIL_H
#define AUTO_GET_MAIL_H

/*!
  \class AutoGetMail

  \brief AutoGetMail will automate email receive

  \bug

  Created because we needed to automate the email receive action. One sholud obtain
  a pointer to a AutoGetMail class by a call to the @see instance() method. After it is started
  the "service" will read the settings to see weather it should run the periodical check to
  see if there is new mail.
*/

//QT includes
#include <qobject.h>
#include <qtimer.h>
#include <qstringlist.h>

 //clientskel includes
#include <clientrmi.h>

//aethera includes
#include <appstatus.h>

class AutoGetMail : public QObject
{
  Q_OBJECT

  public:
   static AutoGetMail* instance();
   ~AutoGetMail();

    void start();
   
  public slots:
    void fetchMail(  );

  private:
    AutoGetMail( QObject* parent=0L, const char* name=0L );
    
    void readSettings();

    unsigned int interval;
    bool isOn;
    bool readAll;

    QTimer* timer;

    ClientRMI* clientRMI;
    QStringList accounts;

    AppStatus* status;
};

#endif //AUTO_GET_MAIL_H


