/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/***************************************************************************
    foldernamerequestdialog.cpp
                             -------------------
    begin                : Sat Nov 24 13:25:28 GMT 2001
    copyright            : (C) 2001 by theKompany.com
    author               : Rik Hemsley <rik@kde.org>
 ***************************************************************************/

#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>
#include <qlayout.h>

#include <foldernamerequestdialog.h>
#include <defines.h>

  FolderInfo
FolderNameRequestDialog::getFolderInfo(QWidget * parent)
{
  FolderNameRequestDialog dialog(parent, "FolderNameRequestDialog");

  FolderInfo fi;

  if (QDialog::Accepted != dialog.exec())
  {
    return fi; // Empty info/
  }

  fi.name = dialog.folderName();

  fi.containerOnly = dialog.containerOnly();

  return fi;
}

FolderNameRequestDialog::FolderNameRequestDialog
(
  QWidget * parent,
  const char * name
)
  : QDialog(parent, name, true)
{
  setCaption(tr("Folder information"));

  QLabel * l = new QLabel(tr("Folder name"), this);

  nameEdit_ = new QLineEdit(this);

  l->setBuddy(nameEdit_);

  QButtonGroup * buttonGroup =
    new QButtonGroup(1, Vertical, tr("Folder type"), this);

#ifndef _QTWIN_
#warning FIXME: re-word text...
#endif

  containerOnlyButton_ =
    new QRadioButton(tr("Container only"), buttonGroup);

  (void) new QRadioButton(tr("May contain mail"), buttonGroup);

  QPushButton * okButton = new QPushButton(tr("&Ok"), this);
  QPushButton * cancelButton = new QPushButton(tr("&Cancel"), this);

  okButton->setAutoDefault(true);
  okButton->setDefault(true);

  QVBoxLayout * layout = new QVBoxLayout(this, 6, 4);

  QHBoxLayout * nameLayout = new QHBoxLayout(layout);

  nameLayout->addWidget(l);
  nameLayout->addWidget(nameEdit_);

  layout->addWidget(buttonGroup);

  QHBoxLayout * buttonLayout = new QHBoxLayout(layout);

  buttonLayout->addStretch(1);

  buttonLayout->addWidget(okButton);
  buttonLayout->addWidget(cancelButton);

  nameEdit_->setFocus();

  connect(okButton, SIGNAL(clicked()), SLOT(accept()));
  connect(cancelButton, SIGNAL(clicked()), SLOT(reject()));
}

FolderNameRequestDialog::~FolderNameRequestDialog()
{
  // Empty.
}

QString FolderNameRequestDialog::folderName() const
{
  return nameEdit_->text();
}

bool FolderNameRequestDialog::containerOnly() const
{
  return containerOnlyButton_->isOn();
}

// vim:tabstop=2:shiftwidth=2:expandtab:cinoptions=(s,U1,m1
