/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/***************************************************************************
 kommailconfigservice.cpp
 -  The accounts configuration service for the mail plug in
                             -------------------
    begin                : Thu Sep 27 15:55:16 EEST 2001
    copyright            : (C) 2001 by theKompany.com
    author               : Rik Hemsley <rik@kde.org>
 ***************************************************************************/

#include <kommailconfigservice.h>
#include <mailconfigserviceprivate.h>
#include <accountmanagerwidget.h>

#include <qsettings.h>
#include <qapplication.h>

//tkcBase includes
#include <qiconloader.h>

class KomMailConfigService::Private
{
  public:

    AccountManagerWidget      * widget;
    MailConfigServicePrivate  * qtHandler;
};

/*
static const char* kommailconfigservice_metainfo[][2]=
{
    { "/name", "Kom Mail Config Service" },
    { "/class", "KomMailConfigService" },
    { "/class/fqn", "KomMailConfigService" },
    { "/factory", "kommailconfigservice_factory" },
    { 0, 0 }
};
*/

kore::Interface* kommailconfigservice_factory()
{
  return new KomMailConfigService();
}
    
KomMailConfigService::KomMailConfigService()
  : KomConfigService()
{
  MetaInfo *info = metaInfo();
  
  info->replaceAll("name", "Kom Mail Config Service");
  info->replaceAll("class", "KomMailConfigService");
  info->replaceAll("class/fqn", "KomMailConfigService");
  info->replaceAll("factory", "kommailconfigservice_factory");
  info->replaceAll("description", "Accounts settings");
  
  
  d = new Private;
  d->widget 		= 0;
	d->qtHandler 	= 0;
}

KomMailConfigService::~KomMailConfigService()
{
	delete d->qtHandler;
	d->qtHandler = 0;
  delete d->widget;
  d->widget = 0;
  delete d;
}

  QWidget *
KomMailConfigService::init(QWidget * parent)
{
	if (0 == d->widget)
	{
		d->widget =
			new AccountManagerWidget(parent, "KomMailConfigService top widget");
	}

  return d->widget;
}

	void
KomMailConfigService::load()
{
	if (0 != d->widget)
		d->widget->load();
}

	void
KomMailConfigService::save()
{
	if (0 != d->widget)
		d->widget->save();
}

	void
KomMailConfigService::defaults()
{
	if (0 != d->widget)
		d->widget->defaults();
}

QPixmap KomMailConfigService::icon()
{
  return QIconLoader::instance()->loadIcon( "MailCenter_SndRcv.png" );
}

	QString
KomMailConfigService::caption()
{
  return QObject::tr("Mail/Accounts");
}

	bool
KomMailConfigService::modified()
{
	return false;
}

	QObject *
KomMailConfigService::createQTHandler()
{ 
	if (0 != d->qtHandler)
		return d->qtHandler;

	d->qtHandler = new MailConfigServicePrivate(this);

	return d->qtHandler;
}

	QObject *
KomMailConfigService::getQTHandler()
{ 
	createQTHandler();

	return d->qtHandler;
}


// vim:ts=2:sw=2:tw=78:noet


