/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/***************************************************************************
                   kommailplugin.cpp  -  The Mail plug in
                             -------------------
    begin                : Thu Sep 27 15:55:16 EEST 2001
    copyright            : (C) 2001 by theKompany.com
    author               : Eugen C. <eug@thekompany.com>
 ***************************************************************************/

#include <kommailplugin.h>

#include <kommailuiservice.h>
#include <kommailbackendservice.h>
#include <kompartbackendservice.h>
#include <kommailconfigservice.h>
#include <komsendreceiveconfigservice.h>
#include <composerconfigservice.h>
#include <mailagentservice.h>


static const char* libkommailplugin_metainfo[][2]=
{
    { "/kore/library", "~kommailplugin" },
    { "~kommailplugin/name", "kommailplugin" },
    { "~kommailplugin/description", "provides the Mail components" },
    { "~kommailplugin/component", "~KomMailUIService" },
    { "~kommailplugin/component", "~MailWrapperConfigService" },    
    { "~kommailplugin/component", "~KomMailConfigService" },
    { "~kommailplugin/component", "~KomSendReceiveConfigService" },
    { "~kommailplugin/component", "~KomMailBackendService" },
    { "~kommailplugin/component", "~KomIMAPBackendService" },
    { "~kommailplugin/component", "~KomPartBackendService" },
    { "~kommailplugin/component", "~ComposerConfigService" },
    { "~kommailplugin/component", "~MailAgentService" },
    { "~kommailplugin/component", "~MailLanguageService" },
//
    { "~KomMailUIService/name", "Kom Mail UI Service" },
    { "~KomMailUIService/type", "Plugin" },
    { "~KomMailUIService/class", "KomMailUIService" },
    { "~KomMailUIService/class/fqn", "KomMailUIService" },
    { "~KomMailUIService/factory", "kommailuiservice_factory" },
    { "~KomMailUIService/description", AETHERA_UISERVICE_DESC },
    { "~KomMailUIService/version", "0.2.0" },
    { "~KomMailUIService/version/major", "0" },
    { "~KomMailUIService/version/minor", "2" },
    { "~KomMailUIService/version/release", "0" },
    { "~KomMailUIService/api/version", "0.2.0" },
    { "~KomMailUIService/api/version/major", "0" },
    { "~KomMailUIService/api/version/minor", "2" },
    { "~KomMailUIService/api/version/release", "0" },
    { "~KomMailUIService/service", "/kore/service/interface" },
    { "~KomMailUIService/service", PART_SERVICE },
    { "~KomMailUIService/service", AETHERA_SERVICE },
    { "~KomMailUIService/service", AETHERA_UISERVICE },
//
    { "~MailWrapperConfigService/name", "MailWrapperConfigService" },
    { "~MailWrapperConfigService/class", "MailWrapperConfigService" },
    { "~MailWrapperConfigService/class/fqn", "MailWrapperConfigService" },
    { "~MailWrapperConfigService/factory", "mailwrapperconfigservice_factory" },
    { "~MailWrapperConfigService/type", "Plugin" },
    { "~MailWrapperConfigService/description",  AETHERA_CONFIGSERVICE_DESC },
    { "~MailWrapperConfigService/version", "0.2.0" },
    { "~MailWrapperConfigService/version/major", "0" },
    { "~MailWrapperConfigService/version/minor", "2" },
    { "~MailWrapperConfigService/version/release", "0" },
    { "~MailWrapperConfigService/api/version", "0.2.0" },
    { "~MailWrapperConfigService/api/version/major", "0" },
    { "~MailWrapperConfigService/api/version/minor", "2" },
    { "~MailWrapperConfigService/api/version/release", "0" },
    { "~MailWrapperConfigService/service", "/kore/service/interface" },
    { "~MailWrapperConfigService/service", AETHERA_SERVICE },
    { "~MailWrapperConfigService/service", AETHERA_CONFIGSERVICE },
//
    { "~KomMailConfigService/name", "Kom Mail Config Service" },
    { "~KomMailConfigService/type", "Plugin" },
    { "~KomMailConfigService/class", "KomMailConfigService" },
    { "~KomMailConfigService/class/fqn", "KomMailConfigService" },
    { "~KomMailConfigService/factory", "kommailconfigservice_factory" },
    { "~KomMailConfigService/description",  "Accounts settings" },
    { "~KomMailConfigService/version", "0.2.0" },
    { "~KomMailConfigService/version/major", "0" },
    { "~KomMailConfigService/version/minor", "2" },
    { "~KomMailConfigService/version/release", "0" },
    { "~KomMailConfigService/api/version", "0.2.0" },
    { "~KomMailConfigService/api/version/major", "0" },
    { "~KomMailConfigService/api/version/minor", "2" },
    { "~KomMailConfigService/api/version/release", "0" },
    { "~KomMailConfigService/service", "/kore/service/interface" },
    { "~KomMailConfigService/service", AETHERA_SERVICE },
    { "~KomMailConfigService/service", AETHERA_CONFIGSERVICE },
//
    { "~KomSendReceiveConfigService/name", "Kom SendReceive Config Service" },
    { "~KomSendReceiveConfigService/type", "Plugin" },
    { "~KomSendReceiveConfigService/class", "KomSendReceiveConfigService" },
    { "~KomSendReceiveConfigService/class/fqn", "KomSendReceiveConfigService" },
    { "~KomSendReceiveConfigService/factory", "komsendreceiveconfigservice_factory" },
    { "~KomSendReceiveConfigService/description",  "Send and receive settings" },
    { "~KomSendReceiveConfigService/version", "0.2.0" },
    { "~KomSendReceiveConfigService/version/major", "0" },
    { "~KomSendReceiveConfigService/version/minor", "2" },
    { "~KomSendReceiveConfigService/version/release", "0" },
    { "~KomSendReceiveConfigService/api/version", "0.2.0" },
    { "~KomSendReceiveConfigService/api/version/major", "0" },
    { "~KomSendReceiveConfigService/api/version/minor", "2" },
    { "~KomSendReceiveConfigService/api/version/release", "0" },
    { "~KomSendReceiveConfigService/service", "/kore/service/interface" },
    { "~KomSendReceiveConfigService/service", AETHERA_SERVICE },
    { "~KomSendReceiveConfigService/service", AETHERA_CONFIGSERVICE },
//
    { "~KomMailBackendService/name", "Kom Mail Backend Service" },
    { "~KomMailBackendService/type", "Plugin" },
    { "~KomMailBackendService/class", "KomMailBackendService" },
    { "~KomMailBackendService/class/fqn", "KomMailBackendService" },
    { "~KomMailBackendService/factory", "kommailbackendservice_factory" },
    { "~KomMailBackendService/description",  AETHERA_MAIL_BACKENDSERVICE_DESC },
    { "~KomMailBackendService/version", "0.2.0" },
    { "~KomMailBackendService/version/major", "0" },
    { "~KomMailBackendService/version/minor", "2" },
    { "~KomMailBackendService/version/release", "0" },
    { "~KomMailBackendService/api/version", "0.2.0" },
    { "~KomMailBackendService/api/version/major", "0" },
    { "~KomMailBackendService/api/version/minor", "2" },
    { "~KomMailBackendService/api/version/release", "0" },
    { "~KomMailBackendService/service", "/kore/service/interface" },
    { "~KomMailBackendService/service", AETHERA_SERVICE },
    { "~KomMailBackendService/service", AETHERA_BACKENDSERVICE },
    { "~KomMailBackendService/service",  AETHERA_MAIL_BACKENDSERVICE },
//
    { "~KomIMAPBackendService/name", "Kom IMAP Backend Service" },
    { "~KomIMAPBackendService/type", "Plugin" },
    { "~KomIMAPBackendService/class", "KomIMAPBackendService" },
    { "~KomIMAPBackendService/class/fqn", "KomIMAPBackendService" },
    { "~KomIMAPBackendService/factory", "komimapbackendservice_factory" },
    { "~KomIMAPBackendService/description",  AETHERA_MAIL_BACKENDSERVICE_DESC },
    { "~KomIMAPBackendService/version", "0.2.0" },
    { "~KomIMAPBackendService/version/major", "0" },
    { "~KomIMAPBackendService/version/minor", "2" },
    { "~KomIMAPBackendService/version/release", "0" },
    { "~KomIMAPBackendService/api/version", "0.2.0" },
    { "~KomIMAPBackendService/api/version/major", "0" },
    { "~KomIMAPBackendService/api/version/minor", "2" },
    { "~KomIMAPBackendService/api/version/release", "0" },
    { "~KomIMAPBackendService/service", "/kore/service/interface" },
    { "~KomIMAPBackendService/service", AETHERA_SERVICE },
    { "~KomIMAPBackendService/service", AETHERA_BACKENDSERVICE },
    { "~KomIMAPBackendService/service",  AETHERA_MAIL_BACKENDSERVICE },
//
    { "~KomPartBackendService/name", "Kom Mail Part Backend Service" },
    { "~KomPartBackendService/type", "Plugin" },
    { "~KomPartBackendService/class", "KomPartBackendService" },
    { "~KomPartBackendService/class/fqn", "KomPartBackendService" },
    { "~KomPartBackendService/factory", "kompartbackendservice_factory" },
    { "~KomPartBackendService/description",  AETHERA_PART_BACKENDSERVICE_DESC },
    { "~KomPartBackendService/version", "0.2.0" },
    { "~KomPartBackendService/version/major", "0" },
    { "~KomPartBackendService/version/minor", "2" },
    { "~KomPartBackendService/version/release", "0" },
    { "~KomPartBackendService/api/version", "0.2.0" },
    { "~KomPartBackendService/api/version/major", "0" },
    { "~KomPartBackendService/api/version/minor", "2" },
    { "~KomPartBackendService/api/version/release", "0" },
    { "~KomPartBackendService/service", "/kore/service/interface" },
    { "~KomPartBackendService/service", AETHERA_SERVICE },
    { "~KomPartBackendService/service", AETHERA_BACKENDSERVICE },
    { "~KomPartBackendService/service",  AETHERA_PART_BACKENDSERVICE },
//
    { "~ComposerConfigService/name", "Composer Config Service" },
    { "~ComposerConfigService/type", "Plugin" },
    { "~ComposerConfigService/class", "ComposerConfigService" },
    { "~ComposerConfigService/class/fqn", "ComposerConfigService" },
    { "~ComposerConfigService/factory", "composerconfigservice_factory" },
    { "~ComposerConfigService/description",  "Composer preferences" },
    { "~ComposerConfigService/version", "0.2.0" },
    { "~ComposerConfigService/version/major", "0" },
    { "~ComposerConfigService/version/minor", "2" },
    { "~ComposerConfigService/version/release", "0" },
    { "~ComposerConfigService/api/version", "0.2.0" },
    { "~ComposerConfigService/api/version/major", "0" },
    { "~ComposerConfigService/api/version/minor", "2" },
    { "~ComposerConfigService/api/version/release", "0" },
    { "~ComposerConfigService/service", "/kore/service/interface" },
    { "~ComposerConfigService/service", AETHERA_SERVICE },
    { "~ComposerConfigService/service", AETHERA_CONFIGSERVICE },
//
    { "~MailAgentService/name", "Mail Agent Service" },
    { "~MailAgentService/type", "Plugin" },
    { "~MailAgentService/class", "MailAgentService" },
    { "~MailAgentService/class/fqn", "MailAgentService" },
    { "~MailAgentService/factory", "mailagentservice_factory" },
    { "~MailAgentService/description",  "A email transport agent service" },
    { "~MailAgentService/version", "0.2.0" },
    { "~MailAgentService/version/major", "0" },
    { "~MailAgentService/version/minor", "2" },
    { "~MailAgentService/version/release", "0" },
    { "~MailAgentService/api/version", "0.2.0" },
    { "~MailAgentService/api/version/major", "0" },
    { "~MailAgentService/api/version/minor", "2" },
    { "~MailAgentService/api/version/release", "0" },
    { "~MailAgentService/service", "/kore/service/interface" },
    { "~MailAgentService/service", AETHERA_SERVICE },
    { "~MailAgentService/service", MAILAGENT_SERVICE },
//
    { "~MailLanguageService/name", "Mail Language Service" },
    { "~MailLanguageService/type", "Plugin" },
    { "~MailLanguageService/class", "MailLanguageService" },
    { "~MailLanguageService/class/fqn", "MailLanguageService" },
    { "~MailLanguageService/factory", "maillanguageservice_factory" },
    { "~MailLanguageService/description",  AETHERA_LANGUAGESERVICE_DESC },
    { "~MailLanguageService/version", "0.2.0" },
    { "~MailLanguageService/version/major", "0" },
    { "~MailLanguageService/version/minor", "2" },
    { "~MailLanguageService/version/release", "0" },
    { "~MailLanguageService/api/version", "0.2.0" },
    { "~MailLanguageService/api/version/major", "0" },
    { "~MailLanguageService/api/version/minor", "2" },
    { "~MailLanguageService/api/version/release", "0" },
    { "~MailLanguageService/service", "/kore/service/interface" },
    { "~MailLanguageService/service", AETHERA_SERVICE },
    { "~MailLanguageService/service", AETHERA_LANGUAGESERVICE },
    { 0, 0 }
};


// the metainfo should be generated dynamicaly but I am not ready
// see the static methods from KomAetheraService 
kore::MetaInfo* kommailplugin_metainfo()
{
  static kore::MetaInfo* info = 0;
  if( !info )
  {
    info = new kore::MetaInfo(libkommailplugin_metainfo);
  }
  return info;
}

