/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/***************************************************************************
                    kommailtreeitem.h  -  Mail tree item
                             -------------------
    begin                : Thu Mar 7 2002
    copyright            : (C) 2002 by theKompany.com
    email                : eug@thekompany.com
 ***************************************************************************/


#ifndef KOMMAILTREEITEM_H
#define KOMMAILTREEITEM_H

#include <kommaintreeitem.h>
#include <defines.h>

class VFolder;
class VFolderAttribute;

/** Mail tree needs it for showing with bold the folders which has unread mails.
  * Also the messages numbers are useful.
  * @author Eugen C.
  */

class MAIL_PLUGIN_API KomMailTreeItem : public KomTreeItem  
{
  public: 
    KomMailTreeItem( QListView * parent, KomItemType& treeItemType );
    KomMailTreeItem( KomTreeItem* parent, KomItemType& treeItemType );
    virtual ~KomMailTreeItem();
    
    /** Paint the mail folders different if there are unread messages.*/
    virtual void paintCell(QPainter *p, const QColorGroup &cg, int column, int width, int align);
    
    /** @return the VFS path.*/
    virtual QString path();
    
    /** @return true if there are unread mails in the folder.*/
    virtual bool hasUnreadMails();
    
    virtual bool isKolabFolder() const;
    
    /** just force the folder attribute update.*/
    virtual void forceUpdate();
    
  private:
    VFolder * folder;
    VFolderAttribute * folderAttribute;
    
    unsigned recent;
    bool bUpdate;
};

#endif
