/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/***************************************************************************
         kommailuiservice.cpp  -  The UI service for the Mail plug in
                             -------------------
    begin                : Thu Sep 27 15:55:16 EEST 2001
    copyright            : (C) 2001 by theKompany.com
    author               : Eugen C. <eug@thekompany.com>
 ***************************************************************************/

#include <kommailuiservice.h>
#include <kommailbackendservice.h>
#include <kommailmaintreeinterface.h>
#include <mailuipartprivate.h>
#include <mailwindow.h>
#include <clientrmi.h>
#include <popupaction.h>
#include <autogetmail.h>

// QT includes
#include <qpixmap.h>
#include <qtoolbar.h>
#include <qmenubar.h>
#include <qmessagebox.h>
#include <qheader.h>

/*
static const char* kommailuiservice_metainfo[][2]=
{
    { "/name", "KomMail UI Service" },
    { "/class", "KomMailUIService" },
    { "/class/fqn", "KomMailUIService" },
    { "/factory", "kommailuiservice_factory" },
    { 0, 0 }
};
*/

kore::Interface* kommailuiservice_factory()
{
  return new KomMailUIService();
}
    
KomMailUIService::KomMailUIService()
  : KomUserInterfaceService (),
    mailsMenu               (0),
    actionsMenu             (0),
    actionsReplyMenu        (0),
    actionsForwardMenu      (0),
    actionsGoToMenu         (0),
    toolsMenu               (0),
    toolsSendReceiveMenu    (0),
    toolsSendMenu           (0),
    toolsReceiveMenu        (0),
    editMenu                (0),
    editMarkMenu            (0),
    optionsMenu             (0),
    windowMenu              (0),
    windowShowMenu          (0),
    windowHideMenu          (0),
    windowCloseMenu         (0),
    mailsMenuId             (-1),
    actionsMenuId           (-1),
    actionsReplyMenuId      (-1),
    actionsForwardMenuId    (-1),
    actionsGoToMenuId       (-1),
    toolsMenuId             (-1),
    toolsSendReceiveMenuId  (-1),
    toolsSendMenuId         (-1),
    toolsReceiveMenuId      (-1),
    editMenuId              (-1),
    editMarkMenuId          (-1),
    optionsMenuId           (-1),
    windowMenuId            (-1),
    windowShowMenuId        (-1),
    windowHideMenuId        (-1),
    windowCloseMenuId       (-1),
    topWidget               (0),
    topWidgetLayout         (0),
    topBannerWidget         (0),
    topViewWidget           (0),
    topMainBanner           (0),
    topMainView             (0),
    bActions                (false),
    m_mainTreeInterface     (0)
{
  MetaInfo *info = metaInfo();
  
  info->replaceAll("name", "Kom Mail UI Service");
  info->replaceAll("class", "KomMailUIService");
  info->replaceAll("class/fqn", "KomMailUIService");
  info->replaceAll("factory", "kommailuiservice_factory");
  
  pluginIcon.setPixmap
    (
      BarIcon(MAIL_ACTIVE),
      QIconSet::Large,
      QIconSet::Active,
      QIconSet::Off
    );

  pluginIcon.setPixmap
    (
      BarIcon(MAIL_NORMAL),
      QIconSet::Large,
      QIconSet::Normal,
      QIconSet::Off
    );

  _mimeType = VFS_MAILS_MIMETYPE;

  AutoGetMail* autoGetMail = 0L;
  autoGetMail = AutoGetMail::instance();
  if( autoGetMail )
    autoGetMail->start();
}

KomMailUIService::~KomMailUIService()
{
  if( m_mainTreeInterface )
  {
    delete m_mainTreeInterface;
    m_mainTreeInterface = 0L;
  }
}

UIPartPrivate *KomMailUIService::createQTHandler(void)
{
  return new MailUIPartPrivate(this);
}

bool KomMailUIService::hasCapability(const QString& capabilityName)
{
  if( KomUserInterfaceService::hasCapability(capabilityName) )
    return true;
  else
  {
    if( capabilityName == TOP_WIDGET || 
        capabilityName == BANNER_WIDGET ||
        capabilityName == PLUGIN_ICONSET ||
        capabilityName == TREE_INTERFACE )
      return true;
  }

  return false;
}

void KomMailUIService::createWidget(const QString& capabilityName)
{
  if( capabilityName==TOP_WIDGET )
  {
    if ( topWidget==NULL )
    {
      // Get the qt handler for the connections
      MailUIPartPrivate *partHandler = (MailUIPartPrivate*) getQTHandler();
      VFSModule * vfs = 0;
      ComponentTrader* trader = dynamic_cast<ComponentTrader*>(ComponentTrader::traderRef().instance());
      if( trader )
      {
        ComponentRef ref = trader->registeredComponent( AETHERA_VFS_SERVICE );
        if( ref.isValid() )
          vfs = static_cast<VFSModule*>(ref.instance());
      }
      
      Q_ASSERT(0 != vfs);
      
      topWidget = new QWidget(0, "MailTopWidget");
      topWidgetLayout = new QVBoxLayout( topWidget );
      topViewWidget = new KomContainerWidget( topWidget, "MailViewWidget" );

      // Build the widgets
      topGeneralView = new QWidget(topWidget);
      topViewWidget->addChildWidget( topGeneralView );
      topViewWidget->showChild( topGeneralView );
      topMainView = new MailWindow(vfs, topWidget);
      topViewWidget->addChildWidget( topMainView );
      topViewWidget->showChild( topMainView );

      topWidgetLayout->addWidget( topViewWidget, 1 );

      // Add the main widget to the plug in widgets dict.
      widgetDict.insert( TOP_WIDGET, topWidget);
      
      // Make the connections
      QObject::connect( partHandler, SIGNAL(updateVInstances(const QStringList&)),
                        topMainView, SLOT(slotUpdateVInstances(const QStringList&)) );
      QObject::connect( partHandler, SIGNAL(createVInstances(const QStringList&)),
                        topMainView, SLOT(slotCreateVInstances(const QStringList&)) );
      QObject::connect( partHandler, SIGNAL(deleteVInstances(const QStringList&)),
                        topMainView, SLOT(slotDeleteVInstances(const QStringList&)) );
    }
  }
  else if( capabilityName==BANNER_WIDGET )
  {
    if( topBannerWidget==NULL )
    {
      topBannerWidget = new KomContainerWidget( 0, "MailBannerWidget" );
      topMainBanner = new QWidget(0);
      
      QHBoxLayout *bannerLayout = new QHBoxLayout(topMainBanner);
      QLabel *leftBanner= new QLabel(topMainBanner);
      leftBanner->setPixmap( BarIcon(MAIL_BANNER_LEFT) );
      QLabel *rightBanner= new QLabel(topMainBanner);
      rightBanner->setPixmap( BarIcon(MAIL_BANNER_RIGHT) );
      
      bannerLayout->addWidget(leftBanner);
      bannerLayout->addStretch();
      bannerLayout->addWidget(rightBanner);
      
      topBannerWidget->addChildWidget( topMainBanner );
      topBannerWidget->showChild( topMainBanner );
      
      // Add the banner widget to the plug in widgets dict.
      widgetDict.insert( BANNER_WIDGET, topBannerWidget);
    }
  }
  else if( capabilityName==TREE_INTERFACE )
  {
  // TODO
  }
}

void KomMailUIService::createActions()
{
  if( !actionDict.size() || !actionDict.find( NEW_MAIL_ID ) )
  {
    // Create the common actions
    KomUserInterfaceService::createActions();
    
    QAction *action;
    
    // Create the new mail action
    action = new QAction( QObject::tr("Create a new mail"),
                                   QIconLoader::instance()->iconSet( NEW_MAIL_BUTTON ),
                                   QObject::tr("&New"),
                                   QKeySequence( QObject::tr("Ctrl+N", "Mail|New")),
                                   (QObject*)topWidget );
    actionDict.insert( NEW_MAIL_ID, action);

    // Create the toolbar send and receive action
    PopupAction * popupAction = new PopupAction(
      QObject::tr("Send and receive using the default account."),
      QIconLoader::instance()->iconSet( SEND_RECEIVE_BUTTON ),
      QObject::tr("&Send Receive"),
      QKeySequence( QObject::tr("Ctrl+S", "Tools|SendReceive")),
      (QObject*)topWidget );
    actionDict.insert( SEND_RECEIVE_ID, popupAction);

    // Create the forward mail action
    action = new QAction( QObject::tr("Forward the email."),
                          QIconLoader::instance()->iconSet(FORWARD_BUTTON  ),
                          QObject::tr("&Forward"),
                          QKeySequence( QObject::tr("Ctrl+F", "Actions|Forward")),
                          (QObject*)topWidget );
    actionDict.insert( FORWARD_ID, action);

    // Create the reply mail action
    action = new QAction( QObject::tr("Reply the mail."),
                          QIconLoader::instance()->iconSet( REPLY_BUTTON ),
                          QObject::tr("&Reply"),
                          QKeySequence( QObject::tr("Ctrl+R", "Actions|Reply")),
                          (QObject*)topWidget );
    actionDict.insert( REPLY_ID, action);

    // Create the replyall mail action
    action = new QAction( QObject::tr("Reply the mail to all."),
                          QIconLoader::instance()->iconSet( REPLY_ALL_BUTTON ),
                          QObject::tr("R&eply All"),
                          QKeySequence( QObject::tr("Ctrl+E", "Actions|ReplyAll")),
                          (QObject*)topWidget );
    actionDict.insert( REPLY_ALL_ID, action);
    
    // Create the next unread mail action
    action = new QAction( QObject::tr("Go to next unread mail."),
                          QIconLoader::instance()->iconSet( RIGHT_NORMAL ),
                          QObject::tr("&Next Unread"),
                          QKeySequence(),
                          (QObject*)topWidget );
    actionDict.insert( NEXT_UNREAD_ID, action);
    
    // Create the previous unread mail action
    action = new QAction( QObject::tr("Go to previous unread mail."),
                          QIconLoader::instance()->iconSet( LEFT_NORMAL ),
                          QObject::tr("&Previous Unread"),
                          QKeySequence(),
                          (QObject*)topWidget );
    actionDict.insert( PREVIOUS_UNREAD_ID, action);
    
    // Create the text only actions
    // TODO Build the send and receive actions for each mail account

    // Create the SelectAll mails action
    action = new QAction( QObject::tr("Select all the mails from the current folder."),
                          QObject::tr("Select &All"),
                          QKeySequence( QObject::tr("Ctrl+A", "Edit|SelectAll")),
                          (QObject*)topWidget );
    actionDict.insert( SELECT_ALL_ID, action);

    // Create the UnSelectAll mails action
    action = new QAction( QObject::tr("Unselect all the mails from the current folder."),
                          QObject::tr("Unselect &All"),
                          QKeySequence( QObject::tr("Ctrl+Shift+A", "Edit|UnselectAll")),
                          (QObject*)topWidget );
    actionDict.insert( UNSELECT_ALL_ID, action);

    // Create the print mails action
    action = new QAction( QObject::tr("Print the current mail."),
                          QObject::tr("&Print"),
                          QKeySequence( QObject::tr("Ctrl+Shift+P", "Edit|Print")),
                          (QObject*)topWidget );
    actionDict.insert( PRINT_ID, action);
    
    // Create the 'mark as read the selected mails' action
    action = new QAction( QObject::tr("Mark as read the selected mails."),
                          QObject::tr("Selected &Read"),
                          QKeySequence( QObject::tr("Ctrl+R", "Edit|Mark|Read")),
                          (QObject*)topWidget );
    actionDict.insert( MARK_READ_ID, action);

    // Create the 'mark as unread the selected mails' action
    action = new QAction( QObject::tr("Mark as unread the selected mails."),
                          QObject::tr("Selected &Unread"),
                          QKeySequence( QObject::tr("Ctrl+U", "Edit|Mark|Unread")),
                          (QObject*)topWidget );
    actionDict.insert( MARK_UNREAD_ID, action);

    // Create the 'mark as read all the mails' action
    action = new QAction( QObject::tr("Mark as read all the mails from the current folder."),
                          QObject::tr("Selected all Read"),
                          QKeySequence( QObject::tr("Ctrl+Shift+R", "Edit|Mark|AllRead")),
                          (QObject*)topWidget );
    actionDict.insert( MARK_ALL_READ_ID, action);

    // Create the 'mark as unread all the mails' action
    action = new QAction( QObject::tr("Mark as unread all the mails from the current folder."),
                          QObject::tr("Selected all Unread"),
                          QKeySequence( QObject::tr("Ctrl+Shift+U", "Edit|Mark|AllUnread")),
                          (QObject*)topWidget );
    actionDict.insert( MARK_ALL_UNREAD_ID, action);

    // Create the toggle flag action
    action = new QAction( QObject::tr("Toggle the flag for the selected mails."),
                          QObject::tr("&Toggle Flag"),
                          QKeySequence( QObject::tr("Ctrl+T", "Edit|ToggleFlag")),
                          (QObject*)topWidget );
    actionDict.insert( TOGGLE_FLAG_ID, action);

    // Create the mail properties action
    action = new QAction( QObject::tr("Show the mail header."),
                          QObject::tr("&Properties"),
                          QKeySequence( QObject::tr("Ctrl+P", "Edit|Properties")),
                          (QObject*)topWidget );
    actionDict.insert( MAIL_PROPERTIES_ID, action);

    // Import mails from other format
    action = new QAction( QObject::tr("Import mails from other format."),
                          QObject::tr("&Import"),
                          QKeySequence( QObject::tr("Ctrl+I", "Mail|Import")),
                          (QObject*)topWidget );
    actionDict.insert( MAIL_IMPORT_ID, action);

    // The mail filter mechanism
    action = new QAction( QObject::tr("Set the mail filters rules."),
                          QObject::tr("Fil&ters"),
                          QKeySequence( QObject::tr("Ctrl+T", "Tools|Filters")),
                          (QObject*)topWidget );
    actionDict.insert( MAIL_FILTERS_ID, action);

    // Create settings action.
    action = new QAction( QObject::tr("Settings"),
                          QObject::tr("&Settings..."),
                          0,
                          (QObject*)topWidget );
    actionDict.insert( MAIL_SETTINGS_ID, action);
    
    // Create the forward mail action
    action = new QAction( QObject::tr("Forward the email inline."),
                          QObject::tr("Forward &Inline"),
                          QKeySequence( QObject::tr("Ctrl+L", "Actions|Forward|Inline")),
                          (QObject*)topWidget );
    actionDict.insert( FORWARD_INLINE_ID, action);
    
    // Create the forward mail action
    action = new QAction( QObject::tr("Forward the email quoted."),
                          QObject::tr("Forward &Quoted"),
                          QKeySequence( QObject::tr("Ctrl+Q", "Actions|Forward|Quoted")),
                          (QObject*)topWidget );
    actionDict.insert( FORWARD_QUOTED_ID, action);
    
    // Create the forward mail action
    action = new QAction( QObject::tr("Forward the email as attachment."),
                          QObject::tr("Forward &As Attachemnt"),
                          QKeySequence( QObject::tr("Ctrl+M", "Actions|Forward|AsAttachment")),
                          (QObject*)topWidget );
    actionDict.insert( FORWARD_ASATTACHMENT_ID, action);
    
    // Create next mail flag action
    action = new QAction( QObject::tr("Go to next mail flag."),
                          QObject::tr("Next Flag"),
                          QKeySequence(),
                          (QObject*)topWidget );
    actionDict.insert( NEXT_FLAG_ID, action);
    
    // Create previous mail flag action
    action = new QAction( QObject::tr("Go to previous mail flag."),
                          QObject::tr("Previous Flag"),
                          QKeySequence(),
                          (QObject*)topWidget );
    actionDict.insert( PREVIOUS_FLAG_ID, action);
    
    // Create next high priority mail action
    action = new QAction( QObject::tr("Go to next high priority mail."),
                          QObject::tr("Next Important"),
                          QKeySequence(),
                          (QObject*)topWidget );
    actionDict.insert( NEXT_IMPORTANT_ID, action);
    
    // Create previous high priority mail action
    action = new QAction( QObject::tr("Go to previous high priority mail."),
                          QObject::tr("Previous Important"),
                          QKeySequence(),
                          (QObject*)topWidget );
    actionDict.insert( PREVIOUS_IMPORTANT_ID, action);
    
    // Create CloseAll composer windows action.
    action = new QAction( QObject::tr("Close all the composer windows."),
                          QObject::tr("Close &All"),
                          QKeySequence(),
                          (QObject*)topWidget );
    actionDict.insert( WINDOW_CLOSEALL_ID, action);
  }
}

void KomMailUIService::connectActions()
{
  if( !bActions )
  {
    createActions();
    bActions=true;
    
    // Get the qt handler for the connections
    MailUIPartPrivate *partHandler = (MailUIPartPrivate*) getQTHandler();
    QAction *action;
    
    action = actionDict.find( CUT_ID );
    QObject::connect( action, SIGNAL(activated()), topMainView, SLOT(slotCut()));
    
    action = actionDict.find( COPY_ID );
    QObject::connect( action, SIGNAL(activated()), topMainView, SLOT(slotCopy()));
    
    action = actionDict.find( PASTE_ID );
    QObject::connect( action, SIGNAL(activated()), topMainView, SLOT(slotPaste()));
    
    action = actionDict.find( DELETE_ID );
    QObject::connect( action, SIGNAL(activated()), topMainView, SLOT(slotDelete()));
    
    action = actionDict.find( NEW_MAIL_ID );
    QObject::connect( action, SIGNAL(activated()), partHandler, SLOT(slotNewMail()));
    
    action = actionDict.find( SEND_RECEIVE_ID );
    QObject::connect( action, SIGNAL(activated()), partHandler, SLOT(slotSendReceive()));
    
    action = actionDict.find( FORWARD_ID );
    QObject::connect( action, SIGNAL(activated()), topMainView, SLOT(slotForward()));
    
    action = actionDict.find( FORWARD_INLINE_ID );
    QObject::connect( action, SIGNAL(activated()), topMainView, SLOT(slotForwardInline()));
    
    action = actionDict.find( FORWARD_QUOTED_ID );
    QObject::connect( action, SIGNAL(activated()), topMainView, SLOT(slotForwardQuoted()));
    
    action = actionDict.find( FORWARD_ASATTACHMENT_ID );
    QObject::connect( action, SIGNAL(activated()), topMainView, SLOT(slotForwardAsAttachment()));
    
    action = actionDict.find( REPLY_ID );
    QObject::connect( action, SIGNAL(activated()), topMainView, SLOT(slotReply()));
    
    action = actionDict.find( REPLY_ALL_ID );
    QObject::connect( action, SIGNAL(activated()), topMainView, SLOT(slotReplyAll()));
    
    action = actionDict.find( SELECT_ALL_ID );
    QObject::connect( action, SIGNAL(activated()), topMainView, SLOT(slotSelectAll()));
    
    action = actionDict.find( UNSELECT_ALL_ID );
    QObject::connect( action, SIGNAL(activated()), topMainView, SLOT(slotUnSelectAll()));

    action = actionDict.find( PRINT_ID );
    QObject::connect( action, SIGNAL(activated()), topMainView, SLOT(slotPrint()));
    
    action = actionDict.find( MARK_READ_ID );
    QObject::connect( action, SIGNAL(activated()), topMainView, SLOT(slotRead()));
    
    action = actionDict.find( MARK_UNREAD_ID );
    QObject::connect( action, SIGNAL(activated()), topMainView, SLOT(slotUnRead()));
    
    action = actionDict.find( MARK_ALL_READ_ID );
    QObject::connect( action, SIGNAL(activated()), topMainView, SLOT(slotAllRead()));
    
    action = actionDict.find( MARK_ALL_UNREAD_ID );
    QObject::connect( action, SIGNAL(activated()), topMainView, SLOT(slotAllUnRead()));
    
    action = actionDict.find( TOGGLE_FLAG_ID );
    QObject::connect( action, SIGNAL(activated()), topMainView, SLOT(slotToggleFlag()));
    
    action = actionDict.find( MAIL_PROPERTIES_ID );
    QObject::connect( action, SIGNAL(activated()), topMainView, SLOT(slotProperties()));
    
    action = actionDict.find( MAIL_IMPORT_ID );
    QObject::connect
      (
        action,
        SIGNAL(activated()),
        partHandler,
        SLOT(slotImport())
      );
      
    action = actionDict.find( MAIL_FILTERS_ID );
    QObject::connect
      (
        action,
        SIGNAL(activated()),
        partHandler,
        SLOT(slotFilters())
      );
    
    action = actionDict.find( MAIL_SETTINGS_ID );
    QObject::connect
      (
        action,
        SIGNAL(activated()),
        partHandler,
        SLOT(slot_settings())
      );
    
    action = actionDict.find( NEXT_UNREAD_ID );
    QObject::connect
      (
        action,
        SIGNAL(activated()),
        topMainView,
        SLOT(slotNextUnread())
      );

    action = actionDict.find( PREVIOUS_UNREAD_ID );
    QObject::connect
      (
        action,
        SIGNAL(activated()),
        topMainView,
        SLOT(slotPreviousUnread())
      );

    action = actionDict.find( NEXT_FLAG_ID );
    QObject::connect
      (
        action,
        SIGNAL(activated()),
        topMainView,
        SLOT(slotNextFlag())
      );

    action = actionDict.find( PREVIOUS_FLAG_ID );
    QObject::connect
      (
        action,
        SIGNAL(activated()),
        topMainView,
        SLOT(slotPreviousFlag())
      );

    action = actionDict.find( NEXT_IMPORTANT_ID );
    QObject::connect
      (
        action,
        SIGNAL(activated()),
        topMainView,
        SLOT(slotNextImportant())
      );

    action = actionDict.find( PREVIOUS_IMPORTANT_ID );
    QObject::connect
      (
        action,
        SIGNAL(activated()),
        topMainView,
        SLOT(slotPreviousImportant())
      );

    action = actionDict.find( WINDOW_CLOSEALL_ID );
    QObject::connect
      (
        action,
        SIGNAL(activated()),
        partHandler,
        SLOT(slotWindowCloseAll())
      );
  }
}

void KomMailUIService::disconnectActions()
{
  if( bActions )
  {
    bActions=false;
    
    // Get the qt handler for the connections
    MailUIPartPrivate *partHandler = (MailUIPartPrivate*) getQTHandler();
    QAction *action;
    
    action = actionDict.find( CUT_ID );
    QObject::disconnect( action, SIGNAL(activated()), topMainView, SLOT(slotCut()));
    
    action = actionDict.find( COPY_ID );
    QObject::disconnect( action, SIGNAL(activated()), topMainView, SLOT(slotCopy()));
    
    action = actionDict.find( PASTE_ID );
    QObject::disconnect( action, SIGNAL(activated()), topMainView, SLOT(slotPaste()));
    
    action = actionDict.find( DELETE_ID );
    QObject::disconnect( action, SIGNAL(activated()), topMainView, SLOT(slotDelete()));
    
    action = actionDict.find( NEW_MAIL_ID );
    QObject::disconnect( action, SIGNAL(activated()), partHandler, SLOT(slotNewMail()));
    
    action = actionDict.find( SEND_RECEIVE_ID );
    QObject::disconnect( action, SIGNAL(activated()), partHandler, SLOT(slotSendReceive()));
    
    action = actionDict.find( FORWARD_ID );
    QObject::disconnect( action, SIGNAL(activated()), topMainView, SLOT(slotForward()));
    
    action = actionDict.find( FORWARD_INLINE_ID );
    QObject::disconnect( action, SIGNAL(activated()), topMainView, SLOT(slotForwardInline()));
    
    action = actionDict.find( FORWARD_QUOTED_ID );
    QObject::disconnect( action, SIGNAL(activated()), topMainView, SLOT(slotForwardQuoted()));
    
    action = actionDict.find( FORWARD_ASATTACHMENT_ID );
    QObject::disconnect( action, SIGNAL(activated()), topMainView, SLOT(slotForwardAsAttachment()));
    
    action = actionDict.find( REPLY_ID );
    QObject::disconnect( action, SIGNAL(activated()), topMainView, SLOT(slotReply()));
    
    action = actionDict.find( REPLY_ALL_ID );
    QObject::disconnect( action, SIGNAL(activated()), topMainView, SLOT(slotReplyAll()));
    
    action = actionDict.find( SELECT_ALL_ID );
    QObject::disconnect( action, SIGNAL(activated()), topMainView, SLOT(slotSelectAll()));
    
    action = actionDict.find( UNSELECT_ALL_ID );
    QObject::disconnect( action, SIGNAL(activated()), topMainView, SLOT(slotUnSelectAll()));

    action = actionDict.find( PRINT_ID );
    QObject::disconnect( action, SIGNAL(activated()), topMainView, SLOT(slotPrint()));
    
    action = actionDict.find( MARK_READ_ID );
    QObject::disconnect( action, SIGNAL(activated()), topMainView, SLOT(slotRead()));
    
    action = actionDict.find( MARK_UNREAD_ID );
    QObject::disconnect( action, SIGNAL(activated()), topMainView, SLOT(slotUnRead()));
    
    action = actionDict.find( MARK_ALL_READ_ID );
    QObject::disconnect( action, SIGNAL(activated()), topMainView, SLOT(slotAllRead()));
    
    action = actionDict.find( MARK_ALL_UNREAD_ID );
    QObject::disconnect( action, SIGNAL(activated()), topMainView, SLOT(slotAllUnRead()));
    
    action = actionDict.find( TOGGLE_FLAG_ID );
    QObject::disconnect( action, SIGNAL(activated()), topMainView, SLOT(slotToggleFlag()));
    
    action = actionDict.find( MAIL_PROPERTIES_ID );
    QObject::disconnect( action, SIGNAL(activated()), topMainView, SLOT(slotProperties()));
    
    action = actionDict.find( MAIL_IMPORT_ID );
    QObject::disconnect
      (
        action,
        SIGNAL(activated()),
        partHandler,
        SLOT(slotImport())
      );
      
    action = actionDict.find( MAIL_FILTERS_ID );
    QObject::disconnect
      (
        action,
        SIGNAL(activated()),
        partHandler,
        SLOT(slotFilters())
      );
    
    action = actionDict.find( MAIL_SETTINGS_ID );
    QObject::disconnect
      (
        action,
        SIGNAL(activated()),
        partHandler,
        SLOT(slot_settings())
      );
    
    action = actionDict.find( NEXT_UNREAD_ID );
    QObject::disconnect
      (
        action,
        SIGNAL(activated()),
        topMainView,
        SLOT(slotNextUnread())
      );

    action = actionDict.find( PREVIOUS_UNREAD_ID );
    QObject::disconnect
      (
        action,
        SIGNAL(activated()),
        topMainView,
        SLOT(slotPreviousUnread())
      );

    action = actionDict.find( NEXT_FLAG_ID );
    QObject::disconnect
      (
        action,
        SIGNAL(activated()),
        topMainView,
        SLOT(slotNextFlag())
      );

    action = actionDict.find( PREVIOUS_FLAG_ID );
    QObject::disconnect
      (
        action,
        SIGNAL(activated()),
        topMainView,
        SLOT(slotPreviousFlag())
      );

    action = actionDict.find( NEXT_IMPORTANT_ID );
    QObject::disconnect
      (
        action,
        SIGNAL(activated()),
        topMainView,
        SLOT(slotNextImportant())
      );

    action = actionDict.find( PREVIOUS_IMPORTANT_ID );
    QObject::disconnect
      (
        action,
        SIGNAL(activated()),
        topMainView,
        SLOT(slotPreviousImportant())
      );
    
    action = actionDict.find( WINDOW_CLOSEALL_ID );
    QObject::disconnect
      (
        action,
        SIGNAL(activated()),
        partHandler,
        SLOT(slotWindowCloseAll())
      );
  }
}

void KomMailUIService::showToolbars(QMainWindow *window)
{
  connectActions();
  
  if( toolBar==NULL )
  {
    toolBar = new QToolBar(window, "MailToolBar");
    // TODO
    // Add the QToolButton-s here, with all associated QActions
    createActions();

    // Add new mail button
    QAction *action = actionDict.find( NEW_MAIL_ID );
    if (0 != action)
      action->addTo( toolBar );
    
    toolBar->addSeparator();
    
    action = actionDict.find( REPLY_ID );
    if (0 != action)
      action->addTo( toolBar );
    
    action = actionDict.find( REPLY_ALL_ID );
    if (0 != action)
      action->addTo( toolBar );
    
    action = actionDict.find( FORWARD_ID );
    if (0 != action)
      action->addTo( toolBar );
    
    PopupAction * popupAction = dynamic_cast<PopupAction *>( actionDict.find( SEND_RECEIVE_ID ) );
    if (0 != popupAction)
    {
      if( !toolsSendReceiveMenu )
        toolsSendReceiveMenu = new QPopupMenu();
      popupAction->setPopup( toolsSendReceiveMenu );
      popupAction->addTo( toolBar );
    }
    
    toolBar->addSeparator();
    
    action = actionDict.find( CUT_ID );
    if (0 != action)
      action->addTo( toolBar );
    
    action = actionDict.find( COPY_ID );
    if (0 != action)
      action->addTo( toolBar );
    
    action = actionDict.find( PASTE_ID );
    if (0 != action)
      action->addTo( toolBar );
    
    action = actionDict.find( DELETE_ID );
    if (0 != action)
      action->addTo( toolBar );
    
    toolBar->addSeparator();
    
    action = actionDict.find( PREVIOUS_UNREAD_ID );
    if (0 != action)
      action->addTo( toolBar );
    
    action = actionDict.find( NEXT_UNREAD_ID );
    if (0 != action)
      action->addTo( toolBar );
    
    QLabel *emptyLabel = new QLabel(toolBar);
    toolBar->setStretchableWidget(emptyLabel);
  }
  else
    toolBar->show();
}

void KomMailUIService::hideToolbars(QMainWindow *)
{
  disconnectActions();
  
  if( toolBar!=NULL )
    toolBar->hide();
}

void KomMailUIService::showMenus(QMenuBar *mainMenu)
{
  connectActions();
  
  if( mainMenu!=NULL )
  {
    // TODO
    // Add the QPopupMenu-s and insertItem() here, with all associated QActions
    if (0 == mailsMenu)
    {
      MailUIPartPrivate *partHandler = (MailUIPartPrivate*) getQTHandler();
      
      mailsMenu = new QPopupMenu(mainMenu, "MailFileMenu");
      actionsMenu = new QPopupMenu(mainMenu, "MailActionsMenu");
      actionsReplyMenu = new QPopupMenu(mainMenu, "MailActionsReplyMenu");
      actionsForwardMenu = new QPopupMenu(mainMenu, "MailActionsForwardMenu");
      actionsGoToMenu = new QPopupMenu(mainMenu, "MailActionsGoToMenu");
      toolsMenu = new QPopupMenu(mainMenu, "MailToolsMenu");
      if( !toolsSendReceiveMenu )
        toolsSendReceiveMenu = new QPopupMenu(mainMenu, "MailSendReceiveMenu");
      toolsSendMenu = new QPopupMenu(mainMenu, "MailSendMenu");
      toolsReceiveMenu = new QPopupMenu(mainMenu, "MailReceiveMenu");
      editMenu = new QPopupMenu(mainMenu, "MailEditMenu");
      windowMenu = new QPopupMenu(mainMenu, "MailWindowMenu");
      windowShowMenu = new QPopupMenu(mainMenu, "MailWindowShowMenu");
      windowHideMenu = new QPopupMenu(mainMenu, "MailWindowHideMenu");
      windowCloseMenu = new QPopupMenu(mainMenu, "MailWindowCloseMenu");
      
      QObject::connect(toolsSendReceiveMenu, SIGNAL(aboutToShow()), partHandler, SLOT(genSendReceiveMenus()));
      QObject::connect(toolsSendReceiveMenu, SIGNAL(activated(int)), partHandler, SLOT(startSendReceive(int)));
      QObject::connect(toolsSendMenu, SIGNAL(aboutToShow()), partHandler, SLOT(genSendReceiveMenus()));
      QObject::connect(toolsSendMenu, SIGNAL(activated(int)), partHandler, SLOT(startSend(int)));
      QObject::connect(toolsReceiveMenu, SIGNAL(aboutToShow()), partHandler, SLOT(genSendReceiveMenus()));
      QObject::connect(toolsReceiveMenu, SIGNAL(activated(int)), partHandler, SLOT(startReceive(int)));
      QObject::connect(windowShowMenu, SIGNAL(aboutToShow()), partHandler, SLOT(genWindowShowMenus()));
      QObject::connect(windowHideMenu, SIGNAL(aboutToShow()), partHandler, SLOT(genWindowHideMenus()));
      QObject::connect(windowCloseMenu, SIGNAL(aboutToShow()), partHandler, SLOT(genWindowCloseMenus()));
    }
      
    mailsMenuId = mainMenu->insertItem(QObject::tr("&Mail"), mailsMenu);
    QAction* action = actionDict.find( MAIL_IMPORT_ID );
    if (0 != action)
      action->addTo( mailsMenu );
    action = actionDict.find( NEW_MAIL_ID );
    if (0 != action)
      action->addTo( mailsMenu );
    
    actionsMenuId = mainMenu->insertItem(QObject::tr("A&ctions"), actionsMenu);
    actionsReplyMenuId = actionsMenu->insertItem(QObject::tr("&Reply"), actionsReplyMenu);
    action = actionDict.find( REPLY_ID );
    if (0 != action)
      action->addTo( actionsReplyMenu );
    action = actionDict.find( REPLY_ALL_ID );
    if (0 != action)
      action->addTo( actionsReplyMenu );
    actionsForwardMenuId = actionsMenu->insertItem(QObject::tr("&Forward"), actionsForwardMenu);
    action = actionDict.find( FORWARD_ID );
    if (0 != action)
      action->addTo( actionsForwardMenu );
    action = actionDict.find( FORWARD_INLINE_ID );
    if (0 != action)
      action->addTo( actionsForwardMenu );
    action = actionDict.find( FORWARD_QUOTED_ID );
    if (0 != action)
      action->addTo( actionsForwardMenu );
//    action = actionDict.find( FORWARD_ASATTACHMENT_ID );
//    if (0 != action)
//      action->addTo( actionsForwardMenu );
    actionsGoToMenuId = actionsMenu->insertItem(QObject::tr("&GoTo"), actionsGoToMenu);
    action = actionDict.find( NEXT_UNREAD_ID );
    if (0 != action)
      action->addTo( actionsGoToMenu );
    action = actionDict.find( PREVIOUS_UNREAD_ID );
    if (0 != action)
      action->addTo( actionsGoToMenu );
    action = actionDict.find( NEXT_FLAG_ID );
    if (0 != action)
      action->addTo( actionsGoToMenu );
    action = actionDict.find( PREVIOUS_FLAG_ID );
    if (0 != action)
      action->addTo( actionsGoToMenu );
    action = actionDict.find( NEXT_IMPORTANT_ID );
    if (0 != action)
      action->addTo( actionsGoToMenu );
    action = actionDict.find( PREVIOUS_IMPORTANT_ID );
    if (0 != action)
      action->addTo( actionsGoToMenu );
    
    editMenuId = mainMenu->insertItem(QObject::tr("&Edit"), editMenu);
    action = actionDict.find( CUT_ID );
    if (0 != action)
      action->addTo( editMenu );
    action = actionDict.find( COPY_ID );
    if (0 != action)
      action->addTo( editMenu );
    action = actionDict.find( PASTE_ID );
    if (0 != action)
      action->addTo( editMenu );
    action = actionDict.find( DELETE_ID );
    if (0 != action)
      action->addTo( editMenu );
    action = actionDict.find( SELECT_ALL_ID );
    if (0 != action)
      action->addTo( editMenu );
    action = actionDict.find( UNSELECT_ALL_ID );
    if (0 != action)
      action->addTo( editMenu );
    action = actionDict.find( PRINT_ID );
    if (0 != action)
      action->addTo( editMenu );
    
    toolsMenuId = mainMenu->insertItem(QObject::tr("&Tools"), toolsMenu);
    action = actionDict.find( MAIL_FILTERS_ID );
    if (0 != action)
      action->addTo( toolsMenu );
    
    toolsSendReceiveMenuId = toolsMenu->insertItem(QObject::tr("S&end-Receive"), toolsSendReceiveMenu);
    toolsSendMenuId = toolsMenu->insertItem(QObject::tr("&Send"), toolsSendMenu);
    toolsReceiveMenuId = toolsMenu->insertItem(QObject::tr("&Receive"), toolsReceiveMenu);
    
    windowMenuId = mainMenu->insertItem(QObject::tr("&Window"), windowMenu);
    windowShowMenuId = windowMenu->insertItem(QObject::tr("&Show"), windowShowMenu);
    windowHideMenuId = windowMenu->insertItem(QObject::tr("&Hide"), windowHideMenu);
    windowMenu->insertSeparator();
    windowCloseMenuId = windowMenu->insertItem(QObject::tr("&Close"), windowCloseMenu);
    action = actionDict.find( WINDOW_CLOSEALL_ID );
    if (0 != action)
      action->addTo( windowMenu );
  }
}

void KomMailUIService::hideMenus(QMenuBar *mainMenu)
{
  disconnectActions();
  
  if( mainMenu!=NULL )
  {
    // Mail
    if( -1 != mailsMenuId )
    {
      mainMenu->removeItem( mailsMenuId );
      mailsMenuId = -1;
    }
    if( mailsMenu!=NULL )
      mailsMenu->clear();
      
    // Actions->Reply
    if( -1 != actionsReplyMenuId )
    {
      actionsMenu->removeItem( actionsReplyMenuId );
      actionsReplyMenuId = -1;
    }
    if( actionsReplyMenu!=NULL )
      actionsReplyMenu->clear();
      
    // Actions->Forward
    if( -1 != actionsForwardMenuId )
    {
      actionsMenu->removeItem( actionsForwardMenuId );
      actionsForwardMenuId = -1;
    }
    if( actionsForwardMenu!=NULL )
      actionsForwardMenu->clear();
      
    // Actions->GoTo
    if( -1 != actionsGoToMenuId )
    {
      actionsMenu->removeItem( actionsGoToMenuId );
      actionsGoToMenuId = -1;
    }
    if( actionsGoToMenu!=NULL )
      actionsGoToMenu->clear();
      
    // Actions
    if( -1 != actionsMenuId )
    {
      mainMenu->removeItem( actionsMenuId );
      actionsMenuId = -1;
    }
    if( actionsMenu!=NULL )
      actionsMenu->clear();
      
    // Edit
    if( -1 != editMenuId )
    {
      mainMenu->removeItem( editMenuId );
      editMenuId = -1;
    }
    if( editMenu!=NULL )
      editMenu->clear();
    
    // Tools->SendReceive
    if( -1 != toolsSendReceiveMenuId )
    {
      toolsMenu->removeItem( toolsSendReceiveMenuId );
      toolsSendReceiveMenuId = -1;
    }
    if( toolsSendReceiveMenu!=NULL )
      toolsSendReceiveMenu->clear();
      
    // Tools->Send
    if( -1 != toolsSendMenuId )
    {
      toolsMenu->removeItem( toolsSendMenuId );
      toolsSendMenuId = -1;
    }
    if( toolsSendMenu!=NULL )
      toolsSendMenu->clear();
      
    // Tools->Receive
    if( -1 != toolsReceiveMenuId )
    {
      toolsMenu->removeItem( toolsReceiveMenuId );
      toolsReceiveMenuId = -1;
    }
    if( toolsReceiveMenu!=NULL )
      toolsReceiveMenu->clear();
      
    // Tools
    if( -1 != toolsMenuId )
    {
      mainMenu->removeItem( toolsMenuId );
      toolsMenuId = -1;
    }
    if( toolsMenu!=NULL )
      toolsMenu->clear();
    
    // Window->Show
    if( -1 != windowShowMenuId )
    {
      windowMenu->removeItem( windowShowMenuId );
      windowShowMenuId = -1;
    }
    if( windowShowMenu!=NULL )
      windowShowMenu->clear();
    
    // Window->Hide
    if( -1 != windowHideMenuId )
    {
      windowMenu->removeItem( windowHideMenuId );
      windowHideMenuId = -1;
    }
    if( windowHideMenu!=NULL )
      windowHideMenu->clear();
    
    // Window->Close
    if( -1 != windowCloseMenuId )
    {
      windowMenu->removeItem( windowCloseMenuId );
      windowCloseMenuId = -1;
    }
    if( windowCloseMenu!=NULL )
      windowCloseMenu->clear();
    
    // Window
    if( -1 != windowMenuId )
    {
      mainMenu->removeItem( windowMenuId );
      windowMenuId = -1;
    }
    if( windowMenu!=NULL )
      windowMenu->clear();
  }
}

  KomMainTreeInterface *
KomMailUIService::getMainTreeInterface(QListView * parentTree)
{
  if (0 == m_mainTreeInterface)
  {
    m_mainTreeInterface = new KomMailMainTreeInterface(parentTree);
  }

  return m_mainTreeInterface;
}

  void
KomMailUIService::setCurrentURL(QString url)
{
  if( url.left(17) != "/Aethera/VFS/Mail" )
    return;
  
  if (0 == topMainView)
  {
    qDebug("topMainView is 0");
    return;
  }

  VFSModule * vfs = 0;
  ComponentTrader* trader = dynamic_cast<ComponentTrader*>(ComponentTrader::traderRef().instance());
  if( trader )
  {
    ComponentRef ref = trader->registeredComponent( AETHERA_VFS_SERVICE );
    if( ref.isValid() )
      vfs = static_cast<VFSModule*>(ref.instance());
  }
  Q_ASSERT(0 != vfs);
  
  VFolder *folder = vfs->folderRef(url);
  if( folder )
  {
    // Unmount a possible mounted imap folder
    topMainView->unmountFolder();
    
    // Select the right view
    if( folder->viewType()=="genmail" )
    {
      topViewWidget->showChild( topGeneralView );
      if( folder->type()=="imap" )
      {
        // Create the subfolders
//        qDebug("-------------- SUBFOLDERS -------------------");

        // /Aethera/VFS/Mail/Account/Mailbox
        int iMailRoot = (vfs->root()+"/Mail/").length();
        int iFind = url.find("/", iMailRoot);
        QString account;
        QString mailbox;
        
        if( iFind==-1 )
        {

          account = url.mid(iMailRoot);
          mailbox = "\"\"";
        }
        else
        {
          account = url.mid( iMailRoot, iFind-iMailRoot );
          mailbox = url.right( url.length() - (iFind+1) );
        }
        
        ClientRMIModule * clientRMI = 0;
        ComponentTrader* trader = dynamic_cast<ComponentTrader*>(ComponentTrader::traderRef().instance());
        if( trader )
        {
          ComponentRef ref = trader->registeredComponent( AETHERA_RMI_CLIENT );
          if( ref.isValid() )
            clientRMI = static_cast<ClientRMIModule*>(ref.instance());
        }
        if( clientRMI )
          clientRMI->subfolders(account, mailbox, folder->viewType());
      }
    }
    else 
    {
      topViewWidget->showChild( topMainView );
      topMainView->slotSetFolder(url);
    }
  }
}

  void
KomMailUIService::buildTree()
{
  if (0 == m_mainTreeInterface)
  {
    qDebug("KomMailUIService::buildTree: No m_mainTreeInterface");
    return;
  }

  m_mainTreeInterface->parentTree()->setColumnText( 0, "Folder" );
  m_mainTreeInterface->parentTree()->addColumn( "New", 50 );
  m_mainTreeInterface->parentTree()->addColumn( "All", 50 );
  m_mainTreeInterface->parentTree()->header()->show();

  MailUIPartPrivate* partHandler = (MailUIPartPrivate*)getQTHandler();

  QObject::connect
    (
      partHandler,
      SIGNAL(create(const QString &)),
      m_mainTreeInterface->qObject(),
      SLOT(slotCreate(const QString &))
    );

  QObject::connect
    (
      partHandler,
      SIGNAL(updateVInstances(const QStringList &)),
      m_mainTreeInterface->qObject(),
      SLOT(slotUpdateVInstances(const QStringList &))
    );

  QObject::connect
    (
      partHandler,
      SIGNAL(createVInstances(const QStringList &)),
      m_mainTreeInterface->qObject(),
      SLOT(slotCreateVInstances(const QStringList &))
    );

  QObject::connect
    (
      partHandler,
      SIGNAL(deleteVInstances(const QStringList &)),
      m_mainTreeInterface->qObject(),
      SLOT(slotDeleteVInstances(const QStringList &))
    );
    
  QObject::connect
    (
      partHandler,
      SIGNAL(createVFolder(const QString &, const QString &, const QString &, const QString &, const QString &)),
      m_mainTreeInterface->qObject(),
      SLOT(slotCreateVFolder(const QString &, const QString &, const QString &, const QString &, const QString &))
    );

  QObject::connect
    (
      partHandler,
      SIGNAL(deleteVFolder(const QString &, const QString &, const QString &)),
      m_mainTreeInterface->qObject(),
      SLOT(slotDeleteVFolder(const QString &, const QString &, const QString &))
    );
      
  QObject::connect
    (
      m_mainTreeInterface->qObject(),
      SIGNAL(deleteMailGroup(const QString &)),
      topMainView,
      SLOT(slotDeleteFolder(const QString &))
    );
  
  m_mainTreeInterface->show( topMainView->getCurrentFolder() );
}

  void
KomMailUIService::removeTree()
{
  if (0 == m_mainTreeInterface)
  {
    qDebug("KomMailUIService::buildTree: No m_mainTreeInterface");
    return;
  }

  m_mainTreeInterface->parentTree()->setColumnText( 0, "" );
  m_mainTreeInterface->parentTree()->removeColumn( 2 );
  m_mainTreeInterface->parentTree()->removeColumn( 1 );
  m_mainTreeInterface->parentTree()->header()->hide();

  MailUIPartPrivate* partHandler = (MailUIPartPrivate*)getQTHandler();

  QObject::disconnect
    (
      partHandler,
      SIGNAL(create(const QString &)),
      m_mainTreeInterface->qObject(),
      SLOT(slotCreate(const QString &))
    );

  QObject::disconnect
    (
      partHandler,
      SIGNAL(updateVInstances(const QStringList &)),
      m_mainTreeInterface->qObject(),
      SLOT(slotUpdateVInstances(const QStringList &))
    );

  QObject::disconnect
    (
      partHandler,
      SIGNAL(createVInstances(const QStringList &)),
      m_mainTreeInterface->qObject(),
      SLOT(slotCreateVInstances(const QStringList &))
    );

  QObject::disconnect
    (
      partHandler,
      SIGNAL(deleteVInstances(const QStringList &)),
      m_mainTreeInterface->qObject(),
      SLOT(slotDeleteVInstances(const QStringList &))
    );
    
  QObject::disconnect
    (
      partHandler,
      SIGNAL(createVFolder(const QString &, const QString &, const QString &, const QString &, const QString &)),
      m_mainTreeInterface->qObject(),
      SLOT(slotCreateVFolder(const QString &, const QString &, const QString &, const QString &, const QString &))
    );

  QObject::disconnect
    (
      partHandler,
      SIGNAL(deleteVFolder(const QString &, const QString &, const QString &)),
      m_mainTreeInterface->qObject(),
      SLOT(slotDeleteVFolder(const QString &, const QString &, const QString &))
    );
      
  QObject::disconnect
    (
      m_mainTreeInterface->qObject(),
      SIGNAL(deleteMailGroup(const QString &)),
      topMainView,
      SLOT(slotDeleteFolder(const QString &))
    );
}

  QString
KomMailUIService::prettyName() const
{
  return "Mail";
}

  void
KomMailUIService::execAboutDialog(QWidget * parent) const
{
  QMessageBox::about
    (
      parent,
      QString("About plugin: %1").arg(prettyName()),
      QString("This plugin handles email")
    );

}

