/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/***************************************************************************
         kommailuiservice.h  -  The UI service for the Mail plug in
                             -------------------
    begin                : Thu Sep 27 15:55:16 EEST 2001
    copyright            : (C) 2001 by theKompany.com
    author               : Eugen C. <eug@thekompany.com>
 ***************************************************************************/

#ifndef KOMMAILUISERVICE_H
#define KOMMAILUISERVICE_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <komaetheraplugin.h>
#include <komaetheratools.h>

#include <qlabel.h>
#include <qlayout.h>

// the main icon
#define MAIL_ACTIVE             "MailCenter2_active.png"
#define MAIL_NORMAL             "MailCenter2_inactive.png"
#define MAIL_BANNER             "aethera-banner-mail.png"
#define MAIL_BANNER_LEFT        "MailCenter_Type.png"
#define MAIL_BANNER_RIGHT       "MailCenter_Banner4.png"
// the toolbar icons
#define NEW_MAIL_BUTTON         "NewMail.png"
//#define NEW_MAIL_NORMAL         "NewMail.png"
//#define NEW_MAIL_ACTIVE         "NewMail.png"
#define SEND_RECEIVE_BUTTON     "SendReceive.png"
//#define SEND_RECEIVE_NORMAL     "SendReceive.png"
//#define SEND_RECEIVE_ACTIVE     "SendReceive.png"
#define FORWARD_BUTTON          "Forward.png"
//#define FORWARD_NORMAL          "Forward.png"
//#define FORWARD_ACTIVE          "Forward.png"
#define REPLY_BUTTON            "Reply.png"
//#define REPLY_NORMAL            "Reply.png"
//#define REPLY_ACTIVE            "Reply.png"
#define REPLY_ALL_BUTTON        "ReplyToAll.png"
//#define REPLY_ALL_NORMAL        "ReplyToAll.png"
//#define REPLY_ALL_ACTIVE        "ReplyToAll.png"

// Actions string id.
#define NEW_MAIL_ID             "NEW_MAIL"
#define SEND_RECEIVE_ID         "TOOLS_SEND_RECEIVE"
#define FORWARD_ID              "ACTIONS_FORWARD"
#define FORWARD_INLINE_ID       "ACTIONS_FORWARD_INLINE"
#define FORWARD_QUOTED_ID       "ACTIONS_FORWARD_QUOTED"
#define FORWARD_ASATTACHMENT_ID "ACTIONS_FORWARD_ASATTACHMENT"
#define REPLY_ID                "ACTIONS_REPLY"
#define REPLY_ALL_ID            "ACTIONS_REPLY_ALL"
#define SELECT_ALL_ID           "SELECT_ALL_MAILS"
#define UNSELECT_ALL_ID         "UNSELECT_ALL_MAILS"
#define MARK_READ_ID            "MARK_READ"
#define MARK_UNREAD_ID          "MARK_UNREAD"
#define MARK_ALL_READ_ID        "MARK_ALL_READ"
#define MARK_ALL_UNREAD_ID      "MARK_ALL_UNREAD"
#define TOGGLE_FLAG_ID          "TOGGLE_FLAG"
#define MAIL_PROPERTIES_ID      "MAIL_PROPERTIES"
#define MAIL_IMPORT_ID          "MAIL_IMPORT"
#define MAIL_FILTERS_ID         "MAIL_FILTERS"
#define MAIL_SETTINGS_ID        "MAIL_SETTINGS"
#define NEXT_UNREAD_ID          "MAIL_NEXT_UNREAD"
#define PREVIOUS_UNREAD_ID      "MAIL_PREVIOUS_UNREAD"
#define NEXT_FLAG_ID            "MAIL_NEXT_FLAG"
#define PREVIOUS_FLAG_ID        "MAIL_PREVIOUS_FLAG"
#define NEXT_IMPORTANT_ID       "MAIL_NEXT_IMPORTANT"
#define PREVIOUS_IMPORTANT_ID   "MAIL_PREVIOUS_IMPORTANT"
#define WINDOW_CLOSEALL_ID      "MAIL_SHOW_WINDOW"
#define PRINT_ID                "PRINT_MAIL"
extern "C"
{
    MAIL_PLUGIN_API kore::Interface* kommailuiservice_factory();
};

class KomMailMainTreeInterface;
class MailUIPartPrivate;
class MailWindow;

class MAIL_PLUGIN_API KomMailUIService : public KomUserInterfaceService
{

  public:
    KomMailUIService();
    virtual ~KomMailUIService();

    virtual KomMainTreeInterface* getMainTreeInterface( QListView *parentTree );
    
    // From UIPart
    /** Query for capabilities.*/
    virtual bool hasCapability(const QString&);
    /** Create a new widget corresponding to the string.*/
    virtual void createWidget(const QString&);
    /** Show the part toolbars.*/
    virtual void showToolbars(QMainWindow *);
    /** Hide the part toolbars.*/
    virtual void hideToolbars(QMainWindow *);
    /** Show the part manus.*/
    virtual void showMenus(QMenuBar *);
    /** Hide the part menu.*/
    virtual void hideMenus(QMenuBar *);

    virtual void setCurrentURL(QString);

    // The popup menus
    QPopupMenu *mailsMenu;
    QPopupMenu *actionsMenu;
    QPopupMenu *actionsReplyMenu;
    QPopupMenu *actionsForwardMenu;
    QPopupMenu *actionsGoToMenu;
    QPopupMenu *toolsMenu;
    QPopupMenu *toolsSendReceiveMenu;
    QPopupMenu *toolsSendMenu;
    QPopupMenu *toolsReceiveMenu;
    QPopupMenu *editMenu;
    QPopupMenu *editMarkMenu;
    QPopupMenu *optionsMenu;
    QPopupMenu *windowMenu;
    QPopupMenu *windowShowMenu;
    QPopupMenu *windowHideMenu;
    QPopupMenu *windowCloseMenu;
    // Popup ids
    int mailsMenuId;
    int actionsMenuId;
    int actionsReplyMenuId;
    int actionsForwardMenuId;
    int actionsGoToMenuId;
    int toolsMenuId;
    int toolsSendReceiveMenuId;
    int toolsSendMenuId;
    int toolsReceiveMenuId;
    int editMenuId;
    int editMarkMenuId;
    int optionsMenuId;
    int windowMenuId;
    int windowShowMenuId;
    int windowHideMenuId;
    int windowCloseMenuId;

    virtual void buildTree();
    virtual void removeTree();

    virtual QString prettyName() const;
    
    virtual void execAboutDialog(QWidget * parent) const;

  protected:
    /** Create the QT signal/slot handler.*/
    virtual UIPartPrivate *createQTHandler(void);
    /** Create the QActions here.*/
    virtual void createActions();
    /** Make all the needed connections.*/
    virtual void connectActions();
    /** Disconnect the acctions.*/
    virtual void disconnectActions();
  
  private:
    QWidget *topWidget;
    QVBoxLayout *topWidgetLayout;
    KomContainerWidget *topBannerWidget;
    KomContainerWidget *topViewWidget;
    QWidget *topMainBanner;
    MailWindow *topMainView;
    QWidget *topGeneralView;
    
    bool bActions;
    
    KomMailMainTreeInterface  * m_mainTreeInterface;
};

#endif
