/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/***************************************************************************
     komnotesbackendservice.h  -  the Notes backend service based on VFS
                             -------------------
    begin                : Thu Sep 27 15:55:16 EEST 2001
    copyright            : (C) 2001 by theKompany.com
    author               : Eugen C. <eug@thekompany.com>
 ***************************************************************************/

#ifndef KOMNOTESBACKENDSERVICE_H
#define KOMNOTESBACKENDSERVICE_H

#include <komaetheraplugin.h>
#include <vnoteobject.h>

#define AETHERA_NOTES_BACKENDSERVICE "/Aethera/Backend/Notes"
#define AETHERA_NOTES_BACKENDSERVICE_DESC "Aethera Backend service for Notes"

extern "C"
{
    NOTE_PLUGIN_API kore::Interface* komnotesbackendservice_factory();
};

class NOTE_PLUGIN_API KomNotesBackendService : public KomBackendService
{
  public:
    /** Constructors and destructor.*/
    KomNotesBackendService();
    virtual ~KomNotesBackendService();

    /** Return a factory for building VNoteObjects.*/
    virtual VObjectFactory* vobjectFactory();
    
    virtual QStringList systemFolders() const;
    
    virtual QString backendType() const;
};

#endif





