/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
______________________________________________________________________________
DATE        : 4 May 2003
COPYRIGHT   : (C) 2003 by theKompany.com
AUTHOR      : Eugen Constantinescu <eug@thekompany.com>
AUTHOR      : Iulian Ghiciuc (ilie@eco-spaces.com.ro)
BUGS        : none that i know of :)
DESCRIPTION : the ProcessView class will be used in the CrmUIService class. These
              widgets will be the TOP_VIEW widgets in the aethera application
______________________________________________________________________________
*/

#ifndef NOTE_PREVIEW_H
#define NOTE_PREVIEW_H

//Qt includes
#include <qframe.h>
#include <qlabel.h>
#include <qpoint.h>

//others
#include <ebutton.h>
#include <noteedit.h>

class NotePreview : public QFrame
{
  Q_OBJECT

  public:
    NotePreview( QWidget* parent=0, const char* name=0 );
    ~NotePreview();

  public slots:
    void setTitle();
    void slotSetBackground( const QColor& );
    void slotSetTextColor( const QColor& );
    void slotSetFont( const QFont& );

  protected:
    virtual QSize minimumSizeHint () const;
    
  private:
    QWidget     * top;
    QLabel      * label;
    EButton     * cl_button;
    NoteEdit    * edit_box;
    bool          dragging;
    bool          resizing;
    QPoint        pointerOffset;
    QPoint        resizeOffset;
    QFrame      * hline;
    QLabel      * date_line;
    QLabel      * icon;
};

#endif

