/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.

---------------------------------------------------------------------------------
    copyright           : (C) 2003 by theKompany.com
                          (C) 2004 by Atol C&D
    author              : Eugen Constantinescu <eug@thekompany.com>
                          Fabien Armand <far@atolcd.com>
    date                : 15 Dec 2003
---------------------------------------------------------------------------------
*/

#ifndef NOTESKOLABINTERFACE_H
#define NOTESKOLABINTERFACE_H

#include <qobject.h>
#include <qstring.h>

class VFolder;

/**Kolab interface for Notes
  *@author Eugen Constantinescu <eug@thekompany.com>
  */

class NotesKolabInterface : public QObject
{
  Q_OBJECT
  
  public:
  
     virtual ~NotesKolabInterface();
     
     static NotesKolabInterface* instance();
     
     virtual QString kolabPath() const;
     
     virtual QString isKolabFolder(const QString&) const;
     virtual QString isKolabSharedFolder(const QString&) const;
     virtual QString isParentKolabSharedFolder(const QString&) const;
     
     virtual void deleteKolabSharedFolder(const QString & path) const;
     
  public slots:
  
    virtual void slotSynch(const QString&, const QString&, bool);
    virtual void slotSynchSharedFolder(const QString&);
    virtual void slotDelete(const QString&);
    virtual void slotUpdate(const QString&);
    virtual void slotAdd(const QString&);
    
  private slots:
  
    void slotClearSynch();
    
  protected:
  
    QString findMailFolder(VFolder *) const;
    QString findMailByUID(const QString&, const QString&) const;
  
  private:
  
    NotesKolabInterface();
    static NotesKolabInterface * instance_;
    
    class Private;
    Private * d;
};

#endif
