/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
//own includes
#include <vfsnotelist.h>

//komcontactplugin includes
#include <vfsnotelistview.h>
#include <vfsnoteiconview.h>
#include <vfsnotepreview.h>

/*
-------------------------------------------------
The widget
-------------------------------------------------
*/
VFSNoteList::VFSNoteList()
{
}


VFSNoteList::~VFSNoteList()
{

}

bool VFSNoteList::hasCapability(const QString& capa)
{
  if( capa==OBJECT_VIEW    ||
      capa==OBJECT_PREVIEW
    )
    return true;

  return false;
}


bool VFSNoteList::hasMultipleView()
{
  return true;
}


bool VFSNoteList::hasView(const ViewType& type)
{
  if( type==ListView || type==IconView )
    return true;

  return false;
}


VFSObjectIconView* VFSNoteList::newObjectIconView(QWidget* parent, const char* name)
{
  return new VFSNoteIconView(parent,name);
}


VFSObjectListView* VFSNoteList::newObjectView(QWidget* parent, const char* name)
{
  return new VFSNoteListView(parent,name);
}


VFSObjectPreview* VFSNoteList::newObjectPreview(QWidget* parent, const char* name)
{
  return new VFSNotePreview(parent,name);
}


/*
-------------------------------------------------
The widget factory
-------------------------------------------------
*/
kore::Interface* vfsnotelist_factory()
{
  return new VFSNoteListFactory();
}


VFSNoteListFactory::VFSNoteListFactory()
{
  MetaInfo* info = metaInfo();

  info->replaceAll("name","VFSNoteListFactory");
  info->replaceAll("class","VFSNoteListFactory");
  info->replaceAll("class/fqn","VFSNoteListFactory");
  info->replaceAll("factory","vfsnotelist_factory");
  info->replaceAll("description",AETHERA_VFS_NOTE_LIST_FACTORY_DESC);
  info->replaceAll("service", AETHERA_VFS_NOTE_LIST_FACTORY);
}


VFSNoteListFactory::~VFSNoteListFactory()
{
  
}


VFSObjectList* VFSNoteListFactory::newObjectList()
{
  VFSNoteList* noteList = new VFSNoteList();

  if( noteList )
    return noteList;

  return 0L;
}

