/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
#ifndef MAILFILTER_H
#define MAILFILTER_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <komaetheraplugin.h>

#define MAILFILTER_NAME                   "Mail Filter Plugin"
#define MAILFILTER_DESCRIPTION            "This plugin is for filtering your emails."
#define AETHERA_MAILFILTER_SERVICE        "/Aethera/Mail/Filter"
#define KORE_MAILFILTER_SERVICE           "Kore/Mail/Filter"

using namespace kore;

class QWidget;
class IndexClass;
class MessageClass;
class QString;

class MailFilterV: public KomAetheraService
{
public:
    virtual void applyFilter(IndexClass*, bool useForwardActions = true ) = 0;
    virtual QString messageFolder( const MessageClass*, const QCString& ) = 0;
    virtual void configure(QWidget *,const char*) = 0;
    virtual QStringList foldersToCopy( const MessageClass*, const QCString& )=0;
};

#endif



