/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
#ifndef MAILFILTERDIALOG_H
#define MAILFILTERDIALOG_H

#include <qptrlist.h>
#include <qvariant.h>
#include <qdialog.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QComboBox;
class QLineEdit;
class QListBox;
class QListBoxItem;
class QWidgetStack;
class QPushButton;
class QToolButton;
class KConfig;

class FilterEl {
public:
        FilterEl(QString r1f,QString r1fun,QString r1con,QString rl,
                 QString r2f,QString r2fun,QString r2con,
                 QString a1,QString a2,QString a3,QString a4,QString a5,
                 QString p1,QString p2,QString p3,QString p4,QString p5)
        : rule1field(r1f),rule1function(r1fun),rule1context(r1con),rulelogic(rl),
          rule2field(r2f),rule2function(r2fun),rule2context(r2con),
          action1(a1),action2(a2),action3(a3),action4(a4),action5(a5),
          actionparam1(p1),actionparam2(p2),actionparam3(p3),actionparam4(p4),actionparam5(p5)
        {}

public:
        int ind;
        QString rule1field;
        QString rule1function;
        QString rule1context;

        QString rulelogic;

        QString rule2field;
        QString rule2function;
        QString rule2context;

        QString action1;
        QString action2;
        QString action3;
        QString action4;
        QString action5;
        QString actionparam1;
        QString actionparam2;
        QString actionparam3;
        QString actionparam4;
        QString actionparam5;
};

class MailFilterDialog : public QDialog
{
    Q_OBJECT

public:
    MailFilterDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~MailFilterDialog();

    virtual void load();
    virtual void sync();

    void setAcCombo(QComboBox *,QComboBox *);
    QStringList getFolderList();

public slots:
    void slotNew();
    void slotDelete();
    void slotUp();
    void slotDown();
    void slotUpdate();
    void setCombo(QComboBox *box,QString text);
    void slotChanged();
    void slotAc1Changed();
    void slotAc2Changed();
    void slotAc3Changed();
    void slotAc4Changed();
    void slotAc5Changed();

public:
    int lastind;
    QPtrList<FilterEl> filterList;

    QWidgetStack *wstack1;
    QWidgetStack *wstack2;
    QWidgetStack *wstack3;
    QWidgetStack *wstack4;
    QWidgetStack *wstack5;

    QComboBox *acel1;
    QComboBox *acel2;
    QComboBox *acel3;
    QComboBox *acel4;
    QComboBox *acel5;

    QListBox* list;
/*
    QPushButton* buttonNew;
    QPushButton* buttonUp;
    QPushButton* buttonDelete;
    QPushButton* buttonDown;
*/
    QToolButton* buttonNew;
    QToolButton* buttonUp;
    QToolButton* buttonDelete;
    QToolButton* buttonDown;

    QPushButton* buttonOk;
    QPushButton* buttonCancel;
    QLineEdit* comboContext1;
    QComboBox* comboField1;
    QComboBox* comboFunction2;
    QComboBox* comboLogic;
    QLineEdit* comboContext2;
    QComboBox* comboField2;
    QComboBox* comboFunction1;
    QComboBox* comboAction5;
    QComboBox* comboAction4;
    QComboBox* comboAction3;
    QComboBox* comboAction2;
    QComboBox* comboAction1;

protected:
    QGridLayout* MailFilterDialogLayout;
    QGridLayout* leftLayout;
    QHBoxLayout* bottomLayout;
    QGridLayout* rightTopLayout;
    QGridLayout* rightBottomLayout;
private:
    QStringList longFoldersList(QString folder);
};

#endif // MAILFILTERDIALOG_H

