/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/***************************************************************************
                          SAMport.h  -  description
                             -------------------
    begin                : Mon Apr 16 2001
    copyright            : (C) 2001 by Sam "Criswell" Hart
    email                : criswell@geekcomix.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __SAMPORT_H__
#define __SAMPORT_H__
#include <iostream>
#include <fstream>
#include <string>

//namespace SAMport {
//  const int MAX_CHAR_SZ = 10000;
//}

// Abstract data struct
class SAMport_Abstract {
  public:
  
  SAMport_Abstract()
    : Num(0)
  {
  }
  
  ~SAMport_Abstract()
  {
  }

  int Num;
  std::string From;
  std::string Content_Type;
  std::string To;
  std::string Subject;
  std::string X_Mailer;
  std::string Sender;
  std::string Reply_To;
  std::string Date;
  std::string Message_Id;
  std::string In_Reply_To;
  std::string MIME_Version;
  std::string FullHeader;
  std::string FullMsg;
};

// Main SAMport superclass
class SAMport
{
  public:
    SAMport();  // Constructor
    virtual ~SAMport(); // Destructor

    virtual void load(const char *Filename);
    virtual void save(char *Filename);

    virtual SAMport_Abstract next();
    virtual SAMport_Abstract prev();
    virtual SAMport_Abstract first();
    virtual SAMport_Abstract last();
    virtual SAMport_Abstract jump(int num);
    virtual void close();
};

// Exception structures
struct SAMport_FileAlreadyOpen {
  char *msg;
  SAMport_FileAlreadyOpen(char *_msg) { msg = _msg; }
};

struct SAMport_FileOpenFailed {
  char *msg;
  SAMport_FileOpenFailed(char *_msg) { msg = _msg; }
};

struct SAMport_FileNotOpen {
  char *msg;
  SAMport_FileNotOpen(char *_msg) { msg = _msg; }
};

struct SAMport_OutOfRange {
  char *msg;
  SAMport_OutOfRange(char *_msg) { msg = _msg; }
};

struct SAMport_SourceBoxProblem {
  char *msg;
  SAMport_SourceBoxProblem(char *_msg) { msg = _msg; }
};

//sub-class includes
#include "SAMport_umbox.h"
#include "SAMport_oebox.h"

#endif // __SAMPORT_H__

