/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/***************************************************************************
        mailimportservice.cpp  -  the mail import services
                             -------------------
    begin                : Thu Aug 15 17:35:17 EEST 2001
    copyright            : (C) 2001 by Eugen C.
    email                : eug@thekompany.com
 ***************************************************************************/

#include <mailimportservice.h>
#include <mailimportsetup.h>

/*
static const char* limailimportservice_metainfo[][2]=
{
    { "/name", MAILIMPORTSERVICE_NAME },
    { "/class", "MailImportService" },
    { "/class/fqn", "MailImportService" },
    { "/description", MAILIMPORTSERVICE_SERVICE_DESC },
    { "/factory", "mailimportservice_factory" },
    { "/service", MAILIMPORTSERVICE_SERVICE },
    { 0, 0 }
};
*/

kore::Interface* mailimportservice_factory()
{
  return new MailImportService();
}
    
MailImportService::MailImportService()
{
  MetaInfo *info = metaInfo();
  
  info->replaceAll("name", MAILIMPORTSERVICE_NAME );
  info->replaceAll("class", "MailImportService");
  info->replaceAll("class/fqn", "MailImportService");
  info->replaceAll("description", MAILIMPORTSERVICE_DESCRIPTION );
  info->replaceAll("factory", "mailimportservice_factory");
  info->insert("service", MAILIMPORTSERVICE_SERVICE );
  
  mailImport=NULL;
}

MailImportService::~MailImportService()
{
  if( mailImport!=NULL )
  {
    delete mailImport;
    mailImport=NULL;
  }
}

bool MailImportService::setup()
{
  MailImportSetup mis(0, "Mail Import Setup", true);
  if (mis.exec())
  {
    if( !mis.fileName.isEmpty() )
    {
      switch( mis.type() )
      {
        case MailImportSetup::OUTLOOKEXPRESS :
          mailImport = (SAMport*)( new SAMport_oebox() );
          break;
        case MailImportSetup::MAILBOX :
        default:
          mailImport = (SAMport*)( new SAMport_umbox() );
          break;
      }
      
      // open the import file
      mailImport->load(mis.fileName.latin1());
      return true;
    }
    else
      return false;
  }
  return false;
}

void MailImportService::load(char *Filename)
{
  mailImport->load(Filename);
}

void MailImportService::save(char *Filename)
{
  mailImport->save(Filename);
}

SAMport_Abstract MailImportService::next()
{
      return mailImport->next();
}

SAMport_Abstract MailImportService::prev()
{
  return mailImport->prev();
}

SAMport_Abstract MailImportService::first()
{
  return mailImport->first();
}

SAMport_Abstract MailImportService::last()
{
  return mailImport->last();
}

SAMport_Abstract MailImportService::jump(int num)
{
  return mailImport->jump(num);
}

void MailImportService::close()
{
  // mailImport->close();
  if (mailImport != NULL) mailImport->close();
}






