/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/***************************************************************************
        mailimportservice.h  -  the mail import services
                             -------------------
    begin                : Thu Aug 15 17:35:17 EEST 2001
    copyright            : (C) 2001 by Eugen C.
    email                : eug@thekompany.com
 ***************************************************************************/

#ifndef MAILIMPORTSERVICE_H
#define MAILIMPORTSERVICE_H

#define MAILIMPORTSERVICE_NAME "Mail Import service"
#define MAILIMPORTSERVICE_DESCRIPTION "Mail Import provide setup and items access features."
#define MAILIMPORTSERVICE_SERVICE "/Aethera/Mail/Import"
#define MAILIMPORTSERVICE_SERVICE_DESCRIPTION "A service for importing the mails (Ex: Outlook and MBOX)"

#include <komaetheraplugin.h>
#include <mailimportinterface.h>

using namespace kore;

extern "C"
{
    MAILIMPORT_PLUGIN_API kore::Interface* mailimportservice_factory();
};

class MAILIMPORT_PLUGIN_API MailImportService: public MailImportInterface, public KomAetheraService
{
  public:
    MailImportService();
    virtual ~MailImportService();

    // the mail import interface
    /** Set the mail import type.*/
    virtual bool setup();
    /** Load a file for importing.*/
    virtual void load(char *Filename);
    /** Save something !?.*/
    virtual void save(char *Filename);
    /** Get the next mail.*/
    virtual SAMport_Abstract next();
    /** Get the prev mail.*/
    virtual SAMport_Abstract prev();
    /** Get the first mail.*/
    virtual SAMport_Abstract first();
    /** Get the last mail.*/
    virtual SAMport_Abstract last();
    /** Get the 'num'-th mail.*/
    virtual SAMport_Abstract jump(int num);
    /** Close the opened files.*/
    virtual void close();

  private:
    /** The mail import object.*/
    SAMport *mailImport;
};

#endif











