/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/***************************************************************************
                commandsprocessor.h  -  a smart command list
                             -------------------
    begin                : Thu Jul  5 17:35:17 EEST 2001
    copyright            : (C) 2001 by Eugen C.
    email                : eug@thekompany.com
 ***************************************************************************/

#ifndef COMMANDSPROCESSOR_H
#define COMMANDSPROCESSOR_H

#include <qptrlist.h>
#include <qdict.h>

#include <imap4client.h>

class CommandsPrivate;

class Command
{
  public:
    Command(IMAP4Client::Commands cmmtype=IMAP4Client::NO_COMMAND,
            const QString cmmAccount=QString::null,
            const QString cmmMailbox=QString::null,
            const QString cmmParameters=QString::null,
            const QString cmmOther=QString::null);
    virtual ~Command();
    
    IMAP4Client::Commands type;
     
    QString account; // IMAP
    QString mailbox; // IMAP
    QString parameters;
    QString other; // other info like Aethera server url , view type etc.
};

typedef QPtrList<Command> CommandsList;
typedef QPtrListIterator<Command> CommandsListIterator;

class CommandsProcessor
{
  public:
    CommandsProcessor(IMAP4Client * client);
    virtual ~CommandsProcessor();
    /** Insert a new command in the list.*/
    bool insert( IMAP4Client::Commands type,
                 const QString account, 
                 const QString mailbox=QString::null,
                 const QString other=QString::null,
                 const QString parameters=QString::null );
    /** Return the next command.
      * The last command will be deleted before 
      * getting the current command.
      */
    Command* pop();
    /** Return the current command from the list.*/
    Command* currentCommand();
    /** Return the first command which correspond with type.*/
    Command* find(IMAP4Client::Commands type);
    /** Check if the list is empty or not.*/
    bool isEmpty();
    /** Clear the list.*/
    void clear();

  protected:
  
    bool isRedundant(Command*);
    
  private:
    CommandsPrivate * d;
    
};

#endif








