/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/*
 * This file is part of Magellan <http://www.kAlliance.org/Magellan>
 *
 * Copyright (c) 1998-2000 Teodor Mihai <teddy@ireland.com>
 * Copyright (c) 1998-2000 Laur Ivan <laur.ivan@ul.ie>
 * Copyright (c) 1999-2000 Virgil Palanciuc <vv@ulise.cs.pub.ro>
 *
 * Requires the Qt widget libraries, available at no cost at
 * http://www.troll.no/
 *
 * Also requires the KDE libraries, available at no cost at
 * http://www.kde.org/
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */

 /** Changes: 2001-2002 Eugen C. <eug@thekompany.com>*/
 
#ifndef __CollectionManager__
#define __CollectionManager__

#include <qstring.h>
#include <qdict.h>
#include <datacollection.h>
#include <localmailfolder.h>

class CollectionManager
{
  public:
  
    enum BackendType { Unknown=0, Mail, Block, Folder, SQL };
  
    CollectionManager();
    virtual ~CollectionManager();

    // object set methods
    QString moveObject(const QString &url, const QString &dest_folder);
    QString moveCollection(const QString &src_folder, const QString &dest_folder);

    bool moveObject(const QStringList &urls, const QString & dest_folder);
    bool copyObject(const QStringList &urls, const QString & dest_folder);
    bool deleteObject(const QStringList &urls);
    
    /** The server wants a new folder.*/
    void createFolder(QString parent, QString folderPath, QString type, QString viewType);
    /** The client wants a new folder.*/
    QString createFolder(QStringList paramList);
    
    /** The server wants to delete a folder.*/
    void deleteFolder(const QString &parent, const QString &folderPath, const QString &type, const QString &viewType);
    /** Remove a folder.*/
    bool removeFolder(const QString &name);
    
    void renameFolder(const QString &account, const QString &mailbox, const QString &newName, const QString &url);
    
    void addPlugin(const QString & mimeType, QStringList systemFolders, const QString & backendType);
    
    /** Returns a reference to the required folder (except for mail folders).*/
    DataCollection *folderReference(const QString url) const;
    
    /** Returns a reference to the required mail folder.*/
    MailFolder *mailfolderReference(const QString url) const;

  private:
    
    class Private;
    Private * d;
};

#endif





