/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
#ifndef SETUP_WIZARD_H
#define SETUP_WIZARD_H

#include <qwizard.h>

class QLineEdit;
class QButtonGroup;
class QSpinBox;
class QLabel;
class QToolButton;

class POP3ConfigWidget;
class IMAP4ConfigWidget;
class SMTPConfigWidget;
class KolabFoldersBase;

class SetupWizard : public QWizard
{ 
  Q_OBJECT

  public:

    SetupWizard(QWidget * parent = 0, const char * name = 0);
    virtual ~SetupWizard();

  protected slots:

    void slotPersonalPageMaybeReady();
    void slotDirPageMaybeReady();
    void slotServerTypePageReady();
    void slotPOPPageMaybeReady();
    void slotIMAPPageMaybeReady();
    void slotKolabPageMaybeReady();
    void slotLocalPageMaybeReady();
    void slotSMTPPageMaybeReady();
    void slotChooseLocalMailboxLocation();
    void slotChooseAetheraDir();
    void slotChoosePluginDir();

  protected:

    virtual void accept();

    /**
     * Overridden to work around the problem where a newly shown page won't
     * have the focus set to its first widget.
     */
    virtual void showPage(QWidget *);

  private:

    QLineEdit       * nameLineEdit_;
    QLineEdit       * orgLineEdit_;
    QLineEdit       * addressLineEdit_;
    QLineEdit       * replyToLineEdit_;
    QLineEdit       * localMailboxLineEdit_;
    QToolButton     * localMailboxToolButton_;

    QLineEdit       * aetheraDirLineEdit_;
    QToolButton     * aetheraDirToolButton_;
    QLineEdit       * pluginDirLineEdit_;
    QToolButton     * pluginDirToolButton_;

    QButtonGroup    * serverTypeButtonGroup_;

    QLabel          * reviewLabel_;
    QLabel          * finishedLabel_;

    QWidget           * personalSetupPage_;
    QWidget           * aetheraDirSetupPage_;
    QWidget           * serverTypeSetupPage_;
    POP3ConfigWidget  * popSetupPage_;
    IMAP4ConfigWidget * imapSetupPage_;
    QWidget           * localSetupPage_;
    KolabFoldersBase  * kolabSetupPage_;
    SMTPConfigWidget  * smtpSetupPage_;
    QWidget           * reviewPage_;
    QWidget           * finishedPage_;
};

#endif // SETUP_WIZARD_H
