/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
#ifndef __UIPARTPRIVATE_H
#define __UIPARTPRIVATE_H

#include "uipart.h"
#include <qobject.h>

/*
 * UIPartPrivate - passes signals/slots around
 * Not really intendend for use outside here
 */
class TINO_API UIPartPrivate: public QObject
{ Q_OBJECT
  public:
    UIPartPrivate(UIPart *part);
    virtual ~UIPartPrivate();
    virtual bool eventFilter(QObject *watched, QEvent *e);
    /*
     * Wrapper functions to emit signals
     */
    virtual void emitActivated(void);
    virtual void emitDeactivated(void);
    virtual void emitWantUIReload(void);
    virtual void emitStatusMessage(QString& message);
    virtual void emitStatusMessage(QString& message, int ms);
  public slots:
    virtual void linkWidget(const QString&);
    virtual void unlinkWidget(const QString&);
  signals:
    /*
     * The UIPartManager will connect to these
     * Use the corresponding function in UIPart
     */
    virtual void activated(UIPart *part);
    virtual void deactivated(UIPart *part);
    virtual void wantUIReload(UIPart *part);
    virtual void statusMessage(QString& message);
    virtual void statusMessage(QString& message, int ms);
  protected:
    UIPart *owner;
};

#endif
