include(../defines.pri)

TEMPLATE  = app
CONFIG   += qt

unix {
TARGET = aethera.bin
}

win32{
TARGET = aethera
}

INCLUDEPATH += .
INCLUDEPATH += ..
DEPENDPATH  += ..
INCLUDEPATH += ../libs/
DEPENDPATH  += ../libs/
INCLUDEPATH += ../libs/htmlprocessing/
DEPENDPATH  += ../libs/htmlprocessing/
INCLUDEPATH += ../libs/server/
DEPENDPATH  += ../libs/server/
INCLUDEPATH += ../libs/mailparsers/
DEPENDPATH  += ../libs/mailparsers/
INCLUDEPATH += ../libs/aethera/
DEPENDPATH  += ../libs/aethera/
INCLUDEPATH += ../libs/tkwidgets/
DEPENDPATH  += ../libs/tkwidgets/
INCLUDEPATH += ../libs/plugins/mailfilter/
DEPENDPATH  += ../libs/plugins/mailfilter/
INCLUDEPATH += ../libs/attributes/
DEPENDPATH  += ../libs/attributes/
INCLUDEPATH += ../libs/clientskel/
DEPENDPATH  += ../libs/clientskel/
INCLUDEPATH += ../libs/transfers/
DEPENDPATH  += ../libs/transfers/
INCLUDEPATH += ../libs/kommanager/
DEPENDPATH  += ../libs/kommanager/
INCLUDEPATH += ../libs/setupwizard/
DEPENDPATH  += ../libs/setupwizard/
INCLUDEPATH += ../libs/protocols/
DEPENDPATH  += ../libs/protocols/

FORMS = generalconfigbase.ui

SOURCES   = \
  aetheraupdate.cpp \
  generalconfigprivate.cpp \
  generalconfigservice.cpp \
  generalconfigwidget.cpp \
  main.cpp 

HEADERS   = \
  aetheraupdate.h \
  generalconfigprivate.h \
  generalconfigservice.h \
  generalconfigwidget.h
  
TRANSLATIONS  = \
  src_ro.ts \
  src_fr.ts \
  src_de.ts \
  src_en.ts

win32 {
LIBS += ../libs/clientskel/clientskel.lib
LIBS += ../libs/kommanager/kommanager.lib
LIBS += ../libs/tkwidgets/tkwidgets.lib
LIBS += ../libs/server/server.lib
LIBS += ../libs/mailparsers/mailparsers.lib
LIBS += ../libs/protocols/protocols.lib
LIBS += ../libs/plugins/mailfilter/mailfilter.lib
LIBS += ../libs/setupwizard/setupwizard.lib

LIBS  += ../libs/aethera/aethera.lib ../libs/tino/tino.lib
LIBS  += tkcbase.lib tkcssl.lib libkore.lib
}

unix {
LIBS += ../libs/clientskel/libclientskel.a
LIBS += ../libs/kommanager/libkommanager.a
LIBS += ../libs/tkwidgets/libtkwidgets.a
LIBS += ../libs/server/libserver.a
LIBS += ../libs/mailparsers/libmailparsers.a
LIBS += ../libs/protocols/libprotocols.a
LIBS += ../libs/plugins/mailfilter/libmailfilter.a
LIBS += ../libs/setupwizard/libsetupwizard.a

LIBS  += -L../libs/aethera -laethera
LIBS  += -L../libs/tino -ltino
LIBS  += -L$$AETHERA_LIB -ltkcbase -ltkcssl
LIBS  += -L/usr/local/lib -lkore

# Installing...

target.path  = $$AETHERA_BIN
INSTALLS    += target

# qmake is crap - these do not work in the top dir.

data.path       = $$AETHERA_DIR/data/
data.files      = ../data/*.*
INSTALLS       += data

icons.path      = $$AETHERA_DIR/pics/
icons.files     = ../icons/*.*
INSTALLS       += icons

sound.path      = $$AETHERA_DIR/sound/
sound.files     = ../sound/*.*
INSTALLS       += sound

binaries.path   = $$AETHERA_DIR/bin/
binaries.files  = ../bin/aethera_sound ../bin/sox
INSTALLS       += binaries

start.path   = /usr/local/bin/
start.files  = ../bin/aethera
INSTALLS       += start

i18n.path      = $$AETHERA_DIR/i18n/
i18n.files     = ../i18n/*.*
INSTALLS       += i18n

help.path      = $$AETHERA_DIR/help/
help.files     = 
help.extra = \
  cp -R ../help $$AETHERA_DIR
INSTALLS       += help

aetheraincludes.path    = $$AETHERA_INCLUDE
aetheraincludes.files   = $$HEADERS
INSTALLS               += aetheraincludes

# desktop stuff

desktopfile.path = /usr/share/applications/
desktopfile.files = ../dist/aethera.desktop
INSTALLS += desktopfile

desktopicon.path = /usr/share/pixmaps/
desktopicon.files = ../dist/*.png
INSTALLS += desktopicon

desktopicon16.path = /usr/share/icons/hicolor/16x16/apps/
desktopicon16.files = ../dist/icons/16/aethera.png
INSTALLS += desktopicon16

desktopicon22.path = /usr/share/icons/hicolor/22x22/apps/
desktopicon22.files = ../dist/icons/22/aethera.png
INSTALLS += desktopicon22

desktopicon32.path = /usr/share/icons/hicolor/32x32/apps/
desktopicon32.files = ../dist/icons/32/aethera.png
INSTALLS += desktopicon32

desktopicon48.path = /usr/share/icons/hicolor/48x48/apps/
desktopicon48.files = ../dist/icons/48/aethera.png
INSTALLS += desktopicon48
}
