
#ifndef CALENDARLISTVIEW_H
#define CALENDARLISTVIEW_H

#include <qlistview.h>

#include <datahandler.h>
#include <vfsmodule.h>

/**The Calendar objects list view.
  *@author Eugen C. <eug@thekompany.com>
  */

class DATEBOOK_PLUGIN_API CalendarListView : public QListView, public DataHandler
{
  Q_OBJECT
  
  public: 
    CalendarListView(VFSModule*, QWidget * parent=0, const char * name=0);
    virtual ~CalendarListView();
  
    QDragObject * dragObject();
    
    virtual void setSortingColumn();
    
    // reimplemented/added from DataHandler
    virtual void newObject() {}
    virtual void openSelection() {}
    virtual void sendSelection() {}
    virtual void printSelection() {}
    virtual void saveSelection() {}
    virtual void editProperties() {}

    /** Return a list of URL-s.*/
    virtual QStringList getSelection();
    virtual bool isSelectionEmpty();
    virtual bool isSelectionSingle();
    virtual bool isSelectionMultiple();
    
  public slots:
    void slotCreateVInstances(const QStringList &);
    void slotUpdateVInstances(const QStringList &);
    void slotDeleteVInstances(const QStringList &);
    void slotSetFolder(const QString&);
    void slotCut();
    void slotCopy();
    void slotPaste();
    void slotDelete();
    virtual void selectAll();
    virtual void unselectAll();
    
  private slots:
    void slotSortingColumn(int, bool ascending=true);

  private:
    class Private;
    Private * d;
};

#endif
