/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

---------------------------------------------------------------------------------
    copyright           : (C) 2003 by theKompany.com
                          (C) 2004 by Atol C&D
    author              : Eugen Constantinescu <eug@thekompany.com>
                          Fabien Armand <far@atolcd.com>
    date                : 15 Dec 2003
---------------------------------------------------------------------------------
*/

#ifndef KOLABINTERFACE_H
#define KOLABINTERFACE_H

#include <qobject.h>
#include <qstring.h>

#include <libkcal/calendar.h>

class VFolder;

using namespace KCal;

/**Kolab interface for DateBook
  *@author Eugen Constantinescu <eug@thekompany.com>
  */

class KolabInterface : public QObject
{
  Q_OBJECT
  
  public:
  
    virtual ~KolabInterface();
     
    static KolabInterface* instance();
     
    virtual QString kolabPath() const;
    virtual QString isKolabCalendarObject(const QString &, bool bToDo=false) const;
    virtual QString isKolabSharedFolder(const QString&) const;
    virtual QString isParentKolabSharedFolder(const QString&) const;
    
    virtual void deleteKolabSharedFolder(const QString & path) const;
    
  public slots:
  
    virtual void slotSynch(const QString&, const QString&, bool);
    virtual void slotSynchSharedFolder(const QString&);
    virtual void slotDeleteEvent(Event *);
    virtual void slotDeleteToDo(Todo *);
    virtual void slotUpdateEvent(Event *);
    virtual void slotUpdateToDo(Todo *);
    virtual void slotAddEvent(Event *);
    virtual void slotAddToDo(Todo *);
    
  protected:
  
    QString findMailFolder(VFolder * folder) const;
    QString findMailFolder(const QString &, bool) const;
    
    // deprecated, use above methods
    QString findMailFolder(bool) const;
    
    QString findMailByUID(const QString&, const QString&, bool) const;
  
  private:
  
    KolabInterface();
    static KolabInterface * instance_;
    
    class Private;
    Private * d;
};

#endif
