
/***************************************************************************
    begin                : Fri Jan 18 21:42:04 EET 2002
    copyright            : (C) 2002 by theKompany.com
    author               : Eugen Constantinescu <eug@thekompany.com>
    author               : Iulian Ghiciuc
    author               : Bodi Vlad <bodivlad@hotmail.com>
 ***************************************************************************/

#ifndef KOM_EVENT_ALARM_SERVICE
#define KOM_EVENT_ALARM_SERVICE

//own includes
#include "komeventalarmhandler.h"

//Aethera includes
#include <komaetheraplugin.h>
#include "komeventalarmhandler.h"
#include <appstatus.h>
#include <vfsmodule.h>

//KOPlugin includes
#include <calendarobject.h>
#include <calendarlocal.h>
#include <icalformat.h>
#include <calendarlocal.h>
#include <event.h>

//QT includes
#include <qtimer.h>
#include <qptrlist.h>
#include <qvaluelist.h>

extern "C"
{
    DATEBOOK_PLUGIN_API kore::Interface* komeventalarmservice_factory();
};

class KomEventAlarmService : public KomAetheraService
{
  public:
    KomEventAlarmService();
    ~KomEventAlarmService();

    void start();
    void stop();
    void slotCheckEvents();
    void slotUseAlarm(bool);
    bool isOn();

  private:
    void checkCalendars( const QString& path );
    void playFile();
    void popupWindow();
    void statusBar();
    
    KomEventAlarmHandler* qtHandler;
    VFSModule* vfs;
    AppStatus* status;
    QTimer* timer;
    unsigned int interval;
    QValueList<KCal::Event> eventList;
};

#endif //KOM_EVENT_ALARM_SERVICE

