
#include "komkobackendservice.h"

kore::Interface* komkobackendservice_factory()
{
  return new KomKOBackendService();
}
    
KomKOBackendService::KomKOBackendService()
{
  MetaInfo *info = metaInfo();
  
  info->replaceAll("name", "Calendar Backend Service");
  info->replaceAll("class", "KomKOBackendService");
  info->replaceAll("class/fqn", "KomKOBackendService");
  info->replaceAll("description", AETHERA_CALENDAR_BACKENDSERVICE_DESC );
  info->replaceAll("factory", "komkobackendservice_factory");
  info->insert("service",  AETHERA_CALENDAR_BACKENDSERVICE );
  
  // If the default backend constructor was ok.
  if( _mimeType == VFS_MIMETYPE )
  {
    // set the type like vfs
    _mimeType = VFS_CALENDAR_MIMETYPE;
  }
}

KomKOBackendService::~KomKOBackendService()
{
}

VObjectFactory* KomKOBackendService::vobjectFactory()
{
  return dynamic_cast<VObjectFactory*> (new CalendarObjectFactory());
}

QStringList KomKOBackendService::systemFolders() const
{
  QStringList systemFolders;
  
  systemFolders.push_back( QString("sysdatebook") );
  
  return systemFolders;
}
    
QString KomKOBackendService::backendType() const
{
  return QString("filefolder");
}


