/***************************************************************************
                   komkoplugin.cpp  -  The KO plug in
                             -------------------
    begin                : Wed Jan 16 17:48:54 EET 2002
    copyright            : (C) 2002 by theKompany.com
    author               : Eugen C. <eug@thekompany.com>
 ***************************************************************************/

#include "komkoplugin.h"

#define CALENDAR_VERSION          "0.2.0"
#define CALENDAR_VERSION_MINOR    "2"
#define CALENDAR_VERSION_MAJOR    "0"
#define CALENDAR_VERSION_RELEASE  "0"

static const char* libkorganizer_metainfo[][2]=
{
    { "/kore/library", "~korganizer" },
    { "~korganizer/name", "korganizer" },
    { "~korganizer/description", "provides the KO components" },
    { "~korganizer/component", "~KomKOUIService" },
    { "~korganizer/component", "~KomKOBackendService" },
    { "~korganizer/component", "~KomEventAlarmService" },
    { "~korganizer/component", "~KOWrapperConfigService" },
    { "~korganizer/component", "~KomKOConfigService" },
    { "~korganizer/component", "~AlarmConfigService" },
    { "~korganizer/component", "~KOLanguageService" },
    { "~korganizer/component", "~KomKORMIService" },
    { "~korganizer/component", "~ExchangeService" },
//
    { "~KomKOUIService/name", "KO UI Service" },
    { "~KomKOUIService/type", "Plugin" },
    { "~KomKOUIService/class", "KomKOUIService" },
    { "~KomKOUIService/class/fqn", "KomKOUIService" },
    { "~KomKOUIService/factory", "komkouiservice_factory" },
    { "~KomKOUIService/description", AETHERA_UISERVICE_DESC },
    { "~KomKOUIService/version", CALENDAR_VERSION },
    { "~KomKOUIService/version/major", CALENDAR_VERSION_MAJOR },
    { "~KomKOUIService/version/minor", CALENDAR_VERSION_MINOR },
    { "~KomKOUIService/version/release", CALENDAR_VERSION_RELEASE },
    { "~KomKOUIService/api/version", CALENDAR_VERSION },
    { "~KomKOUIService/api/version/major", CALENDAR_VERSION_MAJOR },
    { "~KomKOUIService/api/version/minor", CALENDAR_VERSION_MINOR },
    { "~KomKOUIService/api/version/release", CALENDAR_VERSION_RELEASE },
    { "~KomKOUIService/service", "/kore/service/interface" },
    { "~KomKOUIService/service", PART_SERVICE },
    { "~KomKOUIService/service", AETHERA_SERVICE },
    { "~KomKOUIService/service", AETHERA_UISERVICE },
    { "~KomKOUIService/service", AETHERA_CALENDAR_UISERVICE },    
//
    { "~KomKOBackendService/name", "Calendar Backend Service" },
    { "~KomKOBackendService/type", "Plugin" },
    { "~KomKOBackendService/class", "KomKOBackendService" },
    { "~KomKOBackendService/class/fqn", "KomKOBackendService" },
    { "~KomKOBackendService/factory", "komkobackendservice_factory" },
    { "~KomKOBackendService/description",  AETHERA_CALENDAR_BACKENDSERVICE_DESC },
    { "~KomKOBackendService/version", CALENDAR_VERSION },
    { "~KomKOBackendService/version/major", CALENDAR_VERSION_MAJOR },
    { "~KomKOBackendService/version/minor", CALENDAR_VERSION_MINOR },
    { "~KomKOBackendService/version/release", CALENDAR_VERSION_RELEASE },
    { "~KomKOBackendService/api/version", CALENDAR_VERSION },
    { "~KomKOBackendService/api/version/major", CALENDAR_VERSION_MAJOR },
    { "~KomKOBackendService/api/version/minor", CALENDAR_VERSION_MINOR },
    { "~KomKOBackendService/api/version/release", CALENDAR_VERSION_RELEASE },
    { "~KomKOBackendService/service", "/kore/service/interface" },
    { "~KomKOBackendService/service", AETHERA_SERVICE },
    { "~KomKOBackendService/service", AETHERA_BACKENDSERVICE },
    { "~KomKOBackendService/service", AETHERA_CALENDAR_BACKENDSERVICE },
//
    { "~KomEventAlarmService/name", "Alarm Demon" },
    { "~KomEventAlarmService/type", "Plugin" },
    { "~KomEventAlarmService/class", "KomEventAlarmService" },
    { "~KomEventAlarmService/class/fqn", "KomEventAlarmService" },
    { "~KomEventAlarmService/factory", "komeventalarmservice_factory" },
    { "~KomEventAlarmService/description", AETHERA_EVENT_ALARM_SERVICE_DESC },
    { "~KomEventAlarmService/version", CALENDAR_VERSION },
    { "~KomEventAlarmService/version/major", CALENDAR_VERSION_MAJOR },
    { "~KomEventAlarmService/version/minor", CALENDAR_VERSION_MINOR },
    { "~KomEventAlarmService/version/release", CALENDAR_VERSION_RELEASE },
    { "~KomEventAlarmService/api/version", CALENDAR_VERSION },
    { "~KomEventAlarmService/api/version/major", CALENDAR_VERSION_MAJOR },
    { "~KomEventAlarmService/api/version/minor", CALENDAR_VERSION_MINOR },
    { "~KomEventAlarmService/api/version/release", CALENDAR_VERSION_RELEASE },
    { "~KomEventAlarmService/service", "/kore/service/interface" },
    { "~KomEventAlarmService/service", AETHERA_SERVICE },
    { "~KomEventAlarmService/service", AETHERA_EVENT_ALARM_SERVICE },
//
    { "~KOWrapperConfigService/name", "KO Main Config Service" },
    { "~KOWrapperConfigService/type", "Plugin" },
    { "~KOWrapperConfigService/class", "KOWrapperConfigService" },
    { "~KOWrapperConfigService/class/fqn", "KOWrapperConfigService" },
    { "~KOWrapperConfigService/factory", "kowrapperconfigservice_factory" },
    { "~KOWrapperConfigService/description",  AETHERA_CONFIGSERVICE_DESC },
    { "~KOWrapperConfigService/version", "0.2.0" },
    { "~KOWrapperConfigService/version/major", "0" },
    { "~KOWrapperConfigService/version/minor", "2" },
    { "~KOWrapperConfigService/version/release", "0" },
    { "~KOWrapperConfigService/api/version", "0.2.0" },
    { "~KOWrapperConfigService/api/version/major", "0" },
    { "~KOWrapperConfigService/api/version/minor", "2" },
    { "~KOWrapperConfigService/api/version/release", "0" },
    { "~KOWrapperConfigService/service", "/kore/service/interface" },
    { "~KOWrapperConfigService/service", AETHERA_SERVICE },
    { "~KOWrapperConfigService/service", AETHERA_CONFIGSERVICE },
//
    { "~KomKOConfigService/name", "KO Config Service" },
    { "~KomKOConfigService/type", "Plugin" },
    { "~KomKOConfigService/class", "KomKOConfigService" },
    { "~KomKOConfigService/class/fqn", "KomKOConfigService" },
    { "~KomKOConfigService/factory", "komkoconfigservice_factory" },
    { "~KomKOConfigService/description",  AETHERA_CONFIGSERVICE_DESC },
    { "~KomKOConfigService/version", "0.2.0" },
    { "~KomKOConfigService/version/major", "0" },
    { "~KomKOConfigService/version/minor", "2" },
    { "~KomKOConfigService/version/release", "0" },
    { "~KomKOConfigService/api/version", "0.2.0" },
    { "~KomKOConfigService/api/version/major", "0" },
    { "~KomKOConfigService/api/version/minor", "2" },
    { "~KomKOConfigService/api/version/release", "0" },
    { "~KomKOConfigService/service", "/kore/service/interface" },
    { "~KomKOConfigService/service", AETHERA_SERVICE },
    { "~KomKOConfigService/service", AETHERA_CONFIGSERVICE },
//
    { "~AlarmConfigService/name", "Alarm Config Service" },
    { "~AlarmConfigService/type", "Plugin" },
    { "~AlarmConfigService/class", "AlarmConfigService" },
    { "~AlarmConfigService/class/fqn", "AlarmConfigService" },
    { "~AlarmConfigService/factory", "alarmconfigservice_factory" },
    { "~AlarmConfigService/description",  AETHERA_CONFIGSERVICE_DESC },
    { "~AlarmConfigService/version", "0.2.0" },
    { "~AlarmConfigService/version/major", "0" },
    { "~AlarmConfigService/version/minor", "2" },
    { "~AlarmConfigService/version/release", "0" },
    { "~AlarmConfigService/api/version", "0.2.0" },
    { "~AlarmConfigService/api/version/major", "0" },
    { "~AlarmConfigService/api/version/minor", "2" },
    { "~AlarmConfigService/api/version/release", "0" },
    { "~AlarmConfigService/service", "/kore/service/interface" },
    { "~AlarmConfigService/service", AETHERA_SERVICE },
    { "~AlarmConfigService/service", AETHERA_CONFIGSERVICE },
//
    { "~KOLanguageService/name", "KO Language Service" },
    { "~KOLanguageService/type", "Plugin" },
    { "~KOLanguageService/class", "KOLanguageService" },
    { "~KOLanguageService/class/fqn", "KOLanguageService" },
    { "~KOLanguageService/factory", "kolanguageservice_factory" },
    { "~KOLanguageService/description",  AETHERA_LANGUAGESERVICE_DESC },
    { "~KOLanguageService/version", "0.2.0" },
    { "~KOLanguageService/version/major", "0" },
    { "~KOLanguageService/version/minor", "2" },
    { "~KOLanguageService/version/release", "0" },
    { "~KOLanguageService/api/version", "0.2.0" },
    { "~KOLanguageService/api/version/major", "0" },
    { "~KOLanguageService/api/version/minor", "2" },
    { "~KOLanguageService/api/version/release", "0" },
    { "~KOLanguageService/service", "/kore/service/interface" },
    { "~KOLanguageService/service", AETHERA_SERVICE },
    { "~KOLanguageService/service", AETHERA_LANGUAGESERVICE },
//
    { "~KomKORMIService/name", "Calendar RMI Service" },
    { "~KomKORMIService/type", "Plugin" },
    { "~KomKORMIService/class", "KomKORMIService" },
    { "~KomKORMIService/class/fqn", "KomKORMIService" },
    { "~KomKORMIService/factory", "komkormiservice_factory" },
    { "~KomKORMIService/description", KO_RMI_SERVICE_DESC },
    { "~KomKORMIService/version", CALENDAR_VERSION },
    { "~KomKORMIService/version/major", CALENDAR_VERSION_MAJOR },
    { "~KomKORMIService/version/minor", CALENDAR_VERSION_MINOR },
    { "~KomKORMIService/version/release", CALENDAR_VERSION_RELEASE },
    { "~KomKORMIService/api/version", CALENDAR_VERSION },
    { "~KomKORMIService/api/version/major", CALENDAR_VERSION_MAJOR },
    { "~KomKORMIService/api/version/minor", CALENDAR_VERSION_MINOR },
    { "~KomKORMIService/api/version/release", CALENDAR_VERSION_RELEASE },
    { "~KomKORMIService/service", "/kore/service/interface" },
    { "~KomKORMIService/service", AETHERA_SERVICE },
    { "~KomKORMIService/service", AETHERA_RMI_SERVICE },
    { "~KomKORMIService/service", KO_RMI_SERVICE },    
//
    { "~ExchangeService/name", EXCHANGESERVICE_NAME },
    { "~ExchangeService/class", "KPimExchangeService" },
    { "~ExchangeService/class/fqn", "KPimExchangeService" },
    { "~ExchangeService/description", EXCHANGESERVICE_SERVICE_DESCRIPTION },
    { "~ExchangeService/factory", "kpimexchangeservice_factory" },
    { "~ExchangeService/service", EXCHANGESERVICE_SERVICE },
    { "~ExchangeService/type", "Plugin" },
    { "~ExchangeService/EXCHANGE_VERSION", EXCHANGE_VERSION },
    { "~ExchangeService/EXCHANGE_VERSION/major", EXCHANGE_VERSION_MAJOR },
    { "~ExchangeService/EXCHANGE_VERSION/minor", EXCHANGE_VERSION_MINOR },
    { "~ExchangeService/EXCHANGE_VERSION/release",  },
    { "~ExchangeService/api/EXCHANGE_VERSION",EXCHANGE_VERSION_RELEASE  },
    { "~ExchangeService/api/EXCHANGE_VERSION/major", EXCHANGE_VERSION_MAJOR },
    { "~ExchangeService/api/EXCHANGE_VERSION/minor",EXCHANGE_VERSION_MINOR  },
    { "~ExchangeService/api/EXCHANGE_VERSION/release", EXCHANGE_VERSION_RELEASE },
    { "~ExchangeService/service", "/kore/service/interface" },
    { "~ExchangeService/service", AETHERA_SERVICE },
    { "~ExchangeService/service", EXCHANGESERVICE_SERVICE },
    { 0, 0 }
};


// the metainfo should be generated dynamicaly but I am not ready
// see the static methods from KomAetheraService 
kore::MetaInfo* korganizer_metainfo()
{
  static kore::MetaInfo* info = 0;
  if( !info )
  {
    info = new kore::MetaInfo(libkorganizer_metainfo);
  }
  return info;
}

