#ifndef KOMKO_TREE_INTERFACE_H
#define KOMKO_TREE_INTERFACE_H

#include <aethera/komaetheraplugin.h>

class QObject;

class KomKOTreeSlots;

class DATEBOOK_PLUGIN_API KomKOTreeInterface : public KomMainTreeInterface
{
  public:

    enum ItemType
    {
      ItemTypeRoot = 0,
      ItemTypeFolder,
    };

    KomKOTreeInterface(QListView * parentTree);

    virtual ~KomKOTreeInterface();

    virtual void show();
    virtual void show(const QString&);
    virtual void hide();
    
    virtual QString path(KomTreeItem *);

    KomTreeItem * root();
    KomTreeItem * folderItem(const QString & url, bool create);

    virtual void createChildren(KomTreeItem *);

    virtual bool hasChild(KomTreeItem *);

    virtual QPopupMenu * contextMenu(KomTreeItem *);

    void updateVInstances(const QStringList &);
    void createVInstances(const QStringList &);
    void deleteVInstances(const QStringList &);
    void updateHierarchy(const QString &);

    void createVFolder
      (
        const QString & parentFolderPath,
        const QString & folderName,
        const QString & type,
        const QString & subType,
        const QString & serverPath
      );

    void deleteVFolder
      (
        const QString & parentFolderPath,
        const QString & folderName,
        const QString & type
      );

    void create(const QString &);

    virtual QObject * qObject();

    KomTreeItem * findChild(KomTreeItem * root, const QString & name);

    virtual QString name() const { return "Datebook"; }

  private:

    KomTreeItem * createFolderItem
      (KomTreeItem * parentItem, const QString & vfsPath, const QString & type);

    QPopupMenu              * m_popupMenu;
    KomKOTreeSlots          * m_slots;
    KomTreeItem             * m_currentItem;
    KomTreeItem             * m_root;
};

#endif
