#ifndef KOMKOTREEITEM_H
#define KOMKOTREEITEM_H

#include <aethera/kommaintreeitem.h>

class VFolder;
class VFolderAttribute;

/** Show the folder attributes.
  * @author Eugen C.
  */

class DATEBOOK_PLUGIN_API KomKOTreeItem : public KomTreeItem  
{
  public: 
    KomKOTreeItem( QListView * parent, KomItemType& treeItemType );
    KomKOTreeItem( KomTreeItem* parent, KomItemType& treeItemType );
    virtual ~KomKOTreeItem();
    
    /** Paint the mail folders different if there is something special.*/
    virtual void paintCell(QPainter *p, const QColorGroup &cg, int column, int width, int align);
    
    /** @return the VFS path.*/
    virtual QString path();
    
    /** just force the folder attribute to update.*/
    virtual void forceUpdate();
    
    virtual bool isKolabFolder() const;
    
  private:
    VFolder * folder;
    VFolderAttribute * folderAttribute;
    bool bUpdate;
};

#endif
