/***************************************************************************
         komkotreeslots.h  - 
                             -------------------
    begin                : Fri Jan 18 21:44:25 EET 2002
    copyright            : (C) 2002 by theKompany.com
                           (C) 2004 by Atol C&D
    author               : Eugen C. <eug@thekompany.com>
                           Fabien Armand <far@atolcd.com>
 ***************************************************************************/

#ifndef KOMKO_TREE_SLOTS_H
#define KOMKO_TREE_SLOTS_H

#include <defines.h>

#include <qobject.h>

class KomKOTreeInterface;

class DATEBOOK_PLUGIN_API KomKOTreeSlots : public QObject
{
  Q_OBJECT

  public:

    KomKOTreeSlots(KomKOTreeInterface * parent, const char * name);
    virtual ~KomKOTreeSlots();

  public slots:

    void slotCreate(const QString &);

    void slotNewObject();
    void slotDeleteObject();
    void slotNewFolder();
    void slotDeleteFolder();
    void slotMoveFolder();
    void slotRenameFolder();
    void slotExpungeFolder();
    void slotSearchForSharedFolders();
 
    void slotUpdateVInstances(const QStringList &);
    void slotCreateVInstances(const QStringList &);
    void slotDeleteVInstances(const QStringList &);
    void slotUpdateHierarchy(const QString &);

    void slotCreateVFolder
      (
        const QString & parentFolderPath,
        const QString & folderName,
        const QString & type,
        const QString & subType,
        const QString & serverPath
      );

    void slotDeleteVFolder
      (
        const QString & parentFolderPath,
        const QString & folderName,
        const QString & type
      );

  private:

    KomKOTreeInterface * m_mainTreeInterface;
};


#endif
