/***************************************************************************
         komkouiservice.cpp  -  The UI service for the KO plug in
                             -------------------
    begin                : Fri Jan 18 21:44:25 EET 2002
    copyright            : (C) 2002 by theKompany.com
    author               : Eugen C. <eug@thekompany.com>
    updated              : Bodi Vlad <bodivlad@hotmail.com>
 ***************************************************************************/

#include "komkouiservice.h"

#include "kouipartprivate.h"
#include "komkoplugin.h"
#include "komeventalarmservice.h"
#include "komkotreeinterface.h"
#include "calendarmainview.h"
#include "calendarlistview.h"
#include "help.h"
#include "kconfig.h"

// QT includes
#include <qpixmap.h>
#include <qtoolbar.h>
#include <qmenubar.h>
#include <qfiledialog.h>

#include <vfsmimetype.h>

//tkcBase includes
#include <settings.h>

// KO images
static const char* const image0_data[] = { 
"22 22 7 1",
". c None",
"# c #000000",
"b c #2e2e2e",
"c c #5c5c5c",
"d c #878787",
"e c #c2c2c2",
"a c #ffffff",
"......................",
"....##########........",
"....#aaaaaaa#b#.......",
"....#aaaaaaa#cb#......",
"....#aaaaaaa#dcb#.....",
"....#aaaaaaa#edcb#....",
"....#aaaaaaa#aedcb#...",
"....#aaaaaaa#######...",
"....#aaaaaaaaaaaaa#...",
"....#aaaaaaaaaaaaa#...",
"....#aaaaaaaaaaaaa#...",
"....#aaaaaaaaaaaaa#...",
"....#aaaaaaaaaaaaa#...",
"....#aaaaaaaaaaaaa#...",
"....#aaaaaaaaaaaaa#...",
"....#aaaaaaaaaaaaa#...",
"....#aaaaaaaaaaaaa#...",
"....#aaaaaaaaaaaaa#...",
"....#aaaaaaaaaaaaa#...",
"....###############...",
"......................",
"......................"};

static const char* const image1_data[] = { 
"22 22 5 1",
". c None",
"# c #000000",
"c c #848200",
"a c #ffff00",
"b c #ffffff",
"......................",
"......................",
"......................",
"............####....#.",
"...........#....##.##.",
"..................###.",
".................####.",
".####...........#####.",
"#abab##########.......",
"#babababababab#.......",
"#ababababababa#.......",
"#babababababab#.......",
"#ababab###############",
"#babab##cccccccccccc##",
"#abab##cccccccccccc##.",
"#bab##cccccccccccc##..",
"#ab##cccccccccccc##...",
"#b##cccccccccccc##....",
"###cccccccccccc##.....",
"##cccccccccccc##......",
"###############.......",
"......................"};

static const char* const image2_data[] = { 
"22 22 5 1",
". c None",
"# c #000000",
"a c #848200",
"b c #c1c1c1",
"c c #cab5d1",
"......................",
".####################.",
".#aa#bbbbbbbbbbbb#bb#.",
".#aa#bbbbbbbbbbbb#bb#.",
".#aa#bbbbbbbbbcbb####.",
".#aa#bbbccbbbbbbb#aa#.",
".#aa#bbbccbbbbbbb#aa#.",
".#aa#bbbbbbbbbbbb#aa#.",
".#aa#bbbbbbbbbbbb#aa#.",
".#aa#bbbbbbbbbbbb#aa#.",
".#aa#bbbbbbbbbbbb#aa#.",
".#aaa############aaa#.",
".#aaaaaaaaaaaaaaaaaa#.",
".#aaaaaaaaaaaaaaaaaa#.",
".#aaa#############aa#.",
".#aaa#########bbb#aa#.",
".#aaa#########bbb#aa#.",
".#aaa#########bbb#aa#.",
".#aaa#########bbb#aa#.",
".#aaa#########bbb#aa#.",
"..##################..",
"......................"};

static const char* const image3_data[] = { 
"22 22 88 2",
"Qt c None",
".2 c #000000",
".S c #08ff08",
"#v c #100810",
".U c #101010",
"#c c #101018",
".M c #181018",
"#e c #181818",
".A c #181821",
".L c #211821",
"#l c #212121",
".z c #212129",
"#m c #292129",
"#u c #292929",
"#n c #292931",
".R c #29ff29",
"#o c #312931",
".T c #313131",
"#p c #313139",
".Z c #31ff31",
"#q c #393139",
"#t c #393939",
".y c #393942",
"#s c #423942",
".o c #424242",
"#h c #4a4a52",
".n c #5a525a",
"#r c #5a5a63",
".I c #5ace5a",
"#b c #6b636b",
".p c #6b6b6b",
".x c #6b6b73",
".Y c #6bff63",
".l c #736b73",
".t c #7b737b",
".s c #7b7384",
".0 c #7bff7b",
".r c #847b84",
".u c #847b8c",
"#g c #84848c",
".v c #8c7b94",
"#i c #8c848c",
".w c #8c8494",
"#j c #8c8c8c",
".8 c #8c8c94",
".m c #948c94",
"#k c #948c9c",
"#f c #949494",
".q c #94949c",
".J c #94c694",
"#d c #9c949c",
"#a c #9c94a5",
".k c #9c9c9c",
".N c #9c9ca5",
".H c #9ccea5",
".K c #a59ca5",
"#. c #a59cad",
".i c #a5a5a5",
".3 c #a5a5ad",
"## c #ad9cad",
".V c #ada5ad",
".d c #adadad",
".j c #adadb5",
".9 c #b5adb5",
".# c #b5b5b5",
".a c #bdbdbd",
".7 c #bdd6bd",
".c c #c6c6c6",
".5 c #cec6ce",
".b c #cecece",
".4 c #ceced6",
".F c #d6ced6",
".G c #d6cede",
".h c #d6d6d6",
".E c #d6d6de",
".Q c #d6ffd6",
".B c #ded6de",
".1 c #ded6e7",
".g c #dedede",
".D c #dedee7",
".6 c #e7dee7",
".f c #e7e7e7",
".C c #e7e7ef",
".X c #e7ffe7",
".O c #efe7ef",
".e c #efefef",
".W c #f7f7f7",
".P c #ffffff",
"QtQtQtQtQtQt.#.a.b.b.b.b.c.c.a.a.d.aQtQtQtQt",
"QtQtQtQtQtQt.a.e.f.f.f.f.f.e.e.e.g.aQtQtQtQt",
"QtQtQtQtQtQt.a.c.c.c.b.b.c.c.c.c.a.cQtQtQtQt",
"QtQtQtQtQtQt.#.a.a.a.a.#.a.a.#.#.d.aQtQtQtQt",
"QtQtQtQtQt.c.d.c.a.c.c.c.a.a.a.c.#QtQtQtQtQt",
"QtQtQtQtQt.a.a.#.a.a.a.a.a.a.c.c.#QtQtQtQtQt",
"QtQtQtQtQt.a.#.c.a.a.a.a.a.c.a.c.dQtQtQtQtQt",
"QtQtQtQtQt.c.a.a.a.a.a.a.a.a.a.a.#QtQtQtQtQt",
"QtQtQtQtQt.d.b.f.g.g.g.g.g.g.h.g.i.i.jQtQtQt",
"QtQtQt.a.k.l.#.h.b.h.b.h.b.h.g.g.m.n.o.p.#Qt",
"QtQt.a.q.r.s.t.t.t.t.t.t.t.u.v.w.x.y.z.A.o.i",
"Qt.a.k.B.C.D.B.E.E.E.E.F.G.H.I.J.K.o.L.L.M.y",
".a.N.O.P.P.P.P.P.P.P.P.P.Q.R.S.R.b.v.T.A.U.L",
".V.W.P.P.P.P.P.P.P.P.P.P.X.Y.Z.0.P.1.t.A.2.L",
".3.E.4.5.4.h.E.E.g.6.D.B.D.E.7.F.4.5.8.M.2.A",
".m.9.j.V.3#..3.K#.#..i#..K#.###a.q.8#b#c.2.L",
".m.j.j#..3.K.K.K.N.K.N.N.N.N#a#d#d.w#b#c.2#e",
"#f#.#..K.N.K.N.N.N#a.k#a#d#d#d#a.m#g#b.M.2#h",
".m.3.K.K#a.k#a#d#a.k#a#d#a#d.q.m.8#i.x#c#e.d",
"#f#g#i.w#j.w#i.8.w#i.8.8.m.8.m#k.8.w#b#e#fQt",
".#.l.z.A#l.z#m#m#m#n#o#o#p#p#q#q#p#o#p#fQtQt",
"QtQt.d#r#s#s#t#p.T.T.T#u#u.z#e#e#v.o.kQtQtQt"};

static const char* const image4_data[] = { 
"22 22 3 1",
". c None",
"# c #000084",
"a c #848284",
"......................",
"......................",
"......................",
"......................",
"......................",
"...........######a....",
"..#......##########...",
"..##...####......##a..",
"..###.###.........##..",
"..######..........##..",
"..#####...........##..",
"..######..........##..",
"..#######.........##..",
"..########.......##a..",
"...............a###...",
"...............###....",
"......................",
"......................",
"......................",
"......................",
"......................",
"......................"};

static const char* const image5_data[] = { 
"22 22 3 1",
". c None",
"a c #000084",
"# c #848284",
"......................",
"......................",
"......................",
"......................",
"......................",
"....#aaaaaa...........",
"...aaaaaaaaaa......a..",
"..#aa......aaaa...aa..",
"..aa.........aaa.aaa..",
"..aa..........aaaaaa..",
"..aa...........aaaaa..",
"..aa..........aaaaaa..",
"..aa.........aaaaaaa..",
"..#aa.......aaaaaaaa..",
"...aaa#...............",
"....aaa...............",
"......................",
"......................",
"......................",
"......................",
"......................",
"......................"};

static const char* const image6_data[] = { 
"22 22 3 1",
". c None",
"# c #000000",
"a c #000082",
"......................",
".......#.....#........",
".......#.....#........",
".......#.....#........",
".......#....##........",
".......##...#.........",
"........#...#.........",
"........##.##.........",
".........###..........",
".........###..........",
"..........#...........",
".........a#a..........",
"........aa.aaa........",
".......a.a.a..a.......",
"......a..a.a...a......",
".....a...a.a....a.....",
"....a....a.a....a.....",
"....a....a..a...a.....",
"....a....a..a..a......",
"....a...a....aa.......",
".....aaa..............",
"......................"};

static const char* const image7_data[] = { 
"22 22 6 1",
". c None",
"# c #000000",
"b c #000082",
"c c #3c3cfd",
"d c #8b8bfd",
"a c #ffffff",
"......................",
"......................",
"########..............",
"#aaaaaa##.............",
"#a####a#a#............",
"#aaaaaa#aa#...........",
"#a####a#bbbbbbbb......",
"#aaaaaa#baaaaaabb.....",
"#a#####aba####abcb....",
"#aaaaaaabaaaaaabdcb...",
"#a#####aba####abadcb..",
"#aaaaaaabaaaaaabbbbbb.",
"#a#####aba####aaaaaab.",
"#aaaaaaabaaaaaaaaaaab.",
"#a#####aba#########ab.",
"#aaaaaaabaaaaaaaaaaab.",
"########ba#########ab.",
"........baaaaaaaaaaab.",
"........ba#########ab.",
"........baaaaaaaaaaab.",
"........bbbbbbbbbbbbb.",
"......................"};

static const char* const image8_data[] = { 
"22 22 8 1",
". c None",
"# c #000000",
"e c #000084",
"c c #848200",
"b c #848284",
"d c #c6c3c6",
"a c #ffff00",
"f c #ffffff",
"......................",
".......#####..........",
"..######aaa######.....",
".######aaaaa######....",
"##bcb##a###a##bcb##...",
"#bcb#ddddddddd#bcb#...",
"#cbc#ddddddddd#cbc#...",
"#bcb###########bcb#...",
"#cbcbcbcbcbcbcbcbc#...",
"#bcbcbcbcbcbcbcbcb#...",
"#cbcbcbceeeeeeeeee#...",
"#bcbcbcbefffffffefe...",
"#cbcbcbcefeeeeefeffe..",
"#bcbcbcbefffffffefffe.",
"#cbcbcbcefeeeeefeffffe",
"#bcbcbcbefffffffeeeeee",
"#cbcbcbcefeeeeeffffffe",
"#bcbcbcbeffffffffffffe",
"#cbcbcbcefeeeeeeeeeefe",
".#######effffffffffffe",
"........eeeeeeeeeeeeee",
"......................"};

static const char* const image9_data[] = { 
"22 22 106 2",
"Qt c None",
"#N c #212121",
"#J c #292929",
"#K c #393939",
"#M c #424242",
".m c #5a5a5a",
"#r c #5a736b",
"#A c #5a9c84",
"#B c #636363",
".N c #636b6b",
"#G c #63736b",
"#v c #63ad8c",
"#H c #6b6b6b",
".c c #6b7373",
"#D c #6b7b73",
".l c #6b7b7b",
".W c #6b847b",
".t c #6b8c7b",
"#x c #6b9484",
"#w c #6bad94",
".u c #737373",
".v c #737b73",
".g c #737b7b",
".D c #738c84",
".7 c #739484",
"#d c #73948c",
"#z c #73a59c",
"#p c #73b594",
"#o c #73bd9c",
".b c #7b7b7b",
".O c #7b8484",
"#a c #7bad94",
"#q c #7bad9c",
"#i c #7bb59c",
".5 c #7bbd9c",
"#b c #7bbda5",
"#h c #7bc69c",
"#y c #7bc6a5",
".8 c #848484",
".4 c #8484b5",
".h c #849c94",
"#n c #84a5ad",
".V c #84ada5",
"#E c #84b59c",
"#F c #84b5a5",
"#j c #84bda5",
"#t c #84c6a5",
"#l c #84cead",
".E c #8c8c8c",
"#g c #8c8cbd",
"## c #8c94b5",
"#m c #8cadbd",
"#c c #8cb5a5",
".L c #8cc6ad",
".T c #8ccead",
"#f c #8cceb5",
".a c #949494",
".n c #94a59c",
"#u c #94a5ce",
".k c #94bdad",
".M c #94c6ad",
".6 c #94c6b5",
".B c #94ceb5",
".1 c #94d6b5",
".C c #94d6bd",
".9 c #94debd",
".K c #9c94d6",
".d c #9c9c9c",
".w c #9cbdb5",
"#. c #9cbdd6",
"#s c #9ccebd",
".2 c #9ccece",
".0 c #9cdebd",
".S c #9ce7bd",
".Z c #9ce7c6",
".U c #a594de",
"#L c #a5a5a5",
".A c #a5b5de",
".3 c #a5b5ef",
".I c #a5cece",
"#k c #a5dec6",
".s c #a5e7c6",
".f c #adadad",
".J c #adadef",
".R c #adb5de",
".i c #adcec6",
".P c #add6c6",
".j c #addece",
"#e c #ade7ce",
".# c #b5b5b5",
".H c #b5bdde",
".Q c #b5dede",
".r c #b5efd6",
".e c #bdbdbd",
".z c #bdc6f7",
".y c #bdd6ff",
".X c #bde7d6",
".q c #bdefde",
".Y c #bdf7de",
"#I c #c6c6c6",
".x c #c6def7",
".p c #c6f7e7",
"#C c #ced6ce",
".G c #cedeff",
".o c #ceffef",
".F c #d6fff7",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQt.#.a.b.c.c.b.d.eQtQtQtQtQtQtQtQtQtQtQt",
"QtQt.f.g.h.i.j.j.k.l.b.#QtQtQtQtQtQtQtQtQtQt",
"Qt.f.m.n.o.o.p.q.r.s.t.u.eQtQtQtQtQtQtQtQtQt",
".e.v.w.q.p.x.y.z.A.B.C.D.EQtQtQtQtQtQtQtQtQt",
".d.h.F.q.G.H.I.I.J.K.L.M.N.#QtQtQtQtQtQtQtQt",
".O.P.o.Q.R.B.S.T.A.U.V.B.W.dQtQtQtQtQtQtQtQt",
".g.X.Y.Z.Z.0.1.2.3.4.5.6.7.8QtQtQtQtQtQtQtQt",
".g.j.r.0.9.1#..3###a#b#c#d.8QtQtQtQtQtQtQtQt",
".v.P#e.1.1#f.A#g.5#h#i#j.W.EQtQtQtQtQtQtQtQt",
".E#c#k#f.L#l#m#n#o#p#p#q#r.fQtQtQtQtQtQtQtQt",
".f.g#s#t#t#b#u.4#v#w#w#x.u.eQtQtQtQtQtQtQtQt",
"Qt.E.t#y#b.5#z#d#p#A#A#B.d#C.f.eQtQtQtQtQtQt",
"Qt.e.b#D#E#F#j#i#a.7.m.dQt.f#B.m.fQtQtQtQtQt",
"QtQt.e.E.N#D.W.W#G#H.fQtQt#I.b#J#K.E.eQtQtQt",
"QtQtQtQt.#.d.E.a#L#IQtQtQtQtQt#L#M#J#H.fQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt.e.u#N#K.aQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt.d#K#N#H",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt.##B.m",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt"};


/*
static const char* homeuiservice_metainfo[][2]=
{
    { "name", "KO UI Service" },
    { "class", "KomKOUIService" },
    { "class/fqn", "KomKOUIService" },
    { "factory", "komkouiservice_factory" },
    { 0, 0 }
};
*/

kore::Interface* komkouiservice_factory()
{
  return KomKOUIService::instance();
}
    
KomKOUIService * KomKOUIService::instance_ = 0L;

KomKOUIService * KomKOUIService::instance()
{
  if( !instance_ )
  {
    instance_ = new KomKOUIService();
  }
  
  return instance_;
}

KomKOUIService::KomKOUIService()
  : calendarView(0L),
    leftWidget(0L),
    topWidget(0L),
    topBannerWidget(0L),
    treeInterface(0L),
    fileMenu(0L),
    editMenu(0L),
    viewMenu(0L),
    goMenu(0L),
    actionsMenu(0L),
    configMenu(0L),
    exchangeMenu( 0L ),
    scheduleMenu( 0L ),
    fileMenuId(-1),
    editMenuId(-1),
    viewMenuId(-1),
    goMenuId(-1),
    actionsMenuId(-1),
    configMenuId(-1),
    exchangeMenuId(-1),
    scheduleMenuId(-1),
    vfs(0L),
    bActions(false)
{
  MetaInfo *info = metaInfo();
  
  info->replaceAll("name", "KO UI Service");
  info->replaceAll("class", "KomKOUIService");
  info->replaceAll("class/fqn", "KomKOUIService");
  info->replaceAll("factory", "komkouiservice_factory");
  
  pluginIcon.setPixmap( BarIcon( KO_ACTIVE ), QIconSet::Large, QIconSet::Active, QIconSet::Off );
  pluginIcon.setPixmap( BarIcon( KO_NORMAL ), QIconSet::Large, QIconSet::Normal, QIconSet::Off );
  
  _mimeType = VFS_CALENDAR_MIMETYPE;
  
  // Set the config place
  KConfig::setAppName("Aethera/Datebook");
  
  // VFS
  ComponentTrader* trader = dynamic_cast<ComponentTrader*>(ComponentTrader::traderRef().instance());
  if( trader )
  {
    ComponentRef ref = trader->registeredComponent( AETHERA_VFS_SERVICE );
    if( ref.isValid() )
      vfs = static_cast<VFSModule*>( ref.instance() );
  }
  
  assert(0 != vfs);

  //start the alarm daemon service
  ComponentRef ref=trader->registeredComponent( AETHERA_EVENT_ALARM_SERVICE );
  alarmDemon = 0L;
  if( ref.isValid() )
    alarmDemon = static_cast<KomEventAlarmService*>( ref.instance() );

  useAlarmDemon = true;
  useAlarmDemon = Settings::instance()->readBoolEntry( "/Aethera/AlarmDemon/Enable", useAlarmDemon);
    
  if( useAlarmDemon )
    if( alarmDemon ) alarmDemon->start();
  eventAlarmHandler = new KomEventAlarmHandler( alarmDemon );
  
  //if the exchange plugin is availabile start it
  if( trader )
  {
    ComponentRef ref = trader->registeredComponent( EXCHANGESERVICE_SERVICE );
    if( ref.isValid() )
    {
      exchangeService = dynamic_cast<KPimExchangeService*>( ref.instance() );
      Q_CHECK_PTR( exchangeService );
      exchangeService->setUIService( this );
      hasExchangePlugin = true;
    }
  }
}

KomKOUIService::~KomKOUIService()
{
  if( alarmDemon )
  {
    delete alarmDemon;
    alarmDemon=0L;
  }

  if( eventAlarmHandler )
  {
    delete eventAlarmHandler;
    eventAlarmHandler=0L;
  }
  
  if( exchangeService )
  {
    delete exchangeService;
    exchangeService = 0L;
  }
}

UIPartPrivate *KomKOUIService::createQTHandler(void)
{
  return new KOUIPartPrivate(this);
}

bool KomKOUIService::hasCapability(const QString& capabilityName)
{
  if
    (
          capabilityName == TOP_WIDGET
      ||  capabilityName == BANNER_WIDGET
      ||  capabilityName == TREE_INTERFACE
      ||  capabilityName == PLUGIN_ICONSET
    )
      return true;

  return KomUserInterfaceService::hasCapability(capabilityName);
}

void KomKOUIService::createWidget(const QString& capabilityName)
{
  if( capabilityName==TOP_WIDGET )
  {
    if ( topWidget==NULL )
    {
      // Get the qt handler for the connections
      KOUIPartPrivate *partHandler = (KOUIPartPrivate*) getQTHandler();
    
      topWidget=new KomContainerWidget(0, "KOTopWidget");
      calendarView = new CalendarMainView(topWidget);
      topWidget->addChildWidget(calendarView);
      topWidget->showChild(calendarView);

      widgetDict.insert( TOP_WIDGET, topWidget);
      
      QObject::connect( partHandler, SIGNAL(updateVInstances(const QStringList&)),
                        calendarView, SLOT(slotUpdateVInstances(const QStringList&)) );
      QObject::connect( partHandler, SIGNAL(createVInstances(const QStringList&)),
                        calendarView, SLOT(slotCreateVInstances(const QStringList&)) );
      QObject::connect( partHandler, SIGNAL(deleteVInstances(const QStringList&)),
                        calendarView, SLOT(slotDeleteVInstances(const QStringList&)) );
  
    }
  }
  else if( capabilityName==BANNER_WIDGET )
  {
    if( topBannerWidget==NULL )
    {
      topBannerWidget = new KomContainerWidget( 0, "KOBannerWidget" );
      QWidget *topMainBanner = new QWidget(0);
      
      QHBoxLayout *bannerLayout = new QHBoxLayout(topMainBanner);
      QLabel *leftTopBanner= new QLabel(topMainBanner);
      leftTopBanner->setPixmap( BarIcon(KO_TOP_BANNER_LEFT) );
      QLabel *rightTopBanner= new QLabel(topMainBanner);
      rightTopBanner->setPixmap( BarIcon(KO_TOP_BANNER_RIGHT) );
      
      bannerLayout->addWidget(leftTopBanner);
      bannerLayout->addStretch();
      bannerLayout->addWidget(rightTopBanner);
      
      topBannerWidget->addChildWidget( topMainBanner );
      topBannerWidget->showChild( topMainBanner );
      
      // Add the banner widget to the plug in widgets dict.
      widgetDict.insert( BANNER_WIDGET, topBannerWidget);
    }
  }
  if( capabilityName==LEFT_WIDGET )
  {
    if ( leftWidget==NULL )
    {
      leftWidget=new KomContainerWidget(0, "KOLeftBanner");
      QLabel *leftBanner = new QLabel( leftWidget );
      
      leftWidget->addChildWidget( leftBanner );
      leftWidget->showChild( leftBanner );
      
      widgetDict.insert( LEFT_WIDGET, leftWidget);
    }
  }
}

void KomKOUIService::createActions()
{
  if( !actionDict.size() || !actionDict.find( KO_FILE_NEW ) )
  {
    // Create the common actions
//    KomUserInterfaceService::createActions();
    
    QPixmap image0( ( const char** ) image0_data );
    QPixmap image1( ( const char** ) image1_data );
//    QPixmap image2( ( const char** ) image2_data );
    QPixmap image3( ( const char** ) image3_data );
//    QPixmap image4( ( const char** ) image4_data );
//    QPixmap image5( ( const char** ) image5_data );
//    QPixmap image6( ( const char** ) image6_data );
//    QPixmap image7( ( const char** ) image7_data );
//    QPixmap image8( ( const char** ) image8_data );
    QPixmap image9( ( const char** ) image9_data );
    
    QAction *action;
    
    // Create the new ko actions
    action = new QAction( topWidget, "fileNewAction" );
    action->setIconSet( QIconLoader::instance()->iconSet( image0 ) );
    action->setText( QObject::tr( "New" ) );
    action->setMenuText( QObject::tr( "&New" ) );
    action->setAccel( QKeySequence( QObject::tr("Ctrl+N", "KO|New"))/*4194382*/ );
    actionDict.insert( KO_FILE_NEW , action);
    
    action = new QAction( topWidget, "fileSaveAction" );
    action->setIconSet( QIconLoader::instance()->iconSet( "Save.png" ) );
    action->setText( QObject::tr( "Save" ) );
    action->setMenuText( QObject::tr( "&Save" ) );
    action->setAccel( QKeySequence( QObject::tr("Ctrl+S", "KO|Save"))/*4194387*/ );
    actionDict.insert( KO_FILE_SAVE , action);
    
    action = new QAction( topWidget, KO_FILE_CUT );
//    action->setIconSet( QIconLoader::instance()->iconSet( "Cut.png" ) );
    action->setText( QObject::tr( "Cut the selected calendars." ) );
    action->setMenuText( QObject::tr( "&Cut" ) );
    actionDict.insert( KO_FILE_CUT , action);
    
    action = new QAction( topWidget, KO_FILE_COPY );
//    action->setIconSet( QIconLoader::instance()->iconSet( "Copy.png" ) );
    action->setText( QObject::tr( "Copy the selected calendars." ) );
    action->setMenuText( QObject::tr( "C&opy" ) );
    actionDict.insert( KO_FILE_COPY , action);
    
    action = new QAction( topWidget, KO_FILE_PASTE );
//    action->setIconSet( QIconLoader::instance()->iconSet( "Paste.png" ) );
    action->setText( QObject::tr( "Paste the calendars from clipboard." ) );
    action->setMenuText( QObject::tr( "P&aste" ) );
    actionDict.insert( KO_FILE_PASTE , action);
    
    action = new QAction( topWidget, KO_FILE_DELETE );
//    action->setIconSet( QIconLoader::instance()->iconSet( "Delete.png" ) );
    action->setText( QObject::tr( "Delete the selected calendars." ) );
    action->setMenuText( QObject::tr( "&Delete" ) );
    actionDict.insert( KO_FILE_DELETE , action);
    
    action = new QAction( topWidget, KO_FILE_SELECTALL );
    action->setText( QObject::tr( "Select all the calendars from the current folder." ) );
    action->setMenuText( QObject::tr( "&Select All" ) );
    actionDict.insert( KO_FILE_SELECTALL , action);
    
    action = new QAction( topWidget, KO_FILE_UNSELECTALL );
    action->setText( QObject::tr( "Disable the selection." ) );
    action->setMenuText( QObject::tr( "&Unselect All" ) );
    actionDict.insert( KO_FILE_UNSELECTALL , action);
    
    action = new QAction( topWidget, KO_FILE_IMPORT );
    action->setIconSet( QIconSet( image1 ) );
    action->setText( QObject::tr( "Import the calendar data from a file." ) );
    action->setMenuText( QObject::tr( "&Import from file" ) );
    action->setAccel( QKeySequence( QObject::tr("Ctrl+O", "KO|Open"))/*4194383*/ );
    actionDict.insert( KO_FILE_IMPORT , action);
    
    action = new QAction( topWidget, KO_FILE_EXPORT );
    action->setIconSet( QIconLoader::instance()->iconSet( "SaveAs.png" ) );
    action->setText( QObject::tr( "Export the calendar data into a file." ) );
    action->setMenuText( QObject::tr( "&Export to file" ) );
    actionDict.insert( KO_FILE_EXPORT , action);
    
    action = new QAction( topWidget, "filePrintAction" );
    action->setIconSet( QIconLoader::instance()->iconSet( image3 ) );
    action->setText( QObject::tr( "Print" ) );
    action->setMenuText( QObject::tr( "&Print..." ) );
    action->setAccel( QKeySequence( QObject::tr("Ctrl+P", "KO|Print"))/*4194384*/ );
    actionDict.insert( KO_FILE_PRINT , action);

    action = new QAction( topWidget, KO_EDIT_CUT );
    action->setIconSet( QIconLoader::instance()->iconSet( "Cut.png" ) );
    action->setText( QObject::tr( "Cut" ) );
    action->setMenuText( QObject::tr( "&Cut" ) );
    action->setAccel( QKeySequence( QObject::tr("Ctrl+X", "KO|Edit|Cut")) );
    actionDict.insert( KO_EDIT_CUT , action);
    
    action = new QAction( topWidget, KO_EDIT_COPY );
    action->setIconSet( QIconLoader::instance()->iconSet( "Copy.png" ) );
    action->setText( QObject::tr( "Copy" ) );
    action->setMenuText( QObject::tr( "C&opy" ) );
    action->setAccel( QKeySequence( QObject::tr("Ctrl+C", "KO|Edit|Copy")) );
    actionDict.insert( KO_EDIT_COPY , action);

    action = new QAction( topWidget, KO_EDIT_PASTE );
    action->setIconSet( QIconLoader::instance()->iconSet( "Paste.png" ) );
    action->setText( QObject::tr( "Paste" ) );
    action->setMenuText( QObject::tr( "P&aste" ) );
    action->setAccel( QKeySequence( QObject::tr("Ctrl+V", "KO|Edit|Paste")) );
    actionDict.insert( KO_EDIT_PASTE , action);

    action = new QAction( topWidget, KO_EDIT_DELETE );
    action->setIconSet( QIconLoader::instance()->iconSet( "Delete.png" ) );
    action->setText( QObject::tr( "Delete" ) );
    action->setMenuText( QObject::tr( "&Delete" ) );
    actionDict.insert( KO_EDIT_DELETE , action);

    action = new QAction( topWidget, "editFindAction" );
    action->setIconSet( QIconLoader::instance()->iconSet( "search.png" ) );
    action->setText( QObject::tr( "Find" ) );
    action->setMenuText( QObject::tr( "&Find..." ) );
    action->setAccel( QKeySequence( QObject::tr("Ctrl+F", "KO|Find"))/*4194374*/ );
    actionDict.insert( KO_EDIT_FIND , action);
    
    action = new QAction( topWidget, "viewWhatsNextAction" );
    action->setText( QObject::tr( "What's next?" ) );
    actionDict.insert( KO_WHATS_NEXT , action);
    
    action = new QAction( topWidget, "viewListAction" );
    action->setIconSet( QIconLoader::instance()->iconSet( VIEWLIST_NORMAL ) );
    action->setText( QObject::tr( "List" ) );
    actionDict.insert( KO_VIEW_LIST , action);
    
    action = new QAction( topWidget, "viewDayAction" );
    action->setIconSet( QIconLoader::instance()->iconSet( VIEWDAY_NORMAL ) );
    action->setText( QObject::tr( "Day" ) );
    actionDict.insert( KO_VIEW_DAY , action);
    
    action = new QAction( topWidget, "viewWorkWeekAction" );
    action->setIconSet( QIconLoader::instance()->iconSet( VIEWWORKWEEK_NORMAL ) );
    action->setText( QObject::tr( "Work Week" ) );
    actionDict.insert( KO_VIEW_WORKWEEK , action);
    
    action = new QAction( topWidget, "viewWeekAction" );
    action->setIconSet( QIconLoader::instance()->iconSet( VIEWWEEK_NORMAL ) );
    action->setText( QObject::tr( "Week" ) );
    actionDict.insert( KO_VIEW_WEEK , action);
    
    action = new QAction( topWidget, "viewMonthAction" );
    action->setIconSet( QIconLoader::instance()->iconSet( VIEWMONTH_NORMAL ) );
    action->setText( QObject::tr( "Month" ) );
    actionDict.insert( KO_VIEW_MONTH , action);
    
    action = new QAction( topWidget, "viewTodoAction" );
    action->setIconSet( QIconLoader::instance()->iconSet( VIEWTODO_NORMAL ) );
    action->setText( QObject::tr( "Todo" ) );
    actionDict.insert( KO_VIEW_TODO , action);
    
    action = new QAction( topWidget, "goPreviousAction" );
    action->setIconSet( QIconLoader::instance()->iconSet( GOBACKWARD_NORMAL ) );
    action->setText( QObject::tr( "Go Backward" ) );
    actionDict.insert( KO_GO_PREVIOUS , action);
    
    action = new QAction( topWidget, "goNextAction" );
    action->setIconSet( QIconLoader::instance()->iconSet( GOFORWARD_NORMAL ) );
    action->setText( QObject::tr( "Go Forward" ) );
    actionDict.insert( KO_GO_FORWARD , action);
    
    action = new QAction( topWidget, "goTodayAction" );
    action->setIconSet( QIconLoader::instance()->iconSet( VIEWTODAY_NORMAL ) );
    action->setText( QObject::tr( "Go Today" ) );
    actionDict.insert( KO_GO_TODAY , action);
    
    action = new QAction( topWidget, "newEventAction" );
    action->setIconSet( QIconLoader::instance()->iconSet( NEWEVENT_NORMAL ) );
    action->setText( QObject::tr( "New Event..." ) );
    actionDict.insert( KO_NEW_EVENT , action);
    
    action = new QAction( topWidget, "newTodoAction" );
    action->setIconSet( QIconLoader::instance()->iconSet( NEWTODO_NORMAL ) );
    action->setText( QObject::tr( "New Todo..." ) );
    actionDict.insert( KO_NEW_TODO , action);
    /*
    action = new QAction( topWidget, "alarmDemonAction" );
    action->setToggleAction( true );
    action->setOn( useAlarmDemon );
    action->setText( QObject::tr( "Enable event alarm..." ) );
    actionDict.insert( KO_ALARM_DEMON , action);
    */
    action = new QAction( topWidget, "outgoingDlgAction" );
    action->setText( QObject::tr( "Outgoing messages" ) );
    actionDict.insert( KO_OUTGOING_DIALOG , action);
    
    action = new QAction( topWidget, "incomingDlgAction" );
    action->setText( QObject::tr( "Incoming messages" ) );
    actionDict.insert( KO_INCOMING_DIALOG , action);
    
    action = new QAction( topWidget, "publishAction" );
    action->setText( QObject::tr( "Publish..." ) );
    actionDict.insert( KO_PUBLISH_EVENT , action);
    
    action = new QAction( topWidget, "requestAction" );
    action->setText( QObject::tr( "Request" ) );
    actionDict.insert( KO_REQUEST_EVENT , action);

    action = new QAction( topWidget, "refreshAction" );
    action->setText( QObject::tr( "Refresh" ) );
    actionDict.insert( KO_REFRESH_EVENT , action);

    action = new QAction( topWidget, "cancelAction" );
    action->setText( QObject::tr( "Cancel" ) );
    actionDict.insert( KO_CANCEL_EVENT , action);

    action = new QAction( topWidget, "replyAction" );
    action->setText( QObject::tr( "Reply" ) );
    actionDict.insert( KO_REPLY_EVENT , action);   
    
    action = new QAction( topWidget, "replyAction" );
    action->setText( QObject::tr( "Counter" ) );
    actionDict.insert( KO_COUNTER_EVENT, action ); 

    action = new QAction( topWidget, "replyAction" );
    action->setText( QObject::tr( "Publish FreeBusy Information" ) );
    actionDict.insert( KO_PUBLISH_FREEBUSY, action ); 
    
    if( hasExchangePlugin )
    {
      action = new QAction( topWidget, "exchangeDownload" );
      action->setText( QObject::tr( "Download" ) );
      actionDict.insert( EXCHANGE_DOWNLOAD , action);

      action = new QAction( topWidget, "exchangeUpload" );
      action->setText( QObject::tr( "Upload" ) );
      actionDict.insert( EXCHANGE_UPLOAD , action);

      action = new QAction( topWidget, "exchangeDelete" );
      action->setText( QObject::tr( "Delete" ) );
      actionDict.insert( EXCHANGE_DELETE , action);

      action = new QAction( topWidget, "exchangeConfigure" );
      action->setText( QObject::tr( "Configure" ) );
      actionDict.insert( EXCHANGE_CONFIGURE , action);

    }
  }
}

void KomKOUIService::connectActions()
{
  if( !bActions )
  {
    createActions();
    bActions=true;
    
    // Get the qt handler for the connections
//    KOUIPartPrivate *partHandler = (KOUIPartPrivate*) getQTHandler();
    QAction *action;
    
    action = actionDict.find( KO_FILE_NEW );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotNew()));
    
    action = actionDict.find( KO_FILE_SAVE );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotSave()));
    
    action = actionDict.find( KO_FILE_CUT );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotCut()));
    
    action = actionDict.find( KO_FILE_COPY );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotCopy()));
    
    action = actionDict.find( KO_FILE_PASTE );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotPaste()));
    
    action = actionDict.find( KO_FILE_DELETE );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotDelete()));
    
    action = actionDict.find( KO_FILE_SELECTALL );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotSelectAll()));
    
    action = actionDict.find( KO_FILE_UNSELECTALL );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotUnSelectAll()));
    
    action = actionDict.find( KO_FILE_IMPORT );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotFileImport()));
    
    action = actionDict.find( KO_FILE_EXPORT );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotFileExport()));
    
    action = actionDict.find( KO_FILE_PRINT );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotFilePrint()));
    
    action = actionDict.find( KO_EDIT_CUT );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotEditCut()));
    
    action = actionDict.find( KO_EDIT_COPY );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotEditCopy()));
    
    action = actionDict.find( KO_EDIT_PASTE );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotEditPaste()));
    
    action = actionDict.find( KO_EDIT_DELETE );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotEditDelete()));
    
    action = actionDict.find( KO_EDIT_FIND );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotEditFind()));
      
    action = actionDict.find( KO_VIEW_TODO );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotViewTodo()));
    
    action = actionDict.find( KO_VIEW_MONTH );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotViewMonth()));
    
    action = actionDict.find( KO_VIEW_WEEK );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotViewWeek()));
    
    action = actionDict.find( KO_VIEW_WORKWEEK );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotViewWorkWeek()));
    
    action = actionDict.find( KO_VIEW_DAY );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotViewDay()));
    
    action = actionDict.find( KO_VIEW_LIST );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotViewList()));
    
    action = actionDict.find( KO_WHATS_NEXT );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotViewWhatsNext()));
    
    action = actionDict.find( KO_GO_TODAY );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotGoToday()));
    
    action = actionDict.find( KO_GO_FORWARD );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotGoNext()));
    
    action = actionDict.find( KO_GO_PREVIOUS );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotGoPrevious()));
    
    action = actionDict.find( KO_NEW_TODO );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotNewTodo()));
    
    action = actionDict.find( KO_NEW_EVENT );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotNewEvent()));
    /*
    action = actionDict.find( KO_ALARM_DEMON );
    if( action )
      QObject::connect( action, SIGNAL( toggled(bool) ), eventAlarmHandler, SLOT( slotUseAlarm(bool) ) );
    */  
    action = actionDict.find( KO_OUTGOING_DIALOG );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(showOutgoingDialog()));
      
    action = actionDict.find( KO_INCOMING_DIALOG );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(showIncomingDialog()));
    
    action = actionDict.find( KO_PUBLISH_EVENT );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(schedule_publish()));
    
    action = actionDict.find( KO_REQUEST_EVENT );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(schedule_request()));
    
    action = actionDict.find( KO_REFRESH_EVENT );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(schedule_refresh()));
    
    action = actionDict.find( KO_CANCEL_EVENT );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(schedule_cancel()));
      
    action = actionDict.find( KO_REPLY_EVENT );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(schedule_reply()));
    
    action = actionDict.find( KO_COUNTER_EVENT );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(schedule_counter()));
    
    action = actionDict.find( KO_PUBLISH_FREEBUSY );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(schedule_publish_freebusy()));
      
    if( hasExchangePlugin )
    {
      action = actionDict.find( EXCHANGE_DOWNLOAD );
      if( action )
        QObject::connect( action, SIGNAL(activated()), exchangeService->qtHandler(), SLOT(slotDownload()) );

      action = actionDict.find( EXCHANGE_UPLOAD );
      if( action )
        QObject::connect( action, SIGNAL(activated()), exchangeService->qtHandler(), SLOT(slotUpload()) );

      action = actionDict.find( EXCHANGE_DELETE );
      if( action )
        QObject::connect( action, SIGNAL(activated()), exchangeService->qtHandler(), SLOT(slotDelete()) );

      action = actionDict.find( EXCHANGE_CONFIGURE );
      if( action )
        QObject::connect( action, SIGNAL(activated()), exchangeService->qtHandler(), SLOT(slotConfigure()) );

    }
  }
}

void KomKOUIService::disconnectActions()
{
  if( bActions )
  {
    bActions=false;
    
    // Get the qt handler for the connections
//    KOUIPartPrivate *partHandler = (KOUIPartPrivate*) getQTHandler();
    QAction *action;
    
    action = actionDict.find( KO_FILE_NEW );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotNew()));
    
    action = actionDict.find( KO_FILE_SAVE );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotSave()));
    
    action = actionDict.find( KO_FILE_CUT );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotCut()));
    
    action = actionDict.find( KO_FILE_COPY );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotCopy()));
    
    action = actionDict.find( KO_FILE_PASTE );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotPaste()));
    
    action = actionDict.find( KO_FILE_DELETE );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotDelete()));
    
    action = actionDict.find( KO_FILE_SELECTALL );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotSelectAll()));
    
    action = actionDict.find( KO_FILE_UNSELECTALL );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotUnSelectAll()));
    
    action = actionDict.find( KO_FILE_IMPORT );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotFileImport()));
    
    action = actionDict.find( KO_FILE_EXPORT );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotFileExport()));
    
    action = actionDict.find( KO_FILE_PRINT );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotFilePrint()));
    
    action = actionDict.find( KO_EDIT_CUT );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotEditCut()));
    
    action = actionDict.find( KO_EDIT_COPY );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotEditCopy()));
    
    action = actionDict.find( KO_EDIT_PASTE );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotEditPaste()));
    
    action = actionDict.find( KO_EDIT_DELETE );
    if( action )
      QObject::connect( action, SIGNAL(activated()), calendarView, SLOT(slotEditDelete()));
    
    action = actionDict.find( KO_EDIT_FIND );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotEditFind()));
      
    action = actionDict.find( KO_VIEW_TODO );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotViewTodo()));
    
    action = actionDict.find( KO_VIEW_MONTH );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotViewMonth()));
    
    action = actionDict.find( KO_VIEW_WEEK );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotViewWeek()));
    
    action = actionDict.find( KO_VIEW_WORKWEEK );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotViewWorkWeek()));
    
    action = actionDict.find( KO_VIEW_DAY );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotViewDay()));
    
    action = actionDict.find( KO_VIEW_LIST );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotViewList()));
    
    action = actionDict.find( KO_WHATS_NEXT );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotViewWhatsNext()));
    
    action = actionDict.find( KO_GO_TODAY );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotGoToday()));
    
    action = actionDict.find( KO_GO_FORWARD );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotGoNext()));
    
    action = actionDict.find( KO_GO_PREVIOUS );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotGoPrevious()));
    
    action = actionDict.find( KO_NEW_TODO );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotNewTodo()));
    
    action = actionDict.find( KO_NEW_EVENT );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(slotNewEvent()));
    /*
    action = actionDict.find( KO_ALARM_DEMON  );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), eventAlarmHandler, SLOT(slotUseAlarm(bool)));
    */  
    action = actionDict.find( KO_OUTGOING_DIALOG );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(showOutgoingDialog()));
      
    action = actionDict.find( KO_INCOMING_DIALOG );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(showIncomingDialog()));
    
    action = actionDict.find( KO_PUBLISH_EVENT );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(schedule_publish()));
    
    action = actionDict.find( KO_REQUEST_EVENT );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(schedule_request()));
    
    action = actionDict.find( KO_REFRESH_EVENT );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(schedule_refresh()));
    
    action = actionDict.find( KO_CANCEL_EVENT );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(schedule_cancel()));
      
    action = actionDict.find( KO_REPLY_EVENT );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(schedule_reply()));
    
    action = actionDict.find( KO_COUNTER_EVENT );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(schedule_counter()));
    
    action = actionDict.find( KO_PUBLISH_FREEBUSY );
    if( action )
      QObject::disconnect( action, SIGNAL(activated()), calendarView, SLOT(schedule_publish_freebusy()));
      
    if( hasExchangePlugin )
    {
      action = actionDict.find( EXCHANGE_DOWNLOAD );
      if( action )
        QObject::disconnect( action, SIGNAL(activated()), exchangeService->qtHandler(), SLOT(slotDownload()) );
                                
      action = actionDict.find( EXCHANGE_UPLOAD );
      if( action )
        QObject::disconnect( action, SIGNAL(activated()), exchangeService->qtHandler(), SLOT(slotUpload()) );

      action = actionDict.find( EXCHANGE_DELETE );
      if( action )
        QObject::disconnect( action, SIGNAL(activated()), exchangeService->qtHandler(), SLOT(slotDelete()) );

      action = actionDict.find( EXCHANGE_CONFIGURE );
      if( action )
        QObject::disconnect( action, SIGNAL(activated()), exchangeService->qtHandler(), SLOT(slotConfigure()) );
    }
  }
}

void KomKOUIService::showToolbars(QMainWindow *mainWindow)
{
  connectActions();
  
  if( toolBar==NULL )
  {
    toolBar = new QToolBar(mainWindow, "KOToolBar");
    // TODO
    // Add the QToolButton-s here, with all associated QActions
    createActions();

    // Add new ko button
    QAction *action = 0;
    
    action = actionDict.find( KO_FILE_NEW );
    if( action )
      action->addTo( toolBar );
    
    action = actionDict.find( KO_FILE_SAVE );
    if( action )
      action->addTo( toolBar );
    
    toolBar->addSeparator();
    
    action = actionDict.find( KO_EDIT_CUT );
    if (0 != action)
      action->addTo( toolBar );
    
    action = actionDict.find( KO_EDIT_COPY );
    if (0 != action)
      action->addTo( toolBar );
    
    action = actionDict.find( KO_EDIT_PASTE );
    if (0 != action)
      action->addTo( toolBar );
    
    action = actionDict.find( KO_EDIT_FIND );
    if (0 != action)
      action->addTo( toolBar );
    
    toolBar->addSeparator();
    
    action = actionDict.find( KO_VIEW_LIST );
    if (0 != action)
      action->addTo( toolBar );
    
    action = actionDict.find( KO_VIEW_DAY );
    if (0 != action)
      action->addTo( toolBar );
    
    action = actionDict.find( KO_VIEW_WORKWEEK );
    if (0 != action)
      action->addTo( toolBar );
    
    action = actionDict.find( KO_VIEW_WEEK );
    if (0 != action)
      action->addTo( toolBar );
    
    action = actionDict.find( KO_VIEW_MONTH );
    if (0 != action)
      action->addTo( toolBar );
    
    action = actionDict.find( KO_VIEW_TODO );
    if (0 != action)
      action->addTo( toolBar );
    
    toolBar->addSeparator();
    
    action = actionDict.find( KO_GO_PREVIOUS );
    if (0 != action)
      action->addTo( toolBar );
    
    action = actionDict.find( KO_GO_FORWARD );
    if (0 != action)
      action->addTo( toolBar );
    
    action = actionDict.find( KO_GO_TODAY );
    if (0 != action)
      action->addTo( toolBar );
    
    toolBar->addSeparator();
    
    action = actionDict.find( KO_NEW_EVENT );
    if (0 != action)
      action->addTo( toolBar );

    action = actionDict.find( KO_NEW_TODO );
    if (0 != action)
      action->addTo( toolBar );
    
    QLabel *emptyLabel = new QLabel(toolBar);
    toolBar->setStretchableWidget(emptyLabel);
  }
  else
    toolBar->show();
}

void KomKOUIService::hideToolbars(QMainWindow *)
{
  disconnectActions();
  
  if( toolBar!=NULL )
    toolBar->hide();
}

void KomKOUIService::showMenus(QMenuBar *mainMenu)
{
  connectActions();
  
  if( mainMenu!=NULL )
  {
    // Add the QPopupMenu-s and insertItem() here, with all associated QActions
    if( NULL==fileMenu )
    {
      fileMenu = new QPopupMenu(mainMenu, "KOFileMenu");      
      editMenu = new QPopupMenu(mainMenu, "KOEditMenu"); 
      viewMenu = new QPopupMenu(mainMenu, "KOViewMenu"); 
      goMenu = new QPopupMenu(mainMenu, "KOGoMenu"); 
      actionsMenu = new QPopupMenu(mainMenu, "KOActionsMenu"); 
      configMenu = new QPopupMenu(mainMenu, "KOConfigMenu"); 
      scheduleMenu = new QPopupMenu(mainMenu, "KOScheduleMenu"); 
      exchangeMenu = new QPopupMenu( mainMenu, "KOExchangeMenu" );
    }
      
    QAction* action = 0;
    
    fileMenuId = mainMenu->insertItem(QObject::tr("&File"), fileMenu);
    
    action = actionDict.find( KO_FILE_NEW );
    if( action )
      action->addTo( fileMenu );
    action = actionDict.find( KO_FILE_SAVE );
    if( action )
      action->addTo( fileMenu );
    
    fileMenu->insertSeparator();
    
    action = actionDict.find( KO_FILE_CUT );
    if( action )
      action->addTo( fileMenu );
    
    action = actionDict.find( KO_FILE_COPY );
    if( action )
      action->addTo( fileMenu );
    
    action = actionDict.find( KO_FILE_PASTE );
    if( action )
      action->addTo( fileMenu );
    
    action = actionDict.find( KO_FILE_DELETE );
    if( action )
      action->addTo( fileMenu );
    
    action = actionDict.find( KO_FILE_SELECTALL );
    if( action )
      action->addTo( fileMenu );
    
    action = actionDict.find( KO_FILE_UNSELECTALL );
    if( action )
      action->addTo( fileMenu );
    
    fileMenu->insertSeparator();
    
    action = actionDict.find( KO_FILE_IMPORT );
    if( action )
      action->addTo( fileMenu );
    
    action = actionDict.find( KO_FILE_EXPORT );
    if( action )
      action->addTo( fileMenu );
    
    fileMenu->insertSeparator();
    
    action = actionDict.find( KO_FILE_PRINT );
    if( action )
      action->addTo( fileMenu );
    
    editMenuId = mainMenu->insertItem(QObject::tr("&Edit"), editMenu);
    
    editMenu->insertSeparator();
    action = actionDict.find( KO_EDIT_CUT );
    if( action )
      action->addTo( editMenu );
    action = actionDict.find( KO_EDIT_COPY );
    if( action )
      action->addTo( editMenu );
    action = actionDict.find( KO_EDIT_PASTE );
    if( action )
      action->addTo( editMenu );
    
    editMenu->insertSeparator();
    
    action = actionDict.find( KO_EDIT_FIND );
    if( action )
      action->addTo( editMenu );
      
    viewMenuId = mainMenu->insertItem(QObject::tr("&View"), viewMenu);
    action = actionDict.find( KO_WHATS_NEXT );
    if( action )
      action->addTo( viewMenu );
    viewMenu->insertSeparator();
    action = actionDict.find( KO_VIEW_LIST );
    if( action )
      action->addTo( viewMenu );
    action = actionDict.find( KO_VIEW_DAY );
    if( action )
      action->addTo( viewMenu );
    action = actionDict.find( KO_VIEW_WORKWEEK );
    if( action )
      action->addTo( viewMenu );
    action = actionDict.find( KO_VIEW_WEEK );
    if( action )
      action->addTo( viewMenu );
    action = actionDict.find( KO_VIEW_MONTH );
    if( action )
      action->addTo( viewMenu );
    action = actionDict.find( KO_VIEW_TODO );
    if( action )
      action->addTo( viewMenu );
    
    goMenuId = mainMenu->insertItem(QObject::tr("&Go"), goMenu);
    action = actionDict.find( KO_GO_FORWARD );
    if( action )
      action->addTo( goMenu );
    action = actionDict.find( KO_GO_PREVIOUS );
    if( action )
      action->addTo( goMenu );
    goMenu->insertSeparator();
    action = actionDict.find( KO_GO_TODAY );
    if( action )
      action->addTo( goMenu );
    
    actionsMenuId = mainMenu->insertItem(QObject::tr("&Actions"), actionsMenu);
    action = actionDict.find( KO_NEW_TODO );
    if( action )
      action->addTo( actionsMenu );
    action = actionDict.find( KO_NEW_EVENT );
    if( action )
      action->addTo( actionsMenu );
//
//    configMenuId = mainMenu->insertItem(QObject::tr("&Settings"), configMenu);
//    action = actionDict.find( KO_ALARM_DEMON );
//    if( action )
//      action->addTo( configMenu );
//      
    scheduleMenuId = mainMenu->insertItem(QObject::tr("&Schedule"), scheduleMenu);
    action = actionDict.find( KO_OUTGOING_DIALOG );
    if( action )
      action->addTo( scheduleMenu );
    
    action = actionDict.find( KO_INCOMING_DIALOG );
    if( action )
      action->addTo( scheduleMenu );
    
    scheduleMenu->insertSeparator();
    
    action = actionDict.find( KO_PUBLISH_EVENT );
    if( action )
      action->addTo( scheduleMenu );
    
    action = actionDict.find( KO_REQUEST_EVENT );
    if( action )
      action->addTo( scheduleMenu );
    
    action = actionDict.find( KO_REFRESH_EVENT );
    if( action )
      action->addTo( scheduleMenu );
    
    action = actionDict.find( KO_CANCEL_EVENT );
    if( action )
      action->addTo( scheduleMenu );

    action = actionDict.find( KO_REPLY_EVENT );
    if( action )
      action->addTo( scheduleMenu );      
    
    action = actionDict.find( KO_COUNTER_EVENT );
    if( action )
      action->addTo( scheduleMenu );      
    
    scheduleMenu->insertSeparator();
    
    action = actionDict.find( KO_PUBLISH_FREEBUSY );
    if( action )
      action->addTo( scheduleMenu );      
      
    if( hasExchangePlugin )
    {
      exchangeMenuId = mainMenu->insertItem(QObject::tr("&Exchange"), exchangeMenu);

      // I have diabled the items untill they will be tested
      // TODO: fix it
      
      action = actionDict.find( EXCHANGE_DOWNLOAD );
      if( action )
      {
        action->addTo( exchangeMenu );
        action->setEnabled(false);
      }

      action = actionDict.find( EXCHANGE_UPLOAD );
      if( action )
      {
        action->addTo( exchangeMenu );
        action->setEnabled(false);
      }

      action = actionDict.find( EXCHANGE_DELETE );
      if( action )
      {
        action->addTo( exchangeMenu );
        action->setEnabled(false);
      }

      action = actionDict.find( EXCHANGE_CONFIGURE );
      if( action )
      {
        action->addTo( exchangeMenu );
        action->setEnabled(false);
      }
    }
  }
}

void KomKOUIService::hideMenus(QMenuBar *mainMenu)
{
  disconnectActions();
  
  if( mainMenu!=NULL )
  {
    if( -1 != fileMenuId )
    {
      mainMenu->removeItem( fileMenuId );
      fileMenuId = -1;
    }
    if( fileMenu!=NULL )
      fileMenu->clear();
      
    if( -1 != editMenuId )
    {
      mainMenu->removeItem( editMenuId );
      editMenuId = -1;
    }
    if( editMenu!=NULL )
      editMenu->clear();

    if( -1 != viewMenuId )
    {
      mainMenu->removeItem( viewMenuId );
      viewMenuId = -1;
    }
    if( viewMenu!=NULL )
      viewMenu->clear();
      
    if( -1 != goMenuId )
    {
      mainMenu->removeItem( goMenuId );
      goMenuId = -1;
    }
    if( goMenu!=NULL )
      goMenu->clear();
      
    if( -1 != actionsMenuId )
    {
      mainMenu->removeItem( actionsMenuId );
      actionsMenuId = -1;
    }
    if( actionsMenu!=NULL )
      actionsMenu->clear();
      
    if( -1 != configMenuId )
    {
      mainMenu->removeItem( configMenuId );
      configMenuId = -1;
    }
    if( configMenu!=NULL )
      configMenu->clear();
    
    if( -1 != scheduleMenuId )
    {
      mainMenu->removeItem( scheduleMenuId);
      scheduleMenuId = -1;
    }
    if( scheduleMenu != NULL )
      scheduleMenu->clear();
      
    if( -1 != exchangeMenuId )
    {
      mainMenu->removeItem( exchangeMenuId );
      exchangeMenuId = -1;
    }
    if( exchangeMenu!=NULL )
      exchangeMenu->clear();
  }
  
}

  KomMainTreeInterface *
KomKOUIService::getMainTreeInterface(QListView * parentTree)
{
  if (0 == treeInterface)
  {
    treeInterface = new KomKOTreeInterface(parentTree);
  }

  return treeInterface;
}

void KomKOUIService::buildTree()
{
  if (0 == treeInterface)
  {
    qDebug("KomContactsUIService::buildTree: No treeInterface");
    return;
  }

  KOUIPartPrivate *partHandler = static_cast<KOUIPartPrivate*>( getQTHandler() );

  QObject::connect
    (
      partHandler,
      SIGNAL(create(const QString &)),
      treeInterface->qObject(),
      SLOT(slotCreate(const QString &))
    );

  QObject::connect
    (
      partHandler,
      SIGNAL(updateVInstances(const QStringList &)),
      treeInterface->qObject(),
      SLOT(slotUpdateVInstances(const QStringList &))
    );

  QObject::connect
    (
      partHandler,
      SIGNAL(createVInstances(const QStringList &)),
      treeInterface->qObject(),
      SLOT(slotCreateVInstances(const QStringList &))
    );

  QObject::connect
    (
      partHandler,
      SIGNAL(deleteVInstances(const QStringList &)),
      treeInterface->qObject(),
      SLOT(slotDeleteVInstances(const QStringList &))
    );

  QObject::connect
    (
      partHandler,
      SIGNAL(createVFolder(const QString &, const QString &, const QString &, const QString &, const QString &)),
      treeInterface->qObject(),
      SLOT(slotCreateVFolder(const QString &, const QString &, const QString &, const QString &, const QString &))
    );

  QObject::connect
    (
      partHandler,
      SIGNAL(deleteVFolder(const QString &, const QString &, const QString &)),
      treeInterface->qObject(),
      SLOT(slotDeleteVFolder(const QString &, const QString &, const QString &))
    );
    
  treeInterface->show( getCurrentFolder() );
}

  void
KomKOUIService::removeTree()
{
  if (0 == treeInterface)
  {
    qDebug("KomContactsUIService::buildTree: No treeInterface");
    return;
  }

  KOUIPartPrivate *partHandler = static_cast<KOUIPartPrivate*>( getQTHandler() );

  QObject::disconnect
    (
      partHandler,
      SIGNAL(create(const QString &)),
      treeInterface->qObject(),
      SLOT(slotCreate(const QString &))
    );

  QObject::disconnect
    (
      partHandler,
      SIGNAL(updateVInstances(const QStringList &)),
      treeInterface->qObject(),
      SLOT(slotUpdateVInstances(const QStringList &))
    );

  QObject::disconnect
    (
      partHandler,
      SIGNAL(createVInstances(const QStringList &)),
      treeInterface->qObject(),
      SLOT(slotCreateVInstances(const QStringList &))
    );

  QObject::disconnect
    (
      partHandler,
      SIGNAL(deleteVInstances(const QStringList &)),
      treeInterface->qObject(),
      SLOT(slotDeleteVInstances(const QStringList &))
    );
    
  QObject::disconnect
    (
      partHandler,
      SIGNAL(createVFolder(const QString &, const QString &, const QString &, const QString &, const QString &)),
      treeInterface->qObject(),
      SLOT(slotCreateVFolder(const QString &, const QString &, const QString &, const QString &, const QString &))
    );

  QObject::disconnect
    (
      partHandler,
      SIGNAL(deleteVFolder(const QString &, const QString &, const QString &)),
      treeInterface->qObject(),
      SLOT(slotDeleteVFolder(const QString &, const QString &, const QString &))
    );
}

QString KomKOUIService::getCurrentFolder() const
{
  if(calendarView)
  {
    return calendarView->getCurrentFolder();
  }
  
  return QString::null;
}

QString KomKOUIService::getCurrentObject() const
{
  if(calendarView)
  {
    return calendarView->getCurrentObject();
  }
  
  return QString::null;
}
    
void KomKOUIService::setCurrentURL(QString folder)
{
  if( "/Aethera/VFS/Datebook" == folder.left(21) && calendarView )
  {
    calendarView->slotSetFolder(folder);
  }
}

  QString
KomKOUIService::prettyName() const
{
  return "Datebook";
}

void KomKOUIService::execAboutDialog(QWidget*) const
{
  Help_DateBook helpAbout;
  
  helpAbout.exec();
}

