/***************************************************************************
                          popupwidget.cpp  -  description
                             -------------------
    begin                : Sat Sep 13 2003
    copyright            : (C) 2003 by thekompany
    email                : bodivlad@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


//own includes
#include "popupwidget.h"

//qt includes
#include <qtextbrowser.h>


EventViewItem::EventViewItem(QListView *parent, KCal::Event * ev)
  :QListViewItem(parent)
{
 event = dynamic_cast<KCal::Event *>(ev->clone());
 
 if(event)
 {
   setText(0, event->summary());
 }
}

EventViewItem::~EventViewItem()
{
  if(event)
  {
    delete event;
    event = 0L;
  }
}

int EventViewItem::rtti()
{
  return EventViewItem_RTTI;
}

KCal::Event * EventViewItem::getEvent()
{
  return event;
}

//PopUpWidget Definition

PopUpWidget::PopUpWidget()
{
}

PopUpWidget::PopUpWidget( QValueList<KCal::Event> & lst)
{
  connect(summaryBox, SIGNAL(clicked(QListViewItem* )),
          this, SLOT(displayDescription(QListViewItem*)));

  for( QValueListIterator<KCal::Event> it =lst.begin(); it!=lst.end(); ++it )
    EventViewItem* item = new EventViewItem(summaryBox, &(*it));
}

PopUpWidget::~PopUpWidget()
{
}


void PopUpWidget::displayDescription(QListViewItem* item)
{
  if(item && EventViewItem_RTTI == item->rtti())
  {
    EventViewItem * eventItem = static_cast<EventViewItem*>(item);
    if( eventItem )
    {
      if( eventItem->getEvent() )
      {
        descriptionBox->setText( eventItem->getEvent()->description() );
      }
    }
  }
}
