/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with the tkwidgets library (or with
    modified versions of tkwidgets that use the same license as tkwidgets),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than tkwidgets.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use tkwidgets with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
---------------------------------------------------------------------------------
  Date     : September 2003
  Author   : Ghiciuc Ilie <ilie@eco-spaces.com.ro>
  Author   : Constantinescu Eugen <eug@thekompany.com>
  Author   : Bodi Vlad <vlad@eco-spaces.com.ro>
---------------------------------------------------------------------------------
*/

//own includes
#include "wrapperconfigservice.h"

//QT includes
#include <qtextbrowser.h>

/*
----------------------------------------------------------------------------------------
WrapperConfigService factory
----------------------------------------------------------------------------------------
*/
kore::Interface* kowrapperconfigservice_factory()
{
  return new KOWrapperConfigService();
}

/*
----------------------------------------------------------------------------------------
WrapperConfigServicePrivate class
----------------------------------------------------------------------------------------
*/
class KOWrapperConfigService::KOWrapperConfigServicePrivate
{
  public:

    QTextBrowser * widget;
};

/*
----------------------------------------------------------------------------------------
WrapperConfigService class
----------------------------------------------------------------------------------------
*/
KOWrapperConfigService::KOWrapperConfigService()
  : KomConfigService()
{
  d = new KOWrapperConfigServicePrivate;
  
  MetaInfo *info = metaInfo();

  info->replaceAll("name", "KOWrapperConfigService");
  info->replaceAll("class", "KOWrapperConfigService");
  info->replaceAll("class/fqn", "KOWrapperConfigService");
  info->replaceAll("factory", "KOWrapperConfigService_factory");
  info->replaceAll("description", "Empty configuration service");

  d->widget = 0L;
}

KOWrapperConfigService::~KOWrapperConfigService()
{
  delete d->widget;
  d->widget = 0;
  
  delete d;
  d = 0L;
}

QWidget* KOWrapperConfigService::init(QWidget * parent)
{
  d->widget = new QTextBrowser( parent, "MailWrapperConfigServiceWidget" );
  QString imgFile = Dirs::locate("pics/aethera-home.png");
  QString labelText = QObject::tr( QString ( "<table><tr><td align=\"center\"><img src=\"%1\"> ").arg( imgFile ) );
  labelText += QObject::tr
               ( 
                 "<td><p>The settings dialog allows you to customize and fine tune "
                 " the way Aethera looks and behaves. Feel free to experience with the settings as you"
                 " can always click the <em>Default</em> button to revert to factory settings.</p>"
                 "<p>There are no settings associated with the item that you selected but please"
                 " try one of the following subitems:" 
                 "<ul>"
                 "<li>General: Settings for DateBook;</li>"
                 "<li>Alarm: Configure you notification;</li>"
                 "</ul>"
                 " </p></td></tr></table>"
               );
                      
  d->widget->setText(labelText );
  return d->widget;
}

void KOWrapperConfigService::load()
{
}

void KOWrapperConfigService::save()
{
}

void KOWrapperConfigService::defaults()
{
}

QPixmap KOWrapperConfigService::icon()
{
  return QIconLoader::instance()->loadIcon( "DateBook_Settings.png" );
}

QString KOWrapperConfigService::caption()
{
  return QObject::tr("DateBook");
}

bool KOWrapperConfigService::modified()
{
  return false;
}



