/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with the tkwidgets library (or with
    modified versions of tkwidgets that use the same license as tkwidgets),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than tkwidgets.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use tkwidgets with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
---------------------------------------------------------------------------------
  Date     : 05 August 2003
  Author   : Ghiciuc Ilie (ilie@eco-spaces.com.ro)
---------------------------------------------------------------------------------
*/

#ifndef KPIM_EXCHANGE_SERVICE
#define KPIM_EXCHANGE_SERVICE

#define EXCHANGESERVICE_NAME "Exchange sync service"
#define EXCHANGESERVICE_DESCRIPTION "Provides sync with an Exchange server"
#define EXCHANGESERVICE_SERVICE "/Aethera/KOrganizer/Exchange"
#define EXCHANGESERVICE_SERVICE_DESCRIPTION "A service for ExchangeServer calendar sync"

//Aethera includes
#include <komaetheraplugin.h>

//own includes
#include "kpimexchangeservicehandler.h"

//Exchange kore includes
#include <kore/exchangeclient.h>
#include <kore/exchangeaccount.h>

class KomKOUIService;

extern "C"
{
    MAILIMPORT_PLUGIN_API kore::Interface* kpimexchangeservice_factory();
};

class KPimExchangeService : public KomAetheraService
{
  public:
    KPimExchangeService( );
    
    void setUIService( KomKOUIService* ui );
    KomKOUIService* getUIService();
    
    KPimExchangeServiceHandler* qtHandler();
    
    void slotDownload();
    void slotUpload();
    void slotDelete();
    void slotConfigure();
    
    void showError( int error, const QString& moreInfo = QString::null );
    
  private:
    KomKOUIService* uiService;
    KPimExchangeServiceHandler* handler;
    KPIM::ExchangeClient* exchangeClient;
    KPIM::ExchangeAccount* exchangeAccount;
    
};

#endif

