
// These arrays are from KDE, kcharsets.cpp
// I couldn't use the original files, so I am using only the arrays

#include "kcharsets.h"

#include <qregexp.h>
#include <qtextcodec.h>

#define CHARSETS_COUNT    32

KCharSets* KCharSets::instance = 0;

static const char * const charsetsStr[CHARSETS_COUNT] = {
    "unicode",
    "iso-8859-1",
    "iso-8859-2",
    "iso-8859-3",
    "iso-8859-4",
    "iso-8859-5",
    "iso-8859-6",
    "iso-8859-7",


    "iso-8859-8",
    "iso-8859-9",
    "iso-8859-10",
    "iso-8859-11",
    "iso-8859-12",
    "iso-8859-13",
    "iso-8859-14",
    "iso-8859-15",
    "koi8r",
    "koi8u",
    "cp 1251",
    "pt 154",
    "eucjp",
    "euckr",
    "set-th-th",
    "set-gbk",
    "set-zh",
    "set-zh-tw",
    "big5",
    "tscii",
    "utf-8",
    "utf-16",
    "iso-8859-11",
    "Any"
};

static const char * const xNames[CHARSETS_COUNT] = {
    "iso10646-1",
    "iso8859-1",
    "iso8859-2",
    "iso8859-3",
    "iso8859-4",
    "iso8859-5",
    "iso8859-6",
    "iso8859-7",
    "iso8859-8",
    "iso8859-9",
    "iso8859-10",
    "iso8859-11",
    "iso8859-12",
    "iso8859-13",
    "iso8859-14",
    "iso8859-15",
    "koi8-r",
    "koi8-u",
    "microsoft-cp1251",
    "paratype-cp154",
    "jisx0208.1983-0",
    "ksc5601.1987-0",
    "tis620.2533-1",
    "gb2312.1980-0",
    "gb2312.1980-0",
    "cns11643.1986-",
    "big5-0",
    "tscii-0",
    "utf8",
    "utf16",
    "tis620-0",
    ""
};

KCharSets::KCharSets()
{
}

KCharSets::~KCharSets()
{
}

KCharSets* KCharSets::thisInstance()
{
  return instance ? instance : instance = new KCharSets();
}

QString KCharSets::fromQTCodec(const QString &qtCodec)
{
  CodecsMap::ConstIterator found = codecs.find(qtCodec);
  if( found!=codecs.end() )
    return found.data();
  
  for(int i=0; i < CHARSETS_COUNT; i++)
  {
    if( qtCodec==charsetsStr[i] )
    {
      QString codec = charsetsStr[i];
      codecs[qtCodec] = codec;
      return codec;
    }
  }

{
  for(int i=0; i < CHARSETS_COUNT-1; i++)
  {
    if( qtCodec==xNames[i] )
    {
      QString codec = charsetsStr[i];
      codecs[qtCodec]=codec;
      return codec;
    }
  }
 } 
  return qtCodec;
}
    
QString KCharSets::getDefaultCharset()
{
  QTextCodec * codec = QTextCodec::codecForLocale();
  if(codec)
  {
    return codec->mimeName();
  }
  else
  {
    return QString("us-ascii");
  }
  
//  QString mainName = QTextCodec::codecForLocale()->name();
//  
//  // remove all white spaces
//  mainName.replace(QRegExp("\\s"), "");
//  // to lower
//  mainName = mainName.lower();
//  // fix the name for codec
//  mainName = fromQTCodec(mainName);
//  
//  return mainName;
}


