#ifndef MINIKDE_KCONFIG_H
#define MINIKDE_KCONFIG_H

#include <qstring.h>
#include <qstringlist.h>
#include <qvaluelist.h>
#include <qcolor.h>
#include <qfont.h>

class KConfig
{
  public:

    KConfig();
    KConfig( const QString & );
    virtual ~KConfig();
  
    void setGroup( const QString & );
    
    QValueList<int> readIntListEntry( const QString & );
    int readNumEntry( const QString &, int def=0 );
    QString readEntry( const QString &, const QString &def=QString::null );
    QStringList readListEntry( const QString & );
    bool readBoolEntry( const QString &, bool def=false );
    QColor readColorEntry( const QString &, QColor * );
    QFont readFontEntry( const QString &, QFont * );
    
    void writeEntry( const QString &, QValueList<int> );
    void writeEntry( const QString &, int );
    void writeEntry( const QString &, const char * );
    void writeEntry( const QString &, const QString & );
    void writeEntry( const QString &, const QStringList & );
    void writeEntry( const QString &, bool );
    void writeEntry( const QString &, const QColor & );
    void writeEntry( const QString &, const QFont & );
    
    void sync();

    static void setAppName( const QString &);

  private:
    class Private;
    Private * d;

    static QString mAppName;
};

#endif
