#ifndef MINIKDE_KICONLOADER_H
#define MINIKDE_KICONLOADER_H

#include <qpixmap.h>
#include <qstring.h>

#include <qiconloader.h>

class KIcon
{
  public:
    enum Context { Any, Action, Application, Device, FileSystem, MimeType };
    enum Type { Fixed, Scalable, Threshold };
    enum MatchType { MatchExact, MatchBest };
    // if you add a group here, make sure to change the config reading in
    // KIconLoader too
    enum Group { NoGroup=-1, Desktop=0, FirstGroup=Desktop, Toolbar,
        MainToolbar, Small, Panel, LastGroup, User };
    enum StdSizes { SizeSmall=16, SizeMedium=32, SizeLarge=48 };
    enum States { DefaultState, ActiveState, DisabledState, LastState };
    enum Overlays { LockOverlay=0x100, ZipOverlay=0x200, LinkOverlay=0x400,
            HiddenOverlay=0x800, OverlayMask = ~0xff };
};

class KIconLoader
{
  public:    
    QPixmap loadIcon( const QString &name, int ); 
    void loadIcon( const QString &name,
                   KIcon::Group,
                   KIcon::StdSizes,
                   KIcon::States,
                   QString * path);
    void loadIcon( const QString &name,
                   KIcon::Group,
                   int,
                   KIcon::States,
                   QString * path);
    QString iconPath( const QString &name, int );
};


// The global functions are available via QIconLoader
//
// QPixmap BarIcon(const QString& name);
//
// QPixmap DesktopIcon(const QString& name, int);
//
// QPixmap SmallIcon(const QString& name);
//
// QPixmap SmallIconSet( const QString &name );

#endif
