#ifndef MINIKDE_KIO_DAV_JOB
#define MINIKDE_KIO_DAV_JOB

//QT includes
#include <qobject.h>
#include <qdom.h>
#include <qstring.h>
#include <qcstring.h>

//miniKde includes
#include "kurl.h"
#include "jobclasses.h"

//webdav includes
//#include <webdav.h>
class WebDav;

namespace KIO {

class DavJob : public SimpleJob
{
  Q_OBJECT
  
  public:
    DavJob();
    
    void addMetaData( const QString& key, const QString& value );
    QDomDocument& response();
    
    void propFind
      ( const KURL& url, 
        const QDomDocument& proprieties, 
        QString depth, 
        bool showProgress=true
      );

    void propPatch
      ( const KURL& url, 
        const QDomDocument& nsURI, 
        bool showProgress=true
      );

    void propSearch
      ( const KURL& url, 
        const QString& nsURI, 
        const QString& qName, 
        const QString& query, 
        bool showProgress=true
      );        

  signals:
    void response( Job* );
  
  private slots:
    void slotRequestFinished( int, bool );
  
  private:
    void init();
    QDomDocument responseDoc;
    QByteArray staticData;
    
    WebDav* webDav;
};


DavJob* davPropFind
  ( const KURL& url, 
    const QDomDocument& proprieties, 
    QString depth, 
    bool showProgress=true
  );
  
DavJob* davSearch
  ( const KURL& url, 
    const QString& nsURI, 
    const QString& qName, 
    const QString& query, 
    bool showProgress=true
  );
  
DavJob* davPropPatch
  ( const KURL& url, 
    const QDomDocument& nsURI, 
    bool showProgress=true
  );

}

#endif
