// vim:tabstop=2:shiftwidth=2:expandtab:cinoptions=(s,U1,m1

#include "kseparator.h"

KSeparator::KSeparator
(
  int           orientation,
  QWidget     * parent,
  const char  * name,
  WFlags        wFlags
)
  : QFrame(parent, name, wFlags)
{
  setFrameStyle(Sunken);
  setMidLineWidth(2);
  setFrameShape(Horizontal == orientation ? HLine : VLine);
}

  QSize
KSeparator::sizeHint() const
{
  if (frameStyle() & VLine)
    return QSize(midLineWidth() + 2, 0);
  else if (frameStyle() & VLine)
    return QSize(0, midLineWidth() + 2);
  else
    return QFrame::sizeHint();
}
