/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
#include <qprocess.h>
#include "externalbrowser.h"
#include "dirs.h"

#ifdef _QTX11_
extern char ** environ;
#endif

QString ExternalBrowser::browserPath = QString::null;

  void
ExternalBrowser::setBrowser(const QString & path)
{
  browserPath = path;
}

  bool
ExternalBrowser::launchUrl(const QUrl & qurl, QObject * parent)
{
  QString url = qurl;

  QProcess * process = new QProcess(parent);

#ifdef _QTWIN_
  // Try your settings first
  if( !browserPath.isEmpty() )
  {
    process->clearArguments();
    process->addArgument(browserPath);
    process->addArgument(url);
  
    if (process->launch(QByteArray()))
      return true;
  
    qDebug("Can't launch your browser/file manager. Trying start command next.");
  }
  
  process->clearArguments();
  process->addArgument("start.exe");
  process->addArgument(url);

  if (process->launch(QByteArray()))
    return true;

  qDebug("Can't launch default. Trying Explorer next.");

  process->clearArguments();
  process->addArgument("explorer.exe");
  process->addArgument(url);

  if (process->launch(QByteArray()))
    return true;

  qDebug("Can't launch explorer. Trying IE next.");

  // IE.
  process->clearArguments();
  process->addArgument("C:\\Program Files\\Internet Explorer\\IEXPLORE.EXE");
  process->addArgument(url);

  if (process->launch(QByteArray()))
    return true;

  process->clearArguments();
  process->addArgument("IEXPLORE.EXE");
  process->addArgument(url);

  if (process->launch(QByteArray()))
    return true;

  qDebug("Can't launch IE. Trying mozilla next.");

  // Mozilla
  process->clearArguments();
  process->addArgument("C:\\Program Files\\Mozilla\\mozilla.exe");
  process->addArgument(url);

  if (process->launch(QByteArray()))
    return true;

  process->clearArguments();
  process->addArgument("mozilla.exe");
  process->addArgument(url);

  if (process->launch(QByteArray()))
    return true;

  qDebug("Can't launch mozilla. Trying opera next.");

  // Opera
  process->clearArguments();
  process->addArgument("C:\\Program Files\\Opera7\\opera.exe");
  process->addArgument(url);

  if (process->launch(QByteArray()))
    return true;

  process->clearArguments();
  process->addArgument("opera.exe");
  process->addArgument(url);

  if (process->launch(QByteArray()))
    return true;

  qDebug("Can't launch opera.");
#endif // WIN

#ifdef _QTX11_
  // workaround for thekompany-support package

  int i=0;
  char *var;
  QStringList env;
  while ((var=environ[i]))
  {
    if ( !QString(var).startsWith("LD_LIBRARY_PATH") )
      env << QString(var);
    else
    {
      QString v(var);
      v.replace("/usr/local/thekompany/lib", "");
      v.replace("/usr/local/lib/theKompany/lib", "");
      v.replace("/usr/local/lib/theKompany/Aethera/lib", "");
      env << v;
    }
    i++;
  }

  // try your settings first
  if( !browserPath.isEmpty() )
  {
    process->clearArguments();
    process->addArgument(browserPath);
    process->addArgument(url);
  
    if (process->launch(QByteArray()))
      return true;
  
    qDebug("Can't launch your browser/file manager. Trying KDE file manager next.");
  }
  
  // Try kfmclient (KDE).
  process->clearArguments();
  process->addArgument("kfmclient");
//  process->addArgument("openURL");
  process->addArgument("exec");
  process->addArgument(url);

  if (process->launch(QByteArray(), &env))
    return true;

  qDebug("Can't launch kfmclient. Trying mozilla next.");

  process->clearArguments();
  process->addArgument("mozilla");
  process->addArgument(url);

  if (process->launch(QByteArray(), &env))
    return true;

  qDebug("Can't launch mozilla. Trying opera next.");

  process->clearArguments();
  process->addArgument("opera");
  process->addArgument(url);

  if (process->launch(QByteArray(), &env))
    return true;

  qDebug("Can't launch opera. Trying netscape next.");

  process->clearArguments();
  process->addArgument("netscape");
  process->addArgument(url);

  if (process->launch(QByteArray(), &env))
    return true;
#endif // X11

#ifdef _QTMAC_
  process->clearArguments();
  process->addArgument(Dirs::defaultAppDir() + "/bin/start.sh");
  process->addArgument(url);

  if (process->launch(QByteArray()))
    return true;
#endif // MAC

  return false;
}

