#ifndef FILE_DIALOG_H
#define FILE_DIALOG_H

#include <defines.h>

#include <qdialog.h>
#include <qpe/fileselector.h>

class FileSelector;

class FileDialog : public QDialog
{
  Q_OBJECT

  public:

    FileDialog
      (
        const QString & mimeFilter  = QString::null,
        const QString & defaultName = QString::null,
        QWidget       * parent      = 0,
        const char    * name        = 0
      );

    static DocLnk getOpenFileName
      (
        const QString & mimeFilter  = QString::null,
        const QString & defaultName = QString::null,
        QWidget       * parent      = 0,
        const char    * name        = 0
      );

    static DocLnk getSaveFileName
      (
        const QString & mimeFilter  = QString::null,
        const QString & defaultName = QString::null,
        QWidget       * parent      = 0,
        const char    * name        = 0
      );

    virtual ~FileDialog();

    virtual void setNewVisible(bool);
    virtual void setCloseVisible(bool);
    
    /** This will return the link name using the user typed text.
      * Please overload it for your case.
      */
    virtual QString name(const QString&);
    
    /** This will return the desktop link name using the user typed text.
      * Please overload it for your case.
      */
    virtual QString desktopName(const QString&);
    
    /** This will return the file name using the user typed text.
      * Please overload it for your case.
      */
    virtual QString fileName(const QString&);

    virtual const DocLnk * selected();
    virtual DocLnk selectedSave();

  public slots:

    virtual void slotFileSelected(const DocLnk &);
    virtual void slotNewSelected(const DocLnk &);
    virtual void slotCloseMe();

  protected:

    class Private;
    Private * d;
};

#endif
