/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    By PLUGINS we mean the commercial plug-ins developed by theKompany.com
    for Aethera.

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with PLUGINS (or with
    modified versions of PLUGINS that use the same license as PLUGINS),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than PLUGINS.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use PLUGINS with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
//
// C++ Interface: playsound
//
// Description: 
//
//
// Author: Eugen Constantinescu <eug@thekompany.com>
//
// Copyright: (C) 2005 theKompany.com
//
//
#ifndef PLAYSOUND_H
#define PLAYSOUND_H

#include <defines.h>

#include <qsound.h>

/**
Add more support for sound than QSound.

@author Eugen Constantinescu
*/
class TKCBASE_API PlaySound : public QSound
{
  Q_OBJECT
  
  public:
  
    PlaySound(const QString& filename, QObject* parent, const char* name);

    virtual ~PlaySound();

    static bool isAvailable();
    
    static void play(const QString& filename);
    
    static bool isPlayerAvailable(const QString& filename);
    
    static void setPlayer(const QString& filename=QString::null);
    
    static QString player();
    
    static QString locateSound(const QString & name);
    
    static void setOn(bool enable=true);
    
    static void setOff(bool disable=true);

    virtual bool isFinished() const;
    
    virtual int loops() const;
    
    virtual int loopsRemaining() const;
    
    virtual void setLoops(int);
      
  public slots:
  
    virtual void play();
    
    virtual void stop();

  private:
  
    static QString player_;
    static bool enable_;
    
    class Private;
    Private * d;
};

#endif
