//
// This file is for showing the using of tkcssl library
//

#include <qapplication.h>

#include <sslsocket.h>
#include <ssldevice.h>

#include "main.h"

Tester::Tester(bool ssl)
  : QObject()
{
  using namespace tkcSSL;

  socket_ = new SSLSocket;

  connect(socket_, SIGNAL(connected()), SLOT(slotConnected()));
  connect(socket_, SIGNAL(hostFound()), SLOT(slotHostFound()));
  connect(socket_, SIGNAL(error(int)), SLOT(slotError(int)));
  connect(socket_, SIGNAL(connectionClosed()), SLOT(slotConnectionClosed()));
  connect(socket_, SIGNAL(readyRead()), SLOT(slotReadyRead()));

  if (ssl)
  {
    // SSLDevice::SSL2, SSLDevice::SSL3, SSLDevice::SSL23 or SSLDevice::TLS

    SSLDevice * sslDevice =
      new SSLDevice(QSocketDevice::Stream, SSLDevice::SSL2);

    socket_->setSocketDevice(sslDevice, true);
    
    // DON'T forget to init the ssl device

    if (!sslDevice->initSSL())
      qDebug("initSSL error!");

    socket_->connectToHost("valentine", 995 /* SSL POP3 */);
  }
  else
  {
    socket_->connectToHost("localhost", 110 /* POP3 */);
  }
}

void Tester::slotConnected()
{
  qDebug("slotConnected");
}

void Tester::slotHostFound()
{
  qDebug("slotHostFound");
}

void Tester::slotError(int e)
{
  qDebug("slotError(%d)", e);
}

void Tester::slotConnectionClosed()
{
  qDebug("slotConnectionClosed");
}

void Tester::slotReadyRead()
{
  qDebug("slotReadyRead");
}

int main(int argc, char ** argv)
{
  QApplication app(argc, argv);
  Tester tester(2 == argc);
  return app.exec();
}

