/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

---------------------------------------------------------------------------------
  Date     : July 2003
  Author   : Constantinescu Eugen <eug@thekompany.com> 
  Author   : Bodi Vlad <vlad@eco-spaces.com.ro> 
  Author   : Ghiciuc Ilie <ilie@eco-spaces.com.ro>  
---------------------------------------------------------------------------------
*/

#ifndef WEBDAV
#define WEBDAV

#include <qglobal.h>

// Win
#ifdef Q_WS_WIN
#define _QTWIN_
#endif

// Embedded
#ifdef Q_WS_QWS
#define _QTE_
#endif

// Linux (X11)
#ifdef Q_WS_X11
#define _QTX11_
#endif

// MacOSX
#ifdef Q_WS_MACX
#define _QTMAC_
#endif

// If you want a dll
// #define WEBDAV_DLL

#ifdef Q_WS_WIN
#include <windows.h>
#ifdef WEBDAV_DLL
#ifdef WEBDAV_EXPORTS
  #define WEBDAV_API __declspec(dllexport)
#else
  #define WEBDAV_API __declspec(dllimport)
#endif
#else
  #define WEBDAV_API
#endif
#else
  #define WEBDAV_API
#endif

//own includes
#include "webdavrequestheader.h"
#include "webdavresponseheader.h"
#include "webdavparser.h"

//Qt includes
#include <qhttp.h>

class AuthModule;
class WebDavPrivate;

/**
 * \class WebDav
 * \brief WebDav class
 *
 * This class extends the QHttp class to provide WebDAV support. The functionality
 * of this class is very limited at this point but it was provided for name
 * consistensy and future extension. It's main role of this moment is to facilitate
 * authentification using the AuthModule class.
 * 

 * @see WebDavRequestHeader AuthModule
*/
class WEBDAV_API WebDav : public QHttp
{
  Q_OBJECT
  
  public:
    WebDav(QObject* parent=0L, const char* name=0L);
    virtual ~WebDav();
    
    virtual void setUseAuthorization( bool use );
    virtual bool getUseAuthorization();

    virtual void setAuthModule( AuthModule* module );    
    virtual AuthModule* getAuthModule();
    
    virtual int request( QHttpRequestHeader& header, QIODevice* data=0L, QIODevice* to=0L);
    virtual int request( QHttpRequestHeader& header, const QByteArray& data, QIODevice* to=0L);

    virtual int request( WebDavRequestHeader& header, QIODevice* data=0L, QIODevice* to=0L);
    virtual int request( WebDavRequestHeader& header, const QByteArray& data, QIODevice* to=0L);

  private:
    WebDavPrivate* d;
};

#endif

